<?php
class Anrede
{
    public $id;
    public $anrede;
    public $greeting;
    public $isCompany;

    public function __construct($id = 0)
    {
        if ((int) $id > 0) {
            $registry = Registry::getInstance();
            $db = $registry->db;
            $sql = "SELECT * FROM KUNDEN_ANREDEN WHERE Sprache = :lang AND Internet = 1 AND PK=" . (int) $id;
            $db->prepare($sql);
            $db->bindValue(':lang', Session::getLang());
            $result = $db->execute();

            if ($result !== false) {
                $dbObj = $db->fetch_assoc();
                // Wenn keine Anreden geladen werden können, standardmäßig die deutschen anzeigen
                if (empty($dbObj)) {
                    $db->bindValue(':lang', 'DE');
                    $result = $db->execute();
                    if ($result !== false) {
                        $dbObj = $db->fetch_assoc();
                    }
                }

                if (!empty($dbObj)) {
                    $this->id = $dbObj['PK'];
                    $this->anrede = $dbObj['Anrede'];
                    $this->greeting = $dbObj['Briefanrede'];
                    $this->isCompany = !empty($dbObj['Firma']) ? $dbObj['Firma'] : '';
                }
            }
        }
    }

    public function decodeFromDb($dbObj)
    {
        $this->id = $dbObj->PK;
        $this->anrede = $dbObj->Anrede;
        $this->greeting = $dbObj->Briefanrede;
        $this->isCompany = !empty($dbObj->Firma) ? $dbObj->Firma : '';
    }
} // Class Anrede
