<?php
/****
 *   Klasse für die Fahrzeuggruppenmerkmale (neue Icons-Implementierung)
 *
 *   @author K. Rybaczewski <k.rybaczewski@cx9.de>
 **/
class CarGroupCharacteristics
{
    public $uid = 0;
    public $carGroup;
    public $merkmalCustom; # Wenn ForeignKey ['bUid'] == NULL, steht hier der customized Wert drin, sonst der aus der Tabelle AUTOS_GRUPPEN_MERKMALE
    public $value;
    public $foreignKey = 0;
    public $showOnWebsite = true;
    public $merkmalDB;
    public $cssClass;

    /**
     *   Dieser Konstruktor mit Parameter befüllt das Objekt mit den Daten aus der assoziativen result row
     *   @param  (array) sql result row
     */
    public function __construct($resultRowArray)
    {
        $this->uid = (int) $resultRowArray['aUid'];
        $this->carGroup = '' . trim($resultRowArray['KFZGRUPPE']);
        $this->merkmalCustom = (!$resultRowArray['bUid'] != null and strlen(trim($resultRowArray['bUid'])) != 0 and (int) $resultRowArray['bUid'] != 0) ? trim($resultRowArray['dbMerkmal']) : trim($resultRowArray['customMerkmal']);
        $this->value = ($resultRowArray['WERT'] != null and strlen(trim($resultRowArray['WERT'])) != 0) ? trim($resultRowArray['WERT']) : null;
        $this->foreignKey = ($resultRowArray['bUid'] != null and strlen(trim($resultRowArray['bUid'])) != 0 and (int) $resultRowArray['bUid'] != 0) ? (int) $resultRowArray['bUid'] : null;
        $this->showOnWebsite = ((int) $resultRowArray['inet'] != 0) ? true : false;
        $this->merkmalDB = ($resultRowArray['bUid'] != null and strlen(trim($resultRowArray['bUid'])) != 0 and (int) $resultRowArray['bUid'] != 0) ? trim($resultRowArray['dbMerkmal']) : null;
        $this->cssClass = ($resultRowArray['bUid'] != null and strlen(trim($resultRowArray['bUid'])) != 0 and (int) $resultRowArray['bUid'] != 0) ? trim($resultRowArray['cssClass']) : null;
    }
} // class CarGroupCharacteristics.php
