<?php
class Customer
{
    public $id = 0;
    public $tmp_num = 0;
    public $is_tmp = false;
    public $anrede;
    public $greeting;
    public $firstname;
    public $lastname;
    public $email;
    public $country;
    public $street;
    public $city;
    public $zipcode;
    public $phone;
    public $name_template;
    public $payment;
    public $paymentID;
    public $kknummer;
    public $kkyear;
    public $kkmonth;
    public $drive_licens;
    public $birthday;
    public $driver_firstname;
    public $driver_lastname;
    public $password;
    public $is_inet_active;
    public $discount = 0;
    public $isCompany = false;
    public $firma = '';
    public $pass_hash = '';

    public function __construct($id = 0)
    {
        if ($id > 0) {
            $db = new DBCustomer();
            $dbObj = $db->getById($id);

            if ($dbObj != null) {
                $this->decodeFromDb($dbObj);
            }
        }
    }

    public static function getById($id)
    {
        return new self($id);
    }

    public static function getByEmail($email)
    {
        $db = new DBCustomer();
        $dbObj = $db->getInfoByEmail($email);
        return $dbObj != null ? new self($dbObj->NUMMER) : null;
    }

    public function decodeFromDb($dbObj)
    {
        $this->id = $dbObj->NUMMER;
        $this->anrede = $dbObj->Anrede;
        // TODO get from KUNDEN_ANREDEN->greetings depending on language
        // Briefanrede exkl. Name
        $DBCustomer = new DBCustomer();
        $this->greeting = $DBCustomer->getBriefanrede($dbObj->NUMMER)['computed0']; //'Sehr geehrte/r';

        $this->firstname = $dbObj->Vorname;
        $this->lastname = $dbObj->Nachname;
        $this->email = $dbObj->EMail;
        $this->country = $dbObj->LAND;
        $this->street = $dbObj->STRASSE;
        $this->city = $dbObj->ORT;
        $this->zipcode = $dbObj->PLZ;
        $this->phone = $dbObj->Telefonnummer;
        $this->payment = str_replace("/", "", preg_replace("/\d/", "", $dbObj->kknummer));
        $this->kknummer = str_replace("/", "", preg_replace("/[^0-9]/", "", $dbObj->kknummer));
        $this->kkyear = substr($dbObj->validthru, 3, 2);
        $this->kkmonth = substr($dbObj->validthru, 0, 2);
        $this->firma = ($dbObj->firma == 'J') ? $dbObj->NAME1 : "";
        $this->isCompany = ($dbObj->firma == 'J') ?true : false;
        $this->is_tmp = $dbObj->Tmp;
        $this->tmp_num = $dbObj->Tmp ? $dbObj->NUMMER : 0;
        $this->password = $dbObj->inetpasswort;
        $this->is_inet_active = $dbObj->inetzugangaktiv == 1;
        $this->discount = !empty($dbObj->Rabatt) ? $dbObj->Rabatt : 0;
        $this->pass_hash = !empty($dbObj->pass_hash) ? $dbObj->pass_hash : '';

        $this->station = $dbObj->Filiale;

        $registry = Registry::getInstance();
        $dbparams = $registry->params;
        $db_name_template = $dbparams->getValue('SBONIMA_NAME1');

        if (empty($db_name_template)) {
            $db_name_template = '$VORNAME $NACHNAME';
        }
        // TODO get from database PARAMS
        $db_name_delimiter = ' ';
        if (!empty($db_name_template) && !empty($db_name_delimiter) && !empty($this->firstname) && !empty($this->lastname)) {
            $this->name_template = str_replace(
                array('$VORNAME', '$NACHNAME'),
                array($this->firstname, $this->lastname),
                $db_name_template
            );
        } elseif (!empty($db_name_template) && !empty($db_name_delimiter)) {
            $name = ($this->isCompany ? $dbObj->NAME2 : $dbObj->NAME1);
            $this->name_template = $name;
            $first_word_template = explode($db_name_delimiter, $db_name_template);
            $first_word_template = $first_word_template[0];
            $first_value_name1 = explode($db_name_delimiter, $name);

            $count_name = count($first_value_name1);
            $first_value_name1 = $first_value_name1[0];
            if ($count_name == 1) {
                $this->lastname = $first_value_name1;
            } elseif ($first_word_template == '$VORNAME') {
                $this->firstname = $first_value_name1;
                if ($db_name_delimiter != ' ') {
                    $this->lastname = str_replace(array($first_value_name1, $db_name_delimiter), '', $name);
                } else {
                    //temporärer Bugfix falls Name mehr als aus 2 Teilen besteht - Trennung durch Leerzeichen ist aber auch nicht die beste Lösung
                    $this->lastname = str_replace($first_value_name1 . ' ', '', $name);
                }
            } else {
                $this->lastname = $first_value_name1;
                if ($db_name_delimiter != ' ') {
                    $this->firstname = str_replace(array($first_value_name1, $db_name_delimiter), '', $name);
                } else {
                    //temporärer Bugfix falls Name mehr als aus 2 Teilen besteht - Trennung durch Leerzeichen ist aber auch nicht die beste Lösung
                    $this->firstname = str_replace($first_value_name1 . ' ', '', $name);
                }
            }
        } else {
            $this->name_template = $dbObj->NAME1;
            $this->firstname = $dbObj->NAME1;
            $this->lastname = '';
        }
    }

    public function getHashPassword($password)
    {
        return getToken($password);
    } // getHashPassword()
} // Class Customer
