<?php

class ErrorList extends DBBase
{
    private static $errors = [
        1000 => 'An error occurred!',

        1001 => 'Bitte wählen Sie eine Abfahrtstation aus!',
        1002 => 'Bitte wählen Sie eine Rückgabestation aus!',
        1003 => 'Bitte wählen Sie Abfahrtsdatum / Abfahrtszeit aus!',
        1004 => 'Bitte wählen Sie Rückgabedatum / Rückgabezeit aus!',
        1005 => 'DEPRECATED! CODE 1003! Bitte wählen Sie Abfahrtszeit aus!',
        1006 => 'DEPRECATED! CODE 1004! Bitte wählen Sie Rückgabezeit aus!',
        1007 => 'Keine Anmietung möglich. Preis für diese Gruppe im Zeitraum nicht zu ermittlen!',
        1008 => 'Bitte wählen Sie eine Fahrzeuggruppe aus!',
        1009 => 'Sie müssen die AGB akzeptieren',
        1010 => 'Bitte geben Sie Ihre Daten ein.',
        1011 => 'Der Mietbeginn/ das Mietende liegt außerhalb der Öffnungszeiten!',
        1012 => 'Fehlende Mietbeginnzeit. Vorlaufzeit ist:',
        1013 => 'Kann nicht Kundennummer anlegen',
        1014 => 'Sie müssen die Datenschutzerklärung akzeptieren',
    ];

    public static function getError($code)
    {
        $DbTranslation = new DBTranslate();
        $translate = array(
            'MESSAGE' => $DbTranslation->loadTranslations('MESSAGE'),
            'ERRORS' => $DbTranslation->loadTranslations('ERRORS'),
        );

        # zunächst in den Übersetzungen suchen
        foreach ($translate as $errorClass => $errorData) {
            if (array_key_exists($code, $errorData)) {
                return $translate[$errorClass][$code];
            }
        }

        # wenn keine Übersetzung in DB gefunden, prüfen ob der Fehler als Konstante vorliegt
        foreach ($translate as $errorClass => $errorData) {
            if (!array_key_exists($code, $errorData) and defined($code)) {
                return self::$errors[constant($code)];
            }
        }

        return 'UNDEFINED ERROR: ' . $code;
    }
} // ErrroList
