<?php
class Params
{
    private static $vars = array();

    public static function getValue($param)
    {
        if (!empty($_SESSION['CACHE']['PARAMS'])) {
            self::$vars = $_SESSION['CACHE']['PARAMS'];
        }

        if (!array_key_exists($param, self::$vars)) {
            $reg = Registry::getInstance();
            $db = $reg->db;

            $value = null;
            $sql = "SELECT dbo.getParamValue(:param) AS Wert";

            $db->prepare($sql);

            $db->bindValue('param', $param);

            $result = $db->execute();

            if ($result !== false) {
                $row = $db->fetch_assoc();
                $value = isset($row['Wert']) ? $row['Wert'] : null;
            }

            if (is_null($value) && defined($param)) {
                $value = constant($param);
            }

            self::$vars[$param] = $value;
            $_SESSION['CACHE']['PARAMS'] = self::$vars;
        }
        return self::$vars[$param];
    } // getValue()

    public static function getAll()
    {
        $reg = Registry::getInstance();
        $db = $reg->db;

        $params = array();
        $result = $db->query("SELECT Param, Wert FROM PARAMS");

        if ($result !== false) {
            while ($row = $db->fetch_assoc()) {
                $params[$row['Param']] = $row['Wert'];
            }
        }

        foreach ($params as $key => $val) {
            self::$vars[$key] = $val;
        }
        $_SESSION['CACHE']['PARAMS'] = self::$vars;

        return $params;
    } // getAll();
} // Class Params
