<?php
/*
INSTALATION

Tabelle Params:
|  Param                 |  Beschreibung                        | Wert    |
---------------------------------------------------------------------------
|  PAYPAL_MODE           |  Live oder Sansbox 1-Live 0-Sandbox  |         |
|  PAYPAL_API_USERNAME   |  PayPal API Username                 |         |
|  PAYPAL_API_SIGNATURE  |  PayPal API Signature                |         |
|  PAYPAL_API_PASSWORD   |  PayPal API Password                 |         |
|  PAYPAL_NAME           |  NAME des PayPal Zahlungsmittel      |  PayPal |

Tabelle Module:
|  PK      |  Modul   |  enabled  |
-----------------------------------
|  --pk--  |  PayPal  |  J / N    |

Tabelle FIBU_ZAHLUNGSARTEN:
|  Zahlungsart  |  inet   |  Autobuchung  |
-------------------------------------------
|  PayPal       |  1      |  1            |

 */
class PayPal
{
    public $mode;
    public $api_user;
    public $api_password;
    public $api_signature;
    public $response = null;

    public function __construct()
    {
        $params = new Params();
        $this->mode = $params->getvALUE('PAYPAL_MODE');
        if ($this->mode == 1) {
            $this->api_user = $params->getvALUE('PAYPAL_API_USERNAME');
            $this->api_password = $params->getvALUE('PAYPAL_API_PASSWORD');
            $this->api_signature = $params->getvALUE('PAYPAL_API_SIGNATURE');
        } else {
            $this->api_user = $params->getvALUE('PAYPAL_TEST_API_USERNAME');
            $this->api_password = $params->getvALUE('PAYPAL_TEST_API_PASSWORD');
            $this->api_signature = $params->getvALUE('PAYPAL_TEST_API_SIGNATURE');
        }
    } // __construct

    public function SendRquest($method_name, $data)
    {
        $api_user = urlencode($this->api_user);
        $api_passwordword = urlencode($this->api_password);
        $api_signature = urlencode($this->api_signature);
        $paypalmode = ($this->mode == 0) ? '.sandbox' : '';
        $api_endpoint = "https://api-3t" . $paypalmode . ".paypal.com/nvp";
        // $version             = urlencode('109.0');
        $version = urlencode('124.0');

        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $api_endpoint);
        curl_setopt($ch, CURLOPT_VERBOSE, 1);

        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
        curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, false);

        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_POST, 1);

        $request = "METHOD=" . $method_name .
            "&VERSION=" . $version .
            "&PWD=" . $api_passwordword .
            "&USER=" . $api_user .
            "&SIGNATURE=" . $api_signature . $data;

        $tmp = explode('&', $request);
        $log_array = array();
        foreach ($tmp as $val) {
            $tmp2 = explode('=', $val);
            $log_array[$tmp2[0]] = $tmp2[1];
        }
        paypallog($log_array, 'API-ENDPOINT >> ' . $api_endpoint . "\n" . "REQUEST POST");

        curl_setopt($ch, CURLOPT_POSTFIELDS, $request);

        $response = curl_exec($ch);

        if (!$response) {
            false;
        }

        $response_array_prepare = explode("&", $response);

        $response_array = array();
        foreach ($response_array_prepare as $key => $value) {
            $tmp_array = explode("=", $value);
            if (sizeof($tmp_array) > 1) {
                $response_array[$tmp_array[0]] = $tmp_array[1];
            }
        }

        if (empty($response_array) || !array_key_exists('ACK', $response_array)) {
            return false;
        }

        $this->response = $response_array;
        return $this->response;
    } // SendRquest()

    public function getLastResponse()
    {
        $response = $this->response;
        foreach ($response as &$val) {
            $val = urldecode($val);
        }
        unset($val);
        return $response;
    } // getLastResponse()
}
