<?php
class DBAngebote extends DBBase
{
    public function getAngebote($kat)
    {
        $angebote = array();

        $sql = 'EXEC INET_GET_ANG_DATA @kat = :kat';
        $this->getDatabase()->prepare($sql);
        $this->getDatabase()->bindValue(':kat', $kat);
        $this->getDatabase()->execute();

        $i = 0;
        $rows = $this->getDatabase()->fetch_all();
        $Format = new Format();
        foreach ($rows as $row) {
            //$angebote[$i]['BILD'] = $row['BILD'];
            $angebote[$i]['HEADER'] = $row['HEADER'];
            $angebote[$i]['PRICE'] = $Format->currencyFormat($row['PRICE']); // AK 13.04.2018 Aufgabe 94249: Preisformatierung nicht mehr im template sondern über die Formatklasse
            $angebote[$i]['BESCH2'] = $row['BESCH2'];
            $angebote[$i]['BESCH3'] = $row['BESCH3'];
            $angebote[$i]['BUCHUNG_VON'] = $row['BUCHUNG_VON'];
            $angebote[$i]['BUCHUNG_BIS'] = $row['BUCHUNG_BIS'];
            $angebote[$i]['PKRATE'] = $row['PKRATE'];
            $angebote[$i]['Einheit'] = $row['Einheit'];
            $angebote[$i]['FREIKM'] = $row['FREIKM'];
            $angebote[$i]['STATIONS'] = $this->getStations($row['PKRATE']);
            $angebote[$i]['ENDDATE'] = null;
            $angebote[$i]['STARTDATE'] = null;
            $angebote[$i]['GRUPPE'] = $row['Gruppe'];
            $angebote[$i]['RATE'] = $row['RatenCode'];

            // gültig in zeitraum
            if ($row['GUEL_START_ZEITRAUM'] != null && $row['GUEL_END_ZEITRAUM'] != null) {
                $angebote[$i]['GUEL_START_ZEITRAUM'] = new DateTime($row['GUEL_START_ZEITRAUM']);

                // TODO Öffnungszeiten prüfen
                $angebote[$i]['STARTDATE'] = $angebote[$i]['GUEL_START_ZEITRAUM']->getTimestamp();

                $angebote[$i]['GUEL_END_ZEITRAUM'] = new DateTime($row['GUEL_END_ZEITRAUM']);
                $angebote[$i]['GUEL_END_ZEITRAUM']->modify("+" . $row['GUEL_MIN_MIETZEIT'] . "days");

                // TODO Öffnungszeiten prüfen
                $angebote[$i]['ENDDATE'] = $angebote[$i]['GUEL_END_ZEITRAUM']->getTimestamp();

                //gültig zwischen 2 tagen
            } elseif ($row['GUEL_MIN_START_TAG'] != null) {
                if ($row['GUEL_MIN_START_ZEIT'] == null) {
                    $row['GUEL_MIN_START_ZEIT'] = '0000';
                }

                $starttime = substr($row['GUEL_MIN_START_ZEIT'], 0, 2) . ":" . substr($row['GUEL_MIN_START_ZEIT'], 2, 2);
                $endtime = $starttime; //substr($row['GUEL_MIN_END_ZEIT'], 0, 2) . ":" . substr($row['GUEL_MIN_END_ZEIT'], 2, 2);

                switch ($row['GUEL_MIN_START_TAG']) {
                    case 'Mo':
                        $weekday = 'next monday';
                        break;
                    case 'Di':
                        $weekday = 'next tuesday';
                        break;
                    case 'Mi':
                        $weekday = 'next wednesday';
                        break;
                    case 'Do':
                        $weekday = 'next thursday';
                        break;
                    case 'Fr':
                        $weekday = 'next friday';
                        break;
                    case 'Sa':
                        $weekday = 'next saturday';
                        break;
                    case 'So':
                        $weekday = 'next sunday';
                        break;
                    default:
                        $weekday = 'next monday';
                        break;
                }

                //if($weekday >= $angebote[$i]['STARTDATE']->format("N")) {
                $angebote[$i]['STARTDATE'] = new DateTime(date('Y-m-d', strtotime($weekday)) . $starttime);

                $angebote[$i]['ENDDATE'] = $angebote[$i]['STARTDATE'];

                // TODO Öffnungszeiten prüfen
                $angebote[$i]['STARTDATE'] = $angebote[$i]['STARTDATE']->getTimestamp();

                $angebote[$i]['ENDDATE']->modify("+1day");

                // TODO Öffnungszeiten prüfen
                $angebote[$i]['ENDDATE'] = $angebote[$i]['ENDDATE']->getTimestamp();
                //}
            }
            // immer gültig
            else {
                $angebote[$i]['STARTDATE'] = new DateTime(date_format(new DateTime(), "Y-m-d H:00"));
                $angebote[$i]['STARTDATE'] = $angebote[$i]['STARTDATE']->modify("+1day");
                $angebote[$i]['STARTDATE'] = $angebote[$i]['STARTDATE']->modify("+3hour");

                // TODO Öffnungszeiten prüfen
                $angebote[$i]['STARTDATE'] = $angebote[$i]['STARTDATE']->getTimestamp();

                $angebote[$i]['ENDDATE'] = new DateTime(date_format(new DateTime(), "Y-m-d H:00"));
                $angebote[$i]['ENDDATE'] = $angebote[$i]['ENDDATE']->modify("+2days");

                // TODO Öffnungszeiten prüfen
                $angebote[$i]['ENDDATE'] = $angebote[$i]['ENDDATE']->getTimestamp();
            }

            $i++;
        }

        return $angebote;
    } //getAngebote($kat)

    public function getStations($angpk)
    {
        $stations = array();
        $sql = "SELECT * FROM dbo.GET_ANGEBOTE_STATIONS(:ANGEBOTPK)";
        $this->getDatabase()->prepare($sql);
        $this->getDatabase()->bindValue(':ANGEBOTPK', $angpk);
        $this->getDatabase()->execute();

        while ($row = $this->getDatabase()->fetch_assoc()) {
            $stations[] = $row['PKStation'];
        }
        return $stations;
    } // getStations()

    public function getBild($pk)
    {
        $this->getDatabase()->query("EXEC dbo.INET_GET_ANG_DATA_BY_PK @PKRATE = " . intval($pk));
        $row = $this->getDatabase()->fetch_assoc();
        return (!empty($row['BILD']) ? $row['BILD'] : null);
    } //getBild($pk)
}
