<?php
class DBCustomer extends DBBase
{
    public function getInfoByLogin($mail, $pass)
    {
        $dbObj = null;

        $sql = 'SELECT * FROM WEBSERVICE_LOGIN WHERE email = :email ORDER BY PK';

        $this->getDatabase()->prepare($sql);
        $this->getDatabase()->bindValue(':email', $mail);

        $result = $this->getDatabase()->execute();

        if ($result !== false) {
            $dbRow = $this->getDatabase()->fetch_assoc();
        }

        if (empty($dbRow)) {
            $dbRow = $this->inetpassowrd_from_table_kunden_update($mail, $pass);
        }

        if (!empty($dbRow)) {
            $pass_compare = getPasswordHash($pass, $dbRow['PASSWORD_SALT']);
            if ($pass_compare == $dbRow['PASSWORD_HASH']) {
                //Aufgabe 60251 JM 2014-10-09
                $sql = "SELECT TOP 1 * FROM KUNDEN WHERE NUMMER = " . (int) $dbRow['KUNDENNUMMER'] . " AND ((gesperrt=0) OR (gesperrt IS NULL)) AND ((Tmp=0) OR (Tmp IS NULL))";
                $result = $this->getDatabase()->query($sql);
                if ($result !== false) {
                    $dbObj = $this->getDatabase()->fetch_obj();
                    $dbObj->pass_hash = $pass_compare;
                }
            }
        }
        return $dbObj;
    } // getInfoByLogin($mail, $pass)

    public function loginResetOldPassword($id)
    {
        if ($id > 0) {
            $sql = 'UPDATE KUNDEN
                    SET inetpasswort = null, inetzugangaktiv = 0
                    WHERE NUMMER = :id';
            $this->getDatabase()->prepare($sql);
            $this->getDatabase()->bindValue(':id', $id);
            $this->getDatabase()->execute();
        }
    } // loginResetOldPassword

    public function getInfoByEmail($mail)
    {
        $dbObj = null;

        $sql = "SELECT * FROM KUNDEN WHERE inetemail=:mail AND ((gesperrt=0) OR (gesperrt IS NULL)) AND ((Tmp=0) OR (Tmp IS NULL))";
        $this->getDatabase()->prepare($sql);
        $this->getDatabase()->bindValue(':mail', $mail);

        $result = $this->getDatabase()->execute();

        if ($result !== false) {
            $dbObj = $this->getDatabase()->fetch_obj();
        }

        return $dbObj;
    } // getInfoByEmail($mail)

    public function getInfoBypassHash($hash)
    {
        $dbObj = null;
        $sql = "SELECT * FROM KUNDEN LEFT JOIN dbo.WEBSERVICE_LOGIN ON	KUNDEN.NUMMER = dbo.WEBSERVICE_LOGIN.KUNDENNUMMER
                    WHERE WEBSERVICE_LOGIN.PASSWORD_HASH = :hash";
        $this->getDatabase()->prepare($sql);
        $this->getDatabase()->bindValue(':hash', $hash);

        $result = $this->getDatabase()->execute();

        if ($result !== false) {
            $dbObj = $this->getDatabase()->fetch_obj();
        }

        return $dbObj;
    } // getInfoBypassHash($hash)

    public function getById($id)
    {
        $dbObj = null;

        if ($id > 0) {
            $sql = "SELECT * FROM KUNDEN LEFT JOIN dbo.WEBSERVICE_LOGIN ON	KUNDEN.NUMMER = dbo.WEBSERVICE_LOGIN.KUNDENNUMMER
                    WHERE KUNDEN.NUMMER = :id";
            $this->getDatabase()->prepare($sql);
            $this->getDatabase()->bindValue(':id', $id);

            $result = $this->getDatabase()->execute();

            if ($result !== false) {
                $dbObj = $this->getDatabase()->fetch_obj();
            }
        }
        return $dbObj;
    } // getById($id)

    public function loginIsActivate($id)
    {
        $dbObj = null;
        if ($id > 0) {
            $sql = "SELECT inetzugangaktiv FROM KUNDEN WHERE NUMMER = :id";
            $this->getDatabase()->prepare($sql);
            $this->getDatabase()->bindValue(':id', $id);
            $this->getDatabase()->execute();
        }
        $row = $this->getDatabase()->fetch_assoc();
        if ($row['inetzugangaktiv'] == 1) {
            $isActiv = true;
        } else {
            $isActiv = false;
        }

        return $isActiv;
    } // loginIsActivate($id)

    public function logChanges($customerNumber)
    {
        $this->db->proc_exec('aenderungseintrag_Kunden', array(
            'kdnummer' => $customerNumber,
            'benutzer' => 'WEB',
        ));
    }

    public function loginActivate($user, $password)
    {
        $dbMandant = new DBMandant();
        $mandant = $dbMandant->getInfo();

        $kunden_category = Params::getValue('SINET_KAT_KUNDE_WEB');
        $kunden_category = !empty($kunden_category) ? $kunden_category : '';
        $tmp_id = (int) $user->tmp_num;
        $new_id = 0;
        if (!empty($mandant->Kundenkategorien) && !empty($kunden_category)) {
            $sql = "SELECT dbo.KUNDEN_GET_KAT_PK(:kunden_category)";
            $this->getDatabase()->prepare($sql);
            $this->getDatabase()->bindValue(':kunden_category', $kunden_category);
            $result = $this->getDatabase()->execute();
            if ($result !== false) {
                $row = $this->getDatabase()->fetch_all();
                if (!empty($row[0])) {
                    $new_id = array_shift($row[0]);
                }
            }
        } else {
            $kpk_tanle = 'KPK';
            $sql = "SELECT KPKKennz FROM stammt WHERE station= (SELECT TOP 1 Filiale FROM kunden WHERE NUMMER = ?)";
            $this->getDatabase()->prepare($sql);
            $this->getDatabase()->execute(array((int) $tmp_id));
            $row = $this->getDatabase()->fetch_assoc();

            $kpk_tanle = $row['KPKKennz'];
            $sql = "EXEC dbo.inet_get_next_pk @ATablename = :kpk_tanle,@newvalue = 0";

            $this->getDatabase()->prepare($sql);
            $this->getDatabase()->bindValue(':kpk_tanle', $kpk_tanle);
            $result = $this->getDatabase()->execute();
            if ($result !== false) {
                $row = $this->getDatabase()->fetch_assoc();
                $new_id = !empty($row['PK']) ? $row['PK'] : 0;
            }
        }

        if ($new_id > 0) {
            $sql = "EXEC KUNDEN_CHANGE_NR @OldNum = ?, @NewNum = " . (int) $new_id;
            $this->getDatabase()->prepare($sql);
            $this->getDatabase()->execute(array((int) $tmp_id));

            $sql = "UPDATE KUNDEN SET tmp = 0, inetzugangaktiv = 1 WHERE NUMMER = " . (int) $new_id;
            $this->getDatabase()->prepare($sql);
            $this->getDatabase()->execute();

            $password_salt = getSalt();
            $password_hash = getPasswordHash($password, $password_salt);

            $sql = "UPDATE WEBSERVICE_LOGIN
                    SET PASSWORD_HASH = :password_hash,
                    PASSWORD_SALT = :password_salt,
                    LOGIN_VERIFIED = 1
                    WHERE KUNDENNUMMER = :new_id";

            $this->getDatabase()->prepare($sql);
            $this->getDatabase()->bindValue(':password_hash', $password_hash);
            $this->getDatabase()->bindValue(':password_salt', $password_salt);
            $this->getDatabase()->bindValue(':new_id', (int) $new_id);
            $this->getDatabase()->execute();
        }
        return $new_id;
    } // loginActivate()

    public function inetAccessActivate($user, $password)
    {
        if ($user->id > 0) {
            $password_salt = getSalt();
            $password_hash = getPasswordHash($password, $password_salt);
            $sql = "UPDATE KUNDEN SET inetzugangaktiv = 1 WHERE NUMMER = " . (int) $user->id;
            $this->getDatabase()->prepare($sql);
            $this->getDatabase()->execute();

            $sql = "UPDATE WEBSERVICE_LOGIN
                    SET PASSWORD_HASH = :password_hash,
                        PASSWORD_SALT = :password_salt,
                        LOGIN_VERIFIED = 1
                    WHERE KUNDENNUMMER = :new_id";
            $this->getDatabase()->prepare($sql);
            $this->getDatabase()->bindValue(':password_hash', $password_hash);
            $this->getDatabase()->bindValue(':password_salt', $password_salt);
            $this->getDatabase()->bindValue(':new_id', (int) $user->id);
            $this->getDatabase()->execute();
        }
    }

    public function loginResetPassword($id)
    {
        if ($id > 0) {
            $this->loginResetOldPassword($id);

            $sql = 'UPDATE WEBSERVICE_LOGIN
				    SET PASSWORD_HASH = null,
				        PASSWORD_SALT = null,
				        LOGIN_VERIFIED = 0
				    WHERE KUNDENNUMMER = :id';
            $this->getDatabase()->prepare($sql);
            $this->getDatabase()->bindValue(':id', $id);
            $this->getDatabase()->execute();
        }
    } // loginResetPassword($id)

    public function loginUpdatePassword($id, $inetpasswort)
    {
        $dbObj = null;

        if ($id > 0) {
            $pasword_salt = getSalt();
            $password_hash = getPasswordHash($inetpasswort, $pasword_salt);

            $sql = "UPDATE WEBSERVICE_LOGIN SET SET PASSWORD_HASH = :password_hash , PASSWORD_SALT = :password_salt WHERE KUNDENNUMMER=:id";

            $this->getDatabase()->prepare($sql);
            $this->getDatabase()->bindValue(':id', $id);
            $this->getDatabase()->bindValue(':password_hash', $password_hash);
            $this->getDatabase()->bindValue(':password_salt', $password_salt);
            $this->getDatabase()->execute();

            $dbObj = $this->getById($id);
        }

        return $dbObj;
    } // loginUpdatePassword($id, $inetpasswort)

    public function createToken($user)
    {
        $token = getToken();
        $user_id = !empty($user->id) ? $user->id : $user->tmp_num;

        $sql = 'SELECT count(wl.PK) as userExists FROM WEBSERVICE_LOGIN wl JOIN Kunden k ON k.nummer=wl.KUNDENNUMMER WHERE wl.EMAIL = :user_email AND wl.LOGIN_VERIFIED = 0 AND k.tmp = 1'; // TODO nur löschen, wenn tmp
        $this->getDatabase()->prepare($sql);
        $this->getDatabase()->bindValue(':user_email', $user->email);
        $result = $this->getDatabase()->execute();
        if ($result) {
            $row = $this->getDatabase()->fetch_assoc();

            if ($row['userExists'] > 0) {
                $sql = 'DELETE FROM WEBSERVICE_LOGIN WHERE EMAIL = :user_email';
                $this->getDatabase()->prepare($sql);
                $this->getDatabase()->bindValue(':user_email', $user->email);
                $result = $this->getDatabase()->execute();
            }
        }

        $sql = 'SELECT PK FROM WEBSERVICE_LOGIN WHERE KUNDENNUMMER = :user_id';
        $this->getDatabase()->prepare($sql);
        $this->getDatabase()->bindValue(':user_id', $user_id);
        $result = $this->getDatabase()->execute();
        if ($result) {
            $row = $this->getDatabase()->fetch_assoc();
            if (empty($row['PK'])) {
                $sql = "INSERT INTO WEBSERVICE_LOGIN (EMAIL, KUNDENNUMMER) VALUES (:email, :user_id)";
                $this->getDatabase()->prepare($sql);
                $this->getDatabase()->bindValue(':email', $user->email);
                $this->getDatabase()->bindValue(':user_id', $user_id);
                $this->getDatabase()->execute();

                $login_pk = $this->getDatabase()->last_insert_id();
            } else {
                $login_pk = $row['PK'];
            }

            $sql = 'SELECT count(PK) as sessionTokenExist FROM WEBSERVICE_SESSIONS WHERE PK_LOGIN = :pk_login AND EXPIRY_DATE < GETDATE()';
            $this->getDatabase()->prepare($sql);
            $this->getDatabase()->bindValue(':pk_login', $login_pk);
            $result = $this->getDatabase()->execute();
            if ($result) {
                $row = $this->getDatabase()->fetch_assoc();

                if ($row['sessionTokenExist'] > 0) {
                    $sql = 'DELETE FROM WEBSERVICE_SESSIONS WHERE PK_LOGIN = :pk_login';
                    $this->getDatabase()->prepare($sql);
                    $this->getDatabase()->bindValue(':pk_login', $login_pk);
                    $result = $this->getDatabase()->execute();
                }
            }

            $sql = "INSERT INTO WEBSERVICE_SESSIONS (PK_LOGIN, SESSION_TOKEN, EXPIRY_DATE)
                    VALUES (:pk_login, :session_hash, '01.01.2099')";
            $this->getDatabase()->prepare($sql);
            $this->getDatabase()->bindValue(':pk_login', $login_pk);
            $this->getDatabase()->bindValue(':session_hash', $token);
            $this->getDatabase()->execute();
        }

        return $token;
    } // createToken()
    public function getInfoByToken($token)
    {
        $sql = 'SELECT WEBSERVICE_LOGIN.* FROM WEBSERVICE_LOGIN LEFT JOIN WEBSERVICE_SESSIONS
                ON WEBSERVICE_LOGIN.PK = WEBSERVICE_SESSIONS.PK_LOGIN
                WHERE WEBSERVICE_SESSIONS.SESSION_TOKEN = ? AND WEBSERVICE_SESSIONS.EXPIRY_DATE >= GETDATE()';
        $this->getDatabase()->prepare($sql);
        $this->getDatabase()->execute(array(
            $token,
        ));
        $row = $this->getDatabase()->fetch_assoc();
        if (empty($row)) {
            return false;
        } else {
            return $this->getById($row['KUNDENNUMMER']);
        }
    } // getCustomerByToken()
    public function tokenDeactivate($token)
    {
        $sql = "UPDATE WEBSERVICE_SESSIONS SET EXPIRY_DATE = '1900-01-01' WHERE SESSION_TOKEN = ?";
        $this->getDatabase()->prepare($sql);
        $this->getDatabase()->execute(array(
            $token,
        ));
    } // tokenDeactivate()
    private function inetpassowrd_from_table_kunden_update($mail, $pass)
    {
        $dbRow = null;

        $sql = 'SELECT * FROM kunden WHERE email = :email AND inetpasswort = :pass';
        $this->getDatabase()->prepare($sql);
        $this->getDatabase()->bindValue(':email', $mail);
        $this->getDatabase()->bindValue(':pass', $pass);
        $result = $this->getDatabase()->execute();

        if ($result !== false) {
            $dbRowUpdate = $this->getDatabase()->fetch_assoc();
            if (!empty($dbRowUpdate)) {
                $sql = 'INSERT INTO dbo.WEBSERVICE_LOGIN
                ( EMAIL, LOGIN_VERIFIED, KUNDENNUMMER)
                VALUES  ( :email, 1 , :id)';
                $this->getDatabase()->prepare($sql);
                $this->getDatabase()->bindValue(':email', $mail);
                $this->getDatabase()->bindValue(':id', $dbRowUpdate['NUMMER']);
                $this->getDatabase()->execute();

                $login_update = $this->loginUpdatePassword($dbRowUpdate['NUMMER'], $pass);
                if (!empty($login_update)) {
                    $sql = 'UPDATE KUNDEN SET inetpasswort = NULL WHERE nummer = :id';
                    $this->getDatabase()->prepare($sql);
                    $this->getDatabase()->bindValue(':id', $dbRowUpdate['NUMMER']);
                    $this->getDatabase()->execute();

                    $sql = 'SELECT * FROM WEBSERVICE_LOGIN WHERE email = :email';
                    $this->getDatabase()->prepare($sql);
                    $this->getDatabase()->bindValue(':email', $mail);
                    $result = $this->getDatabase()->execute();

                    if ($result !== false) {
                        $dbRow = $this->getDatabase()->fetch_assoc();
                    }
                }
            }
        }

        return $dbRow;
    } // inetpassowrd_from_table_kunden_update()

    public function getBriefanrede($nummer)
    {
        $sql = 'SELECT dbo.KUNDE_GET_BRIEFANREDE_OHNE_NAME(:nummer)';
        $this->getDatabase()->prepare($sql);
        $this->getDatabase()->bindValue(':nummer', $nummer);
        $result = $this->getDatabase()->execute();
        if ($result !== false) {
            return $briefanrede = $this->getDatabase()->fetch_assoc();
        }
    }
}
