<?php
class DBDiscount extends DBBase
{
    public function isRateDiscountable($Rate, $CarGroupCode)
    {
        $RateDiscountable = false;
        $sql = "SELECT count(*) as rate_count FROM RECH_RATEN
				WHERE ((Grp = '*') OR (Grp = :group)) AND (Rate = :rate) AND nichtRabattfaehig = 1";
        $this->getDatabase()->prepare($sql);
        $this->getDatabase()->bindValue(':group', $CarGroupCode);
        $this->getDatabase()->bindValue(':rate', $Rate->rate);

        $result = $this->getDatabase()->execute();

        $row = $this->getDatabase()->fetch_obj();
        if ($result === false) {
            $RateDiscountable = true;
        } else {
            $RateDiscountable = $row->rate_count == 0;
        }

        return $RateDiscountable;
    } // isRateDiscountable()

    public function DiscountDetails($discount_code, $StartDateTime, $EndDateTime)
    {

        $DiscountAvailable = false;
        $discount_info = array();

        $days = ($EndDateTime->getTimestamp() - $StartDateTime->getTimestamp()) / 60 / 60 / 24;
        $today = date('d.m.Y H:i:s');

        $sql = "SELECT *
				FROM INET_RABATT
				WHERE gutscheincode = :code
				AND verwendet = 0
				AND CAST(:StartDateTime AS DATETIME) >= DATEADD(day, ISNULL(vorlauf, 0), von)
				AND CAST(:StartDateTime AS DATETIME) <= DATEADD(day, ISNULL(vorlauf, 0), bis)
                AND CAST(:StartDateTime AS DATETIME) >= DATEADD(day, ISNULL(vorlauf, 0), CAST(:today AS DATETIME))
                AND ISNULL(verwendbar_bis, CAST(:today AS DATETIME)) >= CAST(:today AS DATETIME)";

        # "verwendbar_bis" : bis zu diesem Zeitpunkt (bezogen auf die Durchführung der Reservierung) existiert der Gutschein
        # "von" + "bis" : zwischen diesen beiden Werten muss startdatetime liegen

        $this->getDatabase()->prepare($sql);
        $this->getDatabase()->bindValue(':code', $discount_code);
        $this->getDatabase()->bindValue(':StartDateTime', $StartDateTime->format('d.m.Y H:i:00'));
        $this->getDatabase()->bindValue(':today', $today);

        $result = $this->getDatabase()->execute();

        if ($result !== false) {
            $row = $this->getDatabase()->fetch_assoc();
            if (isset($row['gutscheincode']) && $row['gutscheincode'] === $discount_code) {
                $discount_info = array('persent' => $row['prozent'], 'summe' => $row['betrag'], 'always_allow' => $row['immer_gueltig'], 'code' => $row['gutscheincode']);
                if (!empty($row['min_tage']) && (float) $row['min_tage'] - $days > 0.01) {
                    $discount_info = array();
                }

                if (!empty($row['max_tage']) && $days - (float) $row['max_tage'] > 0.01) {
                    $discount_info = array();
                }
            }
        }
        return $discount_info;
    } //isDiscountAvailable()
} // Class DBDiscount
