<?php

class DBError extends DBBase
{

    /**
     *
     * @param int $step
     * @param DateTime $startdatetime
     * @param DateTime $enddatetime
     * @param Station $station
     * @param Station $endstation
     * @param String $cargroup
     * @return array
     */
    public function checkErrors($step, $startdatetime, $enddatetime, $station, $endstation, $cargroup = '')
    {
        $error_text = array();

        $etr = Params::getValue('CONFIG_EVERYTIME_RETURN');
        $etd = Params::getValue('CONFIG_EVERYTIME_DEPARTURE');

        $query = "EXEC INET_CHECK_ERRORS @step = :step, @startdate = :startdate, "
            . "@enddate = :enddate, @starttime = :starttime, @endtime  = :endtime, @STATION = :station," .
            " @ENDSTATION = :endstation, @everytimereturn = :etr, @everytimedeparture = :etd, @cargroup = :cargroup, @lang = :lang";
        $this->getDatabase()->prepare($query);
        $this->getDatabase()->bindValue('step', $step);
        $this->getDatabase()->bindValue('startdate', $startdatetime->format('d.m.Y'));
        $this->getDatabase()->bindValue('enddate', $enddatetime->format('d.m.Y'));
        $this->getDatabase()->bindValue('starttime', $startdatetime->format('Hi'));
        $this->getDatabase()->bindValue('endtime', $enddatetime->format('Hi'));
        $this->getDatabase()->bindValue('station', $station->code);
        $this->getDatabase()->bindValue('endstation', $endstation->code);
        $this->getDatabase()->bindValue('etr', $etr, PDO::PARAM_INT);
        $this->getDatabase()->bindValue('etd', $etd, PDO::PARAM_INT);
        $this->getDatabase()->bindValue('cargroup', $cargroup);
        $this->getDatabase()->bindValue('lang', Session::getLang());
        $this->getDatabase()->execute();
        $errors = $this->getDatabase()->fetch_all();

        if ($errors[0]['result'] != 1) {
            foreach ($errors as $key => $error) {
                array_push($error_text, $error['error_text']);
            }
        }
        return $error_text;
    } // checkErrors()
}
