 <?php

 class DBReservation extends DBBase
 {
     // ##### INDIVIDUELL WUCHERPFENNIG und SHARE-ME
     public function isAutoReservConfirm($filiale, $group, $startdate, $starttime, $enddate, $endtime)
     {
         $sql = "SELECT VORLAUF, VORLAUFSAM, VORLAUFLASTSAM
				FROM FILIALE_GRUPPE_VORLAUF
				WHERE GRUPPE = :group AND FILIALE=:filiale";

         $this->getDatabase()->prepare($sql);
         $this->getDatabase()->bindValue(':group', $group);
         $this->getDatabase()->bindValue(':filiale', $filiale);
         $result = $this->getDatabase()->execute();
         if ($result !== false) {
             $arr = $this->getDatabase()->fetch_array();
         }

         $vlauf = 0;
         $vsa = 0;
         $vlasa = 0;
         $isReserv = false;

         if (sizeof($arr) > 0) {
             $vlauf = $arr['VORLAUF'];
             $vsa = $arr['VORLAUFSAM'];
             $vlasa = $arr['VORLAUFLASTSAM'];

             $cdate = date("d.m.Y");
             $ctime = date("H:i");
             $diffVorlauf = 0;
             $touchSa = false;
             $touchLaSa = false;
             $this->diffHourMin($cdate, $ctime, $startdate, $starttime, $diffVorlauf);
             $this->isDayOfSa($startdate, $starttime, $enddate, $endtime, $touchSa, $touchLaSa);

             if ($touchLaSa) {
                 // gilt vlasa
                 if ($diffVorlauf > $vlasa) {
                     $isReserv = true;
                 }
             } else {
                 if ($touchSa) {
                     // gilt vsa
                     if ($diffVorlauf > $vsa) {
                         $isReserv = true;
                     }
                 } else {
                     // gilt vlauf
                     if ($diffVorlauf > $vlauf) {
                         $isReserv = true;
                     }
                 }
             }
         }
         return $isReserv;
     }

     private function diffHourMin($startdate, $starttime, $enddate, $endtime, &$resHour = 0, &$resMin = 0)
     {
         $cyear = substr($startdate, 6, 4);
         $cmon = substr($startdate, 3, 2);
         $cday = substr($startdate, 0, 2);
         $chour = substr($starttime, 0, 2);
         $cmin = substr($starttime, 3, 2);

         $ayear = substr($enddate, 6, 4);
         $amon = substr($enddate, 3, 2);
         $aday = substr($enddate, 0, 2);
         $ahour = substr($endtime, 0, 2);
         $amin = substr($endtime, 3, 2);

         $total = 0;
         $cdate = date("YmdHi", mktime($chour, $cmin, 0, $cmon, $cday, $cyear));
         $adate = date("YmdHi", mktime($ahour, $amin, 0, $amon, $aday, $ayear));

         while ($cdate < $adate) {
             $total++;
             $cdate = date("YmdHi", mktime($chour + $total, $cmin, 0, $cmon, $cday, $cyear));
         }

         $resHour = $total;

         return true;
     }

     private function isDayOfSa($startdate, $starttime, $enddate, $endtime, &$issa = false, &$islasa = false)
     {
         $cyear = substr($startdate, 6, 4);
         $cmon = substr($startdate, 3, 2);
         $cday = substr($startdate, 0, 2);
         $chour = substr($starttime, 0, 2);
         $cmin = substr($starttime, 3, 2);

         $ayear = substr($enddate, 6, 4);
         $amon = substr($enddate, 3, 2);
         $aday = substr($enddate, 0, 2);
         $ahour = substr($endtime, 0, 2);
         $amin = substr($endtime, 3, 2);

         $tday = 0;
         $cw = date("w", mktime($chour, $cmin, 0, $cmon, $cday, $cyear));

         $cdate = date("Ymd", mktime($chour, $cmin, 0, $cmon, $cday, $cyear));
         $adate = date("Ymd", mktime($ahour, $amin, 0, $amon, $aday, $ayear));

         if ($cw == 6) {
             $issa = true;
             $nsa = date("m", mktime(0, 0, 0, $cmon, $cday + 7, $cyear));
             if ($nsa > $cmon) {
                 $islasa = true;
             }
         }
         while ($cdate < $adate) {
             $tday++;
             $cdate = date("Ymd", mktime(0, 0, 0, $cmon, $cday + $tday, $cyear));
             $cw = date("w", mktime(0, 0, 0, $cmon, $cday + $tday, $cyear));
             if ($cw == 6) {
                 $issa = true;
                 // prüft die nächste 7 Tage
                 $nsa = date("m", mktime(0, 0, 0, $cmon, $cday + $tday + 7, $cyear));
                 if ($nsa > $cmon) {
                     $islasa = true;
                 }
             }
         }
     }
     // ##### INDIVIDUELL WUCHERPFENNIG und SHARE-ME
     public function getNextReservNum($start_station)
     {
         $sql = "SELECT count(*) as tmp FROM PARAMS WHERE Param='BINET_CACHE_DB' AND Wert='1'";
         $result = $this->getDatabase()->query($sql);
         $row = $this->getDatabase()->fetch_obj();
         $params = array();
         if ($row->tmp > 0) {
             $result = $this->getDatabase()->query('EXEC Inet_GetResNo_Cache');
         } else {
             $sql = "EXEC Inet_GetResNo @station= :station";
             $this->getDatabase()->prepare($sql);
             $this->getDatabase()->bindValue(':station', $start_station);
             $result = $this->getDatabase()->execute($sql);
         }

         $res_num = $this->getDatabase()->fetch_row();

         return $res_num[0];
     }

     public function Save($params)
     {
         $registry = Registry::getInstance();
         $dbparams = $registry->params;
         $sumNetto = 0;
         $prepay = 0;
         $paypal = 0;
         $reservNum = 0;
         $user = $params['user'];
         $no_login = false;
         // debug($user);

         $dbTranslate = new DBTranslate();
         $lang = Session::getLang();
         $translate = $dbTranslate->loadTranslations('CONFIRM', $lang);

         try {
             $this->getDatabase()->beginTransaction();

             $next_user_id = 0;

             if ($user->id == 0) {
                 $no_login = true;

                 $sql = "INSERT INTO KUNDEN (
							NUMMER,
							Anrede,
							Vorname,
							Nachname,
							NAME1,
							NAME2,
							STRASSE,
							PLZ,
							ORT,
							EMail,
							Telefonnummer,
							Tmp,
							allow_marketing,
							kknummer,
							validthru,
							filiale,
							inetemail,
							inetzugangaktiv,
							firma,
                            F_HRERSCHEINNR,
                            GEBDAT,
                            Kategorie)
						VALUES(
							:KDNUMMER,
							:CUSTOMER_ANREDE,
							:CUSTOMER_VORNAME,
							:CUSTOMER_NACHNAME,
							:NAME1_TEMPLATE,
							:NAME2_TEMPLATE,
							:CUSTOMER_STRASSE,
							:CUSTOMER_PLZ,
							:CUSTOMER_ORT,
							:CUSTOMER_EMAIL,
							:CUSTOMER_PHONE,
							:CUSTOMER_TMP,
							0,
							:PAYMENTMETHOD + :CARDNO,
							:GUELTDATE,
							:STARTSTATION,
							:INETEMAIL,
							:INETZUGANGAKTIV,
							:istFirma,
                            :F_HRERSCHEINNR,
                            :GEBDAT,
                            :CUSTOMER_CATEGORY)";

                 if (!empty($params['pay']->credit_card_number)) {
                     $credit_card_number = preg_replace('/[^0-9]/', '', $params['pay']->credit_card_number);
                 } else {
                     $credit_card_number = '';
                 }

                 $kunden_category = Params::getValue('SINET_KAT_KUNDE_WEB');
                 $kunden_category = !empty($kunden_category) ? $kunden_category : '';

                 $customer_tmp = (Params::getValue('BINET_KUNDE_TMP') == '1') ? 0 : 1;
                 $inetzugangaktiv = (Params::getValue('BINET_KUNDE_LOGIN_NO_CONFIRM') == '1') ? 1 : 0;

                 if ($params['pay']->name == Params::getValue('PAYPAL_NAME') || $params['pay']->name == Params::getValue('CONCARDIS_NAME')) {
                     $customer_tmp = 0;
                 }

                 $next_user_id = $this->getnextKundenPk($customer_tmp, $params['startstation']);
                 if ($next_user_id <= 0) {
                     unset($_SESSION['DATA']['customer']);
                     goError(ErrorList::getError('ERROR_GET_NEW_USER_ID'));
                 }

                 foreach ($user as $key => $value) {
                     $user->$key = html_entity_decode($value);
                 }

                 $this->getDatabase()->prepare($sql);

                 $this->getDatabase()->bindValue('KDNUMMER', $next_user_id);
                 $this->getDatabase()->bindValue('CUSTOMER_ANREDE', $user->anrede);
                 $this->getDatabase()->bindValue('CUSTOMER_VORNAME', substr($user->firstname, 0, 20));
                 $this->getDatabase()->bindValue('CUSTOMER_NACHNAME', substr($user->lastname, 0, 20));
                 $this->getDatabase()->bindValue('CUSTOMER_STRASSE', $user->street);
                 $this->getDatabase()->bindValue('CUSTOMER_PLZ', $user->zipcode);
                 $this->getDatabase()->bindValue('CUSTOMER_ORT', $user->city);
                 $this->getDatabase()->bindValue('CUSTOMER_EMAIL', $user->email);
                 $this->getDatabase()->bindValue('CUSTOMER_PHONE', $user->phone);
                 // AK 16.10.2014 - : Wenn Parameter BINET_KUNDE_TMP = 1, dann Kunde nicht temporär
                 $this->getDatabase()->bindValue('CUSTOMER_TMP', $customer_tmp);
                 $this->getDatabase()->bindValue('PAYMENTMETHOD', $params['pay']->name);
                 // AK 27.04.2016 Aufgabe 78531: wenn Kunde Sparmobile dann ohne / speichern
                 if (defined('MAND_NUMMER') && MAND_NUMMER === 70332) {
                     $this->getDatabase()->bindValue('CARDNO', $credit_card_number != '' ? $credit_card_number : '');
                 } else {
                     $this->getDatabase()->bindValue('CARDNO', $credit_card_number != '' ? '/' . $credit_card_number : '');
                 }
                 $this->getDatabase()->bindValue('GUELTDATE', (isset($params['pay']->credit_card_date) && $params['pay']->credit_card_date != '') ? $params['pay']->credit_card_date : '');
                 $this->getDatabase()->bindValue('STARTSTATION', $params['startstation']);
                 $this->getDatabase()->bindValue('INETEMAIL', $user->email);
                 // AK 16.10.2014 - Aufgabe 60548: Wenn Parameter BINET_KUNDE_LOGIN_NO_CONFIRM = 1, dann Zugang sofort aktiv
                 $this->getDatabase()->bindValue('INETZUGANGAKTIV', $inetzugangaktiv);
                 $this->getDatabase()->bindValue('NAME1_TEMPLATE', substr(($user->isCompany) ? $user->firma : $user->name_template, 0, 50));
                 $this->getDatabase()->bindValue('NAME2_TEMPLATE', substr(($user->isCompany) ? $user->name_template : null, 0, 50));
                 $this->getDatabase()->bindValue('istFirma', ($user->isCompany) ? 'J' : 'N');
                 $this->getDatabase()->bindValue('F_HRERSCHEINNR', $user->drive_licens);
                 $this->getDatabase()->bindValue('GEBDAT', ($user->birthday != '') ? $user->birthday : null);
                 $this->getDatabase()->bindValue('CUSTOMER_TMP', $customer_tmp);
                 $this->getDatabase()->bindValue('CUSTOMER_CATEGORY', $kunden_category);

                 $this->getDatabase()->execute();

                 $user->id = $next_user_id;
             }

             $this->getDatabase()->proc_exec('aenderungseintrag_Kunden', array(
                'kdnummer' => $user->id,
                'benutzer' => 'WEB',
             ));
             $rabatt_auch_als_aufschlag = Params::getValue('BRABATT_AUCH_ALS_AUFSCHLAG');
             // die("Kundennummer:".$user->id);
             $reservNum = (int) $this->getNextReservNum($params['startstation']);

             $sql = "DELETE FROM RECH_POS
                    WHERE PKRECHNUNG = :reservNum";
             $this->getDatabase()->prepare($sql);
             $this->getDatabase()->bindValue(':reservNum', $reservNum);
             $this->getDatabase()->execute();

             // AK 13.04.2018 Aufgabe 97044: die groupid muss anhand der PKRECHNUNG ermittelt werden und nicht über den PK der RECH_POS
             if ($rabatt_auch_als_aufschlag == 1) {
                 $sql = "UPDATE RECH_POS
                    SET PKRECHNUNG = :reservNum,  Anzahl = :count, GesamtPreis = (Einzelpreis * :count) + ((Einzelpreis * :count) * ISNULL(rabatt,0) / 100), GroupID = (CASE WHEN(MietRate = 'N') THEN (SELECT MAX(GroupID) FROM rech_pos WHERE PKRECHNUNG = :reservNum)+1 ELSE GroupID END)
                    WHERE PK = :pk";
             } else {
                 $sql = "UPDATE RECH_POS
                        SET PKRECHNUNG = :reservNum,  Anzahl = :count, GesamtPreis = (Einzelpreis * :count) - ((Einzelpreis * :count) * ABS(ISNULL(rabatt,0)) / 100), GroupID = (CASE WHEN(MietRate = 'N') THEN (SELECT MAX(GroupID) FROM rech_pos WHERE PKRECHNUNG = :reservNum)+1 ELSE GroupID END)
                        WHERE PK = :pk";
             }
             $this->getDatabase()->prepare($sql);

             $this->getDatabase()->bindParam(':count', $count);
             $this->getDatabase()->bindParam(':reservNum', $reservNum);
             $this->getDatabase()->bindParam(':pk', $pk);

             foreach ($params['rates_pk'] as $rate) {
                 $count = $rate['count'];
                 $pk = $rate['db_id'];
                 $this->getDatabase()->execute();
             }

             $sql = "INSERT INTO Mietvertraege (
						  VERTRAGSNUMMER,
						  VERMIETSTATION,
                            MVANUMMER,
						  CODEVSTATAN,
						  ABDAT,
						  ABZEIT,
						  KUNDENNUMMER,
  						  VEREINBRUECKGABEDAT,
  						  VEREINRUECKZEIT,
						  OFFENODERCHECKIN,
						  vtc,
						  RESERVIERUNGSNUMMER,
						  RESERVIERUNG,
						  RES_KFZGruppe,
						  RES_ORIG_GRUPPE,
						  RES_KM_GEPL,
						  Inet_Status,
						  PAYMENTCODE,
						  Bemerkungen,
					  	  WizardErfasstCo,
						  WizardErfasstCI,
						  SELBSTBETEILIGUNG ,
						  VERSNR,
						  VALIDTHRU,
						  STATISTIKCODE,
						  kontaktadresse,
						  basenr,
						  AnlageDatum,
						  RATE_CODE,
						  SUM_NETTO,
						  VORRAUSZAHLUNG,
						  VoucherNo,
                            FAH_VORNAME,
                            FAH_NACHNAME,
                            accept_agb,
			                RABATT,
                            druckfahrer
							)
				VALUES (
						  :VERTRAGSNUMMER,
						  :VERMIETSTATION,
                            :MVANUMMER,
						  :CODEVSTATAN,
						  :ABDAT,
						  :ABZEIT,
						  :KUNDENNUMMER,
  						  :VEREINBRUECKGABEDAT,
  						  :VEREINRUECKZEIT,
						  :OFFENODERCHECKIN,
						  :vtc,
						  :RESERVIERUNGSNUMMER,
						  :RESERVIERUNG,
						  :RES_KFZGruppe,
						  :RES_ORIG_GRUPPE,
						  :RES_KM_GEPL,
						  :Inet_Status,
						  :PAYMENTMETHOD + :CARDNO,
						  :Bemerkungen,
					  	  :WizardErfasstCo,
						  :WizardErfasstCI,
						  :SELBSTBETEILIGUNG ,
						  :VERSNR,
						  :VALIDTHRU,
						  :STATISTIKCODE,
						  :kontaktadresse,
						  :basenr,
						  :AnlageDatum,
						  :RATE_CODE,
						  :SUM_NETTO,
						  :VORRAUSZAHLUNG,
						  :VoucherNo,
                        :FAH_VORNAME,
                        :FAH_NACHNAME,
                        :accept_agb,
			            :rabatt,
                        :druckfahrer
						)";
             if ((defined('CONFIG_CHECK_AVAILABILITY') && CONFIG_CHECK_AVAILABILITY == 1) || (defined('CONFIG_SHOW_AVAILABILITY_PLAN') && CONFIG_SHOW_AVAILABILITY_PLAN == 1) || (Module::isEnabled('ORM_AVAILABILITY_PLAN'))) {
                 $dbGroup = new DBCarGroup();
                 $mvanummer = $dbGroup->isGroupAvailable($params['startdate'], $params['enddate'], $params['starttime'], $params['endtime'], $params['startstation'], $params['group_code']);
                 if (!$mvanummer) {
                     $mvanummer == null;
                 }
                 $group = null;
             } else {
                 $mvanummer = null;
             }
             $group = $params['group_code'];
             //print_r($sql2);die;

             $this->getDatabase()->prepare($sql);

             $this->getDatabase()->bindValue(':MVANUMMER', $mvanummer);
             $this->getDatabase()->bindValue(':RES_KFZGruppe', $group); // varchar(2)

             $this->getDatabase()->bindValue(':VERTRAGSNUMMER', $reservNum); // int
             $this->getDatabase()->bindValue(':VERMIETSTATION', $params['startstation']); // varchar
             $this->getDatabase()->bindValue(':CODEVSTATAN', $params['endstation']); // varchar
             $this->getDatabase()->bindValue(':ABDAT', $params['startdate']); // datetime
             $this->getDatabase()->bindValue(':ABZEIT', str_replace(':', '', $params['starttime'])); // varchar(4)
             $this->getDatabase()->bindValue(':KUNDENNUMMER', $user->id); // int
             $this->getDatabase()->bindValue(':VEREINBRUECKGABEDAT', $params['enddate']); // datetime
             $this->getDatabase()->bindValue(':VEREINRUECKZEIT', str_replace(':', '', $params['endtime'])); // varchar(4)
             $this->getDatabase()->bindValue(':OFFENODERCHECKIN', 'O');
             $this->getDatabase()->bindValue(':vtc', 'M');
             $this->getDatabase()->bindValue(':RESERVIERUNGSNUMMER', $reservNum); // varchar
             $this->getDatabase()->bindValue(':RESERVIERUNG', 'J');
             $this->getDatabase()->bindValue(':RES_ORIG_GRUPPE', $params['group_code']); // varchar(2)
             $this->getDatabase()->bindValue(':RES_KM_GEPL', $params['km_add']); // int
             // $this->getDatabase()->bindValue(':Inet_Status', (defined('INET_STATUS') && INET_STATUS == 1) ? 'U' : 'B'); //varchar(2)
             $this->getDatabase()->bindValue(':Inet_Status', $params['INET_STATUS']); // varchar(2)
             $this->getDatabase()->bindValue('PAYMENTMETHOD', $params['pay']->name);
             // AK 27.04.2016 Aufgabe 78531: wenn Kunde Sparmobile dann ohne / speichern
             if (defined('MAND_NUMMER') && MAND_NUMMER === 70332) {
                 $this->getDatabase()->bindValue('CARDNO', $credit_card_number != '' ? $credit_card_number : '');
             } else {
                 $this->getDatabase()->bindValue('CARDNO', $credit_card_number != '' ? '/' . $credit_card_number : '');
             }
             $this->getDatabase()->bindValue(':VALIDTHRU', (isset($params['pay']->credit_card_date) && $params['pay']->credit_card_date != '') ? $params['pay']->credit_card_date : ''); // vchar(8)
             $this->getDatabase()->bindValue(':Bemerkungen', html_entity_decode($params['comment'])); // text
             $this->getDatabase()->bindValue(':WizardErfasstCo', 0); // bit
             $this->getDatabase()->bindValue(':WizardErfasstCI', 0); // bit
             $this->getDatabase()->bindValue(':SELBSTBETEILIGUNG', 0); // float // wird später berechnet
             $this->getDatabase()->bindValue(':VERSNR', 0); // int
             $this->getDatabase()->bindValue(':STATISTIKCODE', '');

             $modul_anfrage = !empty($translate['MODUL_ANFRAGE']) ? $translate['MODUL_ANFRAGE'] : 'Modul - Anfrage';
             $modul_reservierung = !empty($translate['MODUL_RESERVIERUNG']) ? $translate['MODUL_RESERVIERUNG'] : 'Modul - Reservierung';
             $this->getDatabase()->bindValue(':kontaktadresse', (defined('INET_STATUS') && INET_STATUS == 1) ? $modul_anfrage : $modul_reservierung);

             $this->getDatabase()->bindValue(':basenr', $reservNum);
             $this->getDatabase()->bindValue(':AnlageDatum', date('d.m.Y H:i'));
             $this->getDatabase()->bindValue(':RATE_CODE', $params['main_rate_code']);
             $this->getDatabase()->bindValue(':SUM_NETTO', $sumNetto); // ???????
             $this->getDatabase()->bindValue(':VORRAUSZAHLUNG', $prepay); // $paypal == 1 ? VTR_GetBruttoSumme(@RESNO) : 0); // ???????
             $this->getDatabase()->bindValue(':VoucherNo', (isset($params['discount']['code'])) ? $params['discount']['code'] : '');
             $this->getDatabase()->bindValue(':FAH_VORNAME', $user->driver_firstname);
             $this->getDatabase()->bindValue(':FAH_NACHNAME', $user->driver_lastname);
             $this->getDatabase()->bindValue(':accept_agb', $params['accept_agb']);

             // AK 15.10.18 - Aufgabe 99828: Druckfahrer immer auf 1 setzen
             $this->getDatabase()->bindValue(':druckfahrer', 1);

             $rabatt = (isset($params['main_rate_discount'])) ? $params['main_rate_discount'] : 0;
             $this->getDatabase()->bindValue(':rabatt', ($rabatt_auch_als_aufschlag == 1) ? $rabatt : -1 * abs($rabatt));

             $this->getDatabase()->execute();

             $sql = "UPDATE Mietvertraege SET SELBSTBETEILIGUNG = dbo.VTR_GETSB(:reservNum) WHERE VERTRAGSNUMMER = :reservNum";

             $this->getDatabase()->prepare($sql);
             $this->getDatabase()->bindValue(':reservNum', $reservNum);
             $this->getDatabase()->execute();

             if (isset($params['discount']['code'])) {
                 $sql = "UPDATE INET_RABATT SET verwendet = 1 WHERE gutscheincode = :code AND immer_gueltig = 0";
                 $this->getDatabase()->prepare($sql);

                 $this->getDatabase()->bindvalue('code', $params['discount']['code']);
                 $this->getDatabase()->execute();
             }

             $sql = "EXEC RECH_CREATE_ABSCHLUSS @PKRECHNUNG = :reservNum, @ADate = :date";
             $this->getDatabase()->prepare($sql);
             $this->getDatabase()->bindValue(':reservNum', $reservNum);
             $this->getDatabase()->bindValue(':date', $params['enddate'] . ' ' . $params['endtime']);
             $this->getDatabase()->execute();

             $sql = "EXEC RECH_REORDER_POS @PKRECHNUNG = :reservNum";
             $this->getDatabase()->prepare($sql);
             $this->getDatabase()->bindValue(':reservNum', $reservNum);
             $this->getDatabase()->execute();

             if ((int) $params['pay']->auto_pay == 1) {
                 $clientName = substr($user->name_template, 0, 50) . '/' . $params['pay']->name . (!empty($_SESSION['DATA']['PAYID']) ? "/" . $_SESSION['DATA']['PAYID'] : '');

                 $sql = 'SELECT KTO FROM FIBU_FIL_ZA_SK WHERE ZA = :id  AND FIL = :startstation';
                 $this->getDatabase()->prepare($sql);
                 $this->getDatabase()->bindValue(':id', $params['pay']->id);
                 $this->getDatabase()->bindValue(':startstation', $params['startstation']);
                 if ($this->getDatabase()->execute() && ($row = $this->getDatabase()->fetch_assoc()) !== false) {
                     $KTO = $row['KTO'];
                 } else {
                     $sql = 'SELECT StandardKonto FROM dbo.FIBU_ZAHLUNGSARTEN WHERE PK = :id';
                     $this->getDatabase()->prepare($sql);
                     $this->getDatabase()->bindValue(':id', $params['pay']->id);
                     $KTO = ($this->getDatabase()->execute() && ($row = $this->getDatabase()->fetch_assoc()) !== false) ? $row['StandardKonto'] : '';
                 }

                 $sql = "SELECT dbo.VTR_GetBruttoSumme(:reservNum) as brutto";
                 $this->getDatabase()->prepare($sql);
                 $this->getDatabase()->bindValue(':reservNum', $reservNum);
                 $result = $this->getDatabase()->execute();
                 if ($result !== false) {
                     $row = $this->getDatabase()->fetch_assoc();
                 }
                 $brutto = $row['brutto'];

                 $sql = "UPDATE MIETVERTRAEGE SET VORRAUSZAHLUNG = :brutto WHERE VERTRAGSNUMMER = :reservNum";
                 $this->getDatabase()->prepare($sql);
                 $this->getDatabase()->bindValue(':brutto', $brutto);
                 $this->getDatabase()->bindValue(':reservNum', $reservNum);
                 $this->getDatabase()->execute();

                 $sql = "EXEC dbo.FIBU_ZAHLUNG_BUCHEN
							@AZahlDate='" . date('d.m.Y H:i:s') . "',
							@ADate='" . date('d.m.Y H:i:s') . "',
							@AKonto= :user_id,
							@AGGKto= :kto,
							@ABelegNummer=:ABelegNummer,
							@AOPNummer= :AOPNummer,
							@AText= :clientName,
							@ABetrag=:brutto,
							@soll=0,
							@user='WEB',
							@Kost1='',
							@Kost2='',
							@result1 = ''";
                 $this->getDatabase()->prepare($sql);
                 $this->getDatabase()->bindValue(':user_id', $user->id);
                 $this->getDatabase()->bindValue(':kto', $KTO);
                 $this->getDatabase()->bindValue(':clientName', $clientName);
                 $this->getDatabase()->bindValue(':ABelegNummer', "ZA-" . $reservNum);
                 $this->getDatabase()->bindValue(':AOPNummer', "RE" . $reservNum . "-1");
                 $this->getDatabase()->bindValue(':brutto', $brutto);

                 $this->getDatabase()->execute();
             }
             $sql = "EXEC aenderungseintrag @mv = :reservNum, @benutzer = 'WEB'";
             $this->getDatabase()->prepare($sql);
             $this->getDatabase()->bindValue(':reservNum', $reservNum);
             $this->getDatabase()->execute();

             $this->getDatabase()->commit();
         } catch (PDOException $e) {
             $this->getDatabase()->rollBack();
             $reservNum = 0;
             // echo $e->getMessage() . "<br>" . $this->getDatabase()->last_message() . "<br>" . $sql . "<br>";
             echo $e->getMessage() . "<br>";
         }

         if ($no_login) {
             $user->tmp_num = $user->id;
             $user->id = 0;
             $params['user'] = $user;
         }

         return $reservNum;
     }
     // Save()
     public function SaveIndMobilespace($params)
     {
         $registry = Registry::getInstance();
         $dbparams = $registry->params;
         $sumNetto = 0;
         $prepay = 0;
         $paypal = 0;
         $reservNum = 0;
         $user = $params['user'];
         $no_login = false;

         $dbTranslate = new DBTranslate();
         $lang = Session::getLang();
         $translate = $dbTranslate->loadTranslations('CONFIRM', $lang);

         try {
             $this->getDatabase()->beginTransaction();

             $next_user_id = 0;

             if ($user->id == 0) {
                 $no_login = true;

                 $sql = "INSERT INTO KUNDEN (
							NUMMER,
							Anrede,
							Vorname,
							Nachname,
							NAME1,
							NAME2,
							STRASSE,
							PLZ,
							ORT,
							EMail,
							Telefonnummer,
							Tmp,
							allow_marketing,
							kknummer,
							validthru,
							filiale,
							inetemail,
							inetpasswort,
							inetzugangaktiv,
							firma,
                            F_HRERSCHEINNR,
                            GEBDAT)
						VALUES(
							:KDNUMMER,
							:CUSTOMER_ANREDE,
							:CUSTOMER_VORNAME,
							:CUSTOMER_NACHNAME,
							:NAME1_TEMPLATE,
							:NAME2_TEMPLATE,
							:CUSTOMER_STRASSE,
							:CUSTOMER_PLZ,
							:CUSTOMER_ORT,
							:CUSTOMER_EMAIL,
							:CUSTOMER_PHONE,
							:CUSTOMER_TMP,
							0,
							:PAYMENTMETHOD + :CARDNO,
							:GUELTDATE,
							:STARTSTATION,
							:INETEMAIL,
							:INETPASSWORD,
							:INETZUGANGAKTIV,
							:istFirma,
                            :F_HRERSCHEINNR,
                            :GEBDAT)";

                 if (!empty($params['pay']->credit_card_number)) {
                     $credit_card_number = preg_replace('/[^0-9]/', '', $params['pay']->credit_card_number);
                 } else {
                     $credit_card_number = '';
                 }

                 // --------------------------------------
                 $customer_tmp = ($dbparams->getValue('BINET_KUNDE_TMP') == '1') ? 0 : 1;
                 $inetzugangaktiv = ($dbparams->getValue('BINET_KUNDE_LOGIN_NO_CONFIRM') == '1') ? 1 : 0;

                 if ($params['pay']->name == $dbparams->getValue('PAYPAL_NAME') || $params['pay']->name == $dbparams->getValue('CONCARDIS_NAME')) {
                     $customer_tmp = 0;
                 }
                 $next_user_id = $this->getnextKundenPk($customer_tmp, $params['startstation']);

                 if ($next_user_id <= 0) {
                     unset($_SESSION['DATA']['customer']);
                     goError('Kann nicht Kundennummer anlegen');
                 }

                 // --------------------------------------

                 $this->getDatabase()->prepare($sql);

                 $this->getDatabase()->bindValue('KDNUMMER', $next_user_id);
                 $this->getDatabase()->bindValue('CUSTOMER_ANREDE', $user->anrede);
                 $this->getDatabase()->bindValue('CUSTOMER_VORNAME', '');
                 $this->getDatabase()->bindValue('CUSTOMER_NACHNAME', '');
                 $this->getDatabase()->bindValue('CUSTOMER_STRASSE', $user->street);
                 $this->getDatabase()->bindValue('CUSTOMER_PLZ', $user->zipcode);
                 $this->getDatabase()->bindValue('CUSTOMER_ORT', $user->city);
                 $this->getDatabase()->bindValue('CUSTOMER_EMAIL', '');
                 $this->getDatabase()->bindValue('CUSTOMER_PHONE', '');
                 // AK 16.10.2014 - : Wenn Parameter BINET_KUNDE_TMP = 1, dann Kunde nicht temporär
                 $this->getDatabase()->bindValue('CUSTOMER_TMP', $customer_tmp);
                 $this->getDatabase()->bindValue('PAYMENTMETHOD', $params['pay']->name);
                 $this->getDatabase()->bindValue('CARDNO', $credit_card_number != '' ? '/' . $credit_card_number : '');
                 $this->getDatabase()->bindValue('GUELTDATE', (isset($params['pay']->credit_card_date) && $params['pay']->credit_card_date != '') ? $params['pay']->credit_card_date : '');
                 $this->getDatabase()->bindValue('STARTSTATION', $params['startstation']);
                 $this->getDatabase()->bindValue('INETEMAIL', $user->email);
                 $this->getDatabase()->bindValue('INETPASSWORD', $this->registry->inet_password);
                 // AK 16.10.2014 - Aufgabe 60548: Wenn Parameter BINET_KUNDE_LOGIN_NO_CONFIRM = 1, dann Zugang sofort aktiv
                 $this->getDatabase()->bindValue('INETZUGANGAKTIV', $inetzugangaktiv);
                 $this->getDatabase()->bindValue('NAME1_TEMPLATE', substr(($user->isCompany) ? $user->firma : $user->name_template, 0, 50));
                 $this->getDatabase()->bindValue('NAME2_TEMPLATE', substr(($user->isCompany) ? $user->name_template : null, 0, 50));
                 $this->getDatabase()->bindValue('istFirma', ($user->isCompany) ? 'J' : 'N');
                 $this->getDatabase()->bindValue('F_HRERSCHEINNR', $user->drive_licens);
                 $this->getDatabase()->bindValue('GEBDAT', ($user->birthday != '') ? $user->birthday : null);

                 $this->getDatabase()->execute();

                 $user->id = $next_user_id;
             }

             $this->getDatabase()->proc_exec('aenderungseintrag_Kunden', array(
                'kdnummer' => $user->id,
                'benutzer' => 'WEB',
             ));

             $reservNum = $this->getNextReservNum($params['startstation']);

             $sql = "DELETE FROM RECH_POS
                    WHERE PKRECHNUNG = :reservNum";
             $this->getDatabase()->prepare($sql);
             $this->getDatabase()->bindValue(':reservNum', $reservNum);
             $this->getDatabase()->execute();

             $sql = "UPDATE RECH_POS
                    SET PKRECHNUNG = :reservNum,  Anzahl = :count1, GesamtPreis = Einzelpreis * :count2
                    WHERE PK = :pk";
             $this->getDatabase()->prepare($sql);

             $this->getDatabase()->bindParam(':count1', $count1);
             $this->getDatabase()->bindParam(':count2', $count1);
             $this->getDatabase()->bindParam(':reservNum', $reservNum);
             $this->getDatabase()->bindParam(':pk', $pk);

             foreach ($params['rates_pk'] as $rate) {
                 $count1 = $rate['count'];
                 $pk = $rate['db_id'];
                 $this->getDatabase()->execute();
             }

             $sql = "INSERT INTO Mietvertraege (
						  VERTRAGSNUMMER,
						  VERMIETSTATION,
                            MVANUMMER,
						  CODEVSTATAN,
						  ABDAT,
						  ABZEIT,
						  KUNDENNUMMER,
  						  VEREINBRUECKGABEDAT,
  						  VEREINRUECKZEIT,
						  OFFENODERCHECKIN,
						  vtc,
						  RESERVIERUNGSNUMMER,
						  RESERVIERUNG,
						  RES_KFZGruppe,
						  RES_ORIG_GRUPPE,
						  RES_KM_GEPL,
						  Inet_Status,
						  PAYMENTCODE,
						  Bemerkungen,
					  	  WizardErfasstCo,
						  WizardErfasstCI,
						  SELBSTBETEILIGUNG ,
						  VERSNR,
						  VALIDTHRU,
						  STATISTIKCODE,
						  kontaktadresse,
						  bemerkung,
						  SONDERKOND2,
						  kostenstellkunde,
						  basenr,
						  AnlageDatum,
						  RATE_CODE,
						  SUM_NETTO,
						  VORRAUSZAHLUNG,
						  VoucherNo,
                            FAH_VORNAME,
                            FAH_NACHNAME
							)
				VALUES (
						  :VERTRAGSNUMMER,
						  :VERMIETSTATION,
                            :MVANUMMER,
						  :CODEVSTATAN,
						  :ABDAT,
						  :ABZEIT,
						  :KUNDENNUMMER,
  						  :VEREINBRUECKGABEDAT,
  						  :VEREINRUECKZEIT,
						  :OFFENODERCHECKIN,
						  :vtc,
						  :RESERVIERUNGSNUMMER,
						  :RESERVIERUNG,
						  :RES_KFZGruppe,
						  :RES_ORIG_GRUPPE,
						  :RES_KM_GEPL,
						  :Inet_Status,
						  :PAYMENTMETHOD + :CARDNO,
						  :Bemerkungen,
					  	  :WizardErfasstCo,
						  :WizardErfasstCI,
						  :SELBSTBETEILIGUNG ,
						  :VERSNR,
						  :VALIDTHRU,
						  :STATISTIKCODE,
						  :kontaktadresse,
						  :bemerkung,
						  :SONDERKOND2,
						  :kostenstellkunde,
						  :basenr,
						  :AnlageDatum,
						  :RATE_CODE,
						  :SUM_NETTO,
						  :VORRAUSZAHLUNG,
						  :VoucherNo,
                        :FAH_VORNAME,
                        :FAH_NACHNAME
						)";
             if ((defined('CONFIG_CHECK_AVAILABILITY') && CONFIG_CHECK_AVAILABILITY == 1) || (defined('CONFIG_SHOW_AVAILABILITY_PLAN') && CONFIG_SHOW_AVAILABILITY_PLAN == 1) || (Module::isEnabled('ORM_AVAILABILITY_PLAN'))) {
                 $dbGroup = new DBCarGroup();

                 $mvanummer = $dbGroup->isGroupAvailable($params['startdate'], $params['enddate'], $params['starttime'], $params['endtime'], $params['startstation'], $params['group_code']);
             } else {
                 $mvanummer = null;
                 $group = $params['group_code'];
             }
             $this->getDatabase()->prepare($sql);

             $this->getDatabase()->bindValue(':MVANUMMER', $mvanummer);
             $this->getDatabase()->bindValue(':RES_KFZGruppe', $group); // varchar(2)

             $this->getDatabase()->bindValue(':VERTRAGSNUMMER', $reservNum); // int
             $this->getDatabase()->bindValue(':VERMIETSTATION', $params['startstation']); // varchar
             $this->getDatabase()->bindValue(':CODEVSTATAN', $params['endstation']); // varchar
             $this->getDatabase()->bindValue(':ABDAT', $params['startdate']); // datetime
             $this->getDatabase()->bindValue(':ABZEIT', str_replace(':', '', $params['starttime'])); // varchar(4)
             $this->getDatabase()->bindValue(':KUNDENNUMMER', $user->id); // int
             $this->getDatabase()->bindValue(':VEREINBRUECKGABEDAT', $params['enddate']); // datetime
             $this->getDatabase()->bindValue(':VEREINRUECKZEIT', str_replace(':', '', $params['endtime'])); // varchar(4)
             $this->getDatabase()->bindValue(':OFFENODERCHECKIN', 'O');
             $this->getDatabase()->bindValue(':vtc', 'M');
             $this->getDatabase()->bindValue(':RESERVIERUNGSNUMMER', $reservNum); // varchar
             $this->getDatabase()->bindValue(':RESERVIERUNG', 'J');
             $this->getDatabase()->bindValue(':RES_ORIG_GRUPPE', $params['group_code']); // varchar(2)
             $this->getDatabase()->bindValue(':RES_KM_GEPL', $params['km_add']); // int
             // $this->getDatabase()->bindValue(':Inet_Status', (defined('INET_STATUS') && INET_STATUS == 1) ? 'U' : 'B'); //varchar(2)
             $this->getDatabase()->bindValue(':Inet_Status', $params['INET_STATUS']); // varchar(2)
             $this->getDatabase()->bindValue(':PAYMENTMETHOD', $params['pay']->name);
             $this->getDatabase()->bindValue(':CARDNO', $credit_card_number != '' ? '/' . $credit_card_number : '');
             $this->getDatabase()->bindValue(':VALIDTHRU', (isset($params['pay']->credit_card_date) && $params['pay']->credit_card_date != '') ? $params['pay']->credit_card_date : ''); // vchar(8)
             $this->getDatabase()->bindValue(':Bemerkungen', $params['comment']); // text
             $this->getDatabase()->bindValue(':WizardErfasstCo', 0); // bit
             $this->getDatabase()->bindValue(':WizardErfasstCI', 0); // bit
             $this->getDatabase()->bindValue(':SELBSTBETEILIGUNG', 0); // float // wird später berechnet
             $this->getDatabase()->bindValue(':VERSNR', 0); // int
             $this->getDatabase()->bindValue(':STATISTIKCODE', '');

             $modul_anfrage = !empty($translate['MODUL_ANFRAGE']) ? $translate['MODUL_ANFRAGE'] : 'Modul - Anfrage';
             $modul_reservierung = !empty($translate['MODUL_RESERVIERUNG']) ? $translate['MODUL_RESERVIERUNG'] : 'Modul - Reservierung';
             // $this->getDatabase()->bindValue(':kontaktadresse', (defined('INET_STATUS') && INET_STATUS == 1) ? $modul_anfrage : $modul_reservierung);
             $this->getDatabase()->bindValue(':kontaktadresse', $params['projekt'] . " / " . substr($user->name_template, 0, 50) . " " . $user->email . " /  / " . $user->phone);
             $this->getDatabase()->bindValue(':bemerkung', $params['projekt']);
             $this->getDatabase()->bindValue(':SONDERKOND2', substr($user->name_template, 0, 50) . " " . $user->email);
             $this->getDatabase()->bindValue(':kostenstellkunde', $user->phone);

             $this->getDatabase()->bindValue(':basenr', $reservNum);
             $this->getDatabase()->bindValue(':AnlageDatum', date('d.m.Y H:i'));
             $this->getDatabase()->bindValue(':RATE_CODE', $params['main_rate_code']);
             $this->getDatabase()->bindValue(':SUM_NETTO', $sumNetto); // ???????
             $this->getDatabase()->bindValue(':VORRAUSZAHLUNG', $prepay); // $paypal == 1 ? VTR_GetBruttoSumme(@RESNO) : 0); // ???????
             $this->getDatabase()->bindValue(':VoucherNo', (isset($params['discount']['code'])) ? $params['discount']['code'] : '');
             $this->getDatabase()->bindValue(':FAH_VORNAME', $user->driver_firstname);
             $this->getDatabase()->bindValue(':FAH_NACHNAME', $user->driver_lastname);

             $this->getDatabase()->execute();

             $sql = "UPDATE Mietvertraege SET SELBSTBETEILIGUNG = dbo.VTR_GETSB(:reservNum) WHERE VERTRAGSNUMMER =:reservNum";
             $this->getDatabase()->prepare($sql);
             $this->getDatabase()->bindValue(':reservNum', $reservNum);
             $this->getDatabase()->execute();

             if (isset($params['discount']['code'])) {
                 $sql = "UPDATE INET_RABATT SET verwendet = 1 WHERE gutscheincode = :code AND immer_gueltig = 0";
                 $this->getDatabase()->prepare($sql);

                 $this->getDatabase()->bindvalue('code', $params['discount']['code']);
                 $this->getDatabase()->execute();
             }

             $sql = "EXEC RECH_CREATE_ABSCHLUSS @PKRECHNUNG = :reservNum, @ADate = :date";
             $this->getDatabase()->prepare($sql);
             $this->getDatabase()->bindValue(':reservNum', $reservNum);
             $this->getDatabase()->bindValue(':date', $params['enddate'] . ' ' . $params['endtime']);
             $this->getDatabase()->execute();

             $sql = "EXEC aenderungseintrag @mv = :reservNum, @benutzer = 'WEB'";
             $this->getDatabase()->prepare($sql);
             $this->getDatabase()->bindValue(':reservNum', $reservNum);
             $this->getDatabase()->execute();

             if ($params['pay']->auto_pay == 1) {
                 $clientName = substr($user->name_template, 0, 50) . "/" . $params['pay']->name . (!empty($_SESSION['DATA']['PAYID']) ? "/" . $_SESSION['DATA']['PAYID'] : "");

                 $sql = "SELECT KTO FROM FIBU_FIL_ZA_SK WHERE ZA = :id AND FIL = :startstation";
                 $this->getDatabase()->prepare($sql);
                 $this->getDatabase()->bindValue(':id', $params['pay']->id);
                 $this->getDatabase()->bindValue(':startstation', $params['startstation']);
                 $result = $this->getDatabase()->execute();

                 if ($result !== false) {
                     $row = $this->getDatabase()->fetch_assoc();
                     $KTO = $row['KTO'];
                 } else {
                     $KTO = '';
                 }

                 $sql = "SELECT dbo.VTR_GetBruttoSumme(:reservNum) as brutto";
                 $this->getDatabase()->prepare($sql);
                 $this->getDatabase()->bindValue(':reservNum', $reservNum);
                 $result = $this->getDatabase()->execute();
                 if ($result !== false) {
                     $row = $this->getDatabase()->fetch_assoc();
                     $brutto = $row['brutto'];
                 }

                 $sql = "UPDATE MIETVERTRAEGE SET VORRAUSZAHLUNG = :brutto WHERE VERTRAGSNUMMER = :reservNum";
                 //$this->db->exec($sql);
                 $this->getDatabase()->prepare($sql);
                 $this->getDatabase()->bindValue(':brutto', $brutto);
                 $this->getDatabase()->bindValue(':reservNum', $reservNum);
                 $this->getDatabase()->execute();

                 $sql = "EXEC aenderungseintrag @mv = :reservNum, @benutzer = 'WEB'";
                 $this->getDatabase()->prepare($sql);
                 $this->getDatabase()->bindValue(':reservNum', $reservNum);
                 $this->getDatabase()->execute();

                 $sql = "EXEC dbo.FIBU_ZAHLUNG_BUCHEN
							@AZahlDate='" . date('d.m.Y H:i:s') . "',
							@ADate='" . date('d.m.Y H:i:s') . "',
							@AKonto= :user_id,
							@AGGKto= :kto,
							@ABelegNummer=:ABelegNummer,
							@AOPNummer= :AOPNummer,
							@AText= :clientName,
							@ABetrag=:brutto,
							@soll=0,
							@user='WEB',
							@Kost1='',
							@Kost2='',
							@result1 = ''";
                 $this->getDatabase()->prepare($sql);
                 $this->getDatabase()->bindValue(':user_id', $user->id);
                 $this->getDatabase()->bindValue(':kto', $KTO);
                 $this->getDatabase()->bindValue(':clientName', $clientName);
                 $this->getDatabase()->bindValue(':ABelegNummer', "ZA-" . $reservNum);
                 $this->getDatabase()->bindValue(':AOPNummer', "RE" . $reservNum . "-1");
                 $this->getDatabase()->bindValue(':brutto', $brutto);

                 $this->getDatabase()->execute();
             }

             $this->getDatabase()->commit();
         } catch (PDOException $e) {
             $this->getDatabase()->rollBack();
             $reservNum = 0;
             // echo $e->getMessage() . "<br>" . $this->getDatabase()->last_message() . "<br>" . $sql . "<br>";
             echo $e->getMessage() . "<br>";
         }

         if ($no_login) {
             $user->tmp_num = $user->id;
             $user->id = 0;
             $params['user'] = $user;
         }

         return $reservNum;
     }
     // SaveIndMobilespace()
     public function getByCustomer($customer_id, $order_id = 0)
     {
         $dbTranslate = new DBTranslate();
         $translate = $dbTranslate->loadTranslations('BUCHUNGSLISTE');
         $orders = array();
         if ((int) $order_id == 0) {
             $sql = 'SELECT * FROM MIETVERTRAEGE WHERE KUNDENNUMMER = :customer_id ORDER BY ABDAT DESC, ABZEIT DESC';
         } else {
             $sql = 'SELECT * FROM MIETVERTRAEGE WHERE KUNDENNUMMER = :customer_id AND VERTRAGSNUMMER = :order_id';
         }
         $this->getDatabase()->prepare($sql);
         $this->getDatabase()->bindValue(':customer_id', $customer_id);
         if ($order_id != 0) {
             $this->getDatabase()->bindValue(':order_id', (int) $order_id);
         }
         $this->getDatabase()->execute();

         foreach ($this->getDatabase()->fetch_all() as $dbOrder) {
             $order = new Order();
             $order->id = $dbOrder['VERTRAGSNUMMER'];
             $order->customerId = $customer_id;

             $dbStation = new DBStation();
             $order->depatureStation = $dbStation->getStationByCode($dbOrder['VERMIETSTATION']);
             // $order->arrivalStation = ! empty($dbOrder['RUECKGABESTATION']) ? $dbStation->getStationByCode($dbOrder['RUECKGABESTATION']) : $order->depatureStation;

             if ($dbOrder['Reservierung'] == 'J' && $dbOrder['OFFENODERCHECKIN'] == 'O') {
                 $order->status = 'reservierung';
                 $order->arrivalStation = $dbStation->getStationByCode($dbOrder['CODEVSTATAN']);
             } elseif ($dbOrder['Reservierung'] == 'N' && $dbOrder['OFFENODERCHECKIN'] == 'O') {
                 $order->status = 'in_rent';
                 $order->arrivalStation = $dbStation->getStationByCode($dbOrder['CODEVSTATAN']);
             } else {
                 $order->arrivalStation = $dbStation->getStationByCode($dbOrder['CODESTATAN']);

                 $sql = 'SELECT PKRechnung FROM RECH_REL_MIETVERTRAEGE WHERE main = 1 AND PKMietvertraege = ' . (int) $order->id;
                 $this->getDatabase()->query($sql);
                 $invoice = $this->getDatabase()->fetch_assoc();
                 if (!empty($invoice['PKRechnung'])) {
                     $order->invoice = $invoice['PKRechnung'];
                 }
                 if (!empty($order->invoice)) {
                     $order->status = 'abgerechnet';
                 } else {
                     $order->status = 'abgeschlossen';
                 }
             }
             $order->driver = array(
                'firstname' => $dbOrder['FAH_VORNAME'],
                'lastname' => $dbOrder['FAH_NACHNAME'],
             );
             $order->orderDate = date('Y-m-d H:i', strtotime($dbOrder['AnlageDatum']));
             $order->departureDate = date('Y-m-d', strtotime($dbOrder['ABDAT']));
             $order->arrivalDate = date('Y-m-d', strtotime($dbOrder['VEREINBRUECKGABEDAT']));
             $order->realArrivalDate = date('Y-m-d', strtotime($dbOrder['ANDAT']));

             $order->departureTime = substr($dbOrder['ABZEIT'], 0, 2) . ':' . substr($dbOrder['ABZEIT'], 2, 2);
             $order->arrivalTime = substr($dbOrder['VEREINRUECKZEIT'], 0, 2) . ':' . substr($dbOrder['VEREINRUECKZEIT'], 2, 2);
             $order->realArrivalTime = substr($dbOrder['ANZEIT'], 0, 2) . ':' . substr($dbOrder['ANZEIT'], 2, 2);

             $dbCars = new DBCarGroup();
             $order->fzg_gruppe = $dbCars->getGroupByCode($dbOrder['RES_ORIG_GRUPPE']);
             $order->auto = (!empty($dbOrder['MVANUMMER'])) ? $dbCars->getAuto($dbOrder['MVANUMMER']) : '';
             $order->paymethode = $dbOrder['PAYMENTCODE'];

             $sql = 'select * from rech_pos where PKRECHNUNG = :pkrechnung order by pos asc';
             $this->getDatabase()->prepare($sql);
             $this->getDatabase()->bindValue(':pkrechnung', $dbOrder['VERTRAGSNUMMER']);
             $this->getDatabase()->execute();

             $orderDetails = array();
             foreach ($this->getDatabase()->fetch_all() as $dbOrderDetails) {
                 if ($dbOrderDetails['MietRate'] == 'J') {
                     $orderDetails['main_rate'][] = $dbOrderDetails;
                 } elseif ($dbOrderDetails['Pos'] < 99990) {
                     if ($dbOrderDetails['Rate'] == 'KM') {
                         $orderDetails['KM'] = $dbOrderDetails;
                     } else {
                         $orderDetails['sub_rate'][] = $dbOrderDetails;
                     }
                 } else {
                     $orderDetails[str_replace('.', '', $dbOrderDetails['Rate'])] = $dbOrderDetails;
                 }
             }

             if (empty($orderDetails['KM'])) {
                 $orderDetails['KM'] = false;
             }

             $order->details = $orderDetails;

             $orders[] = $order;
         }

         return $orders;
     }
     // getByCustomer()
     public function getInvoice($invoice_number)
     {
         $sql = "SELECT Beleg
                FROM DOCS_DOCS LEFT JOIN DOCS_REL_OBJ
                ON DOCS_DOCS.PK = DOCS_REL_OBJ.PK_DOCS
                WHERE DOCS_REL_OBJ.PK_FREMD = :invoice_number AND PK_Belegart = 'Ausgangsrechnung'";
         $this->getDatabase()->prepare($sql);
         $this->getDatabase()->bindValue(':invoice_number', $invoice_number);
         $this->getDatabase()->execute();
         $row = $this->getDatabase()->fetch_assoc();

         return !empty($row['Beleg']) ? $row['Beleg'] : null;
     }
     // getInvoice()
     public function getnextKundenPk($tmp_kunden_nummer = 0, $station)
     {
         $kunden_id = 0;
         $dbMandant = new DBMandant();
         $mandant = $dbMandant->getInfo();

         $kunden_category = Params::getValue('SINET_KAT_KUNDE_WEB');
         $kunden_category = !empty($kunden_category) ? $kunden_category : '';
         if (!empty($mandant->Kundenkategorien) && !empty($kunden_category)) {
             $sql = "SELECT dbo.KUNDEN_GET_KAT_PK(:kunden_category)";
             $this->getDatabase()->prepare($sql);
             $this->getDatabase()->bindValue(':kunden_category', $kunden_category);
             $result = $this->getDatabase()->execute();
             if ($result !== false) {
                 $row = $this->getDatabase()->fetch_all();
                 if (!empty($row[0])) {
                     $kunden_id = array_shift($row[0]);
                 }
             }
         } else {
             if (!$tmp_kunden_nummer) {
                 $kpk_tanle = 'KPK';
                 $sql = "SELECT KPKKennz FROM stammt WHERE station=:station";
                 $this->getDatabase()->prepare($sql);
                 $this->getDatabase()->bindValue(':station', $station);
                 $result = $this->getDatabase()->execute();
                 if ($result !== false) {
                     $dbObj = $this->getDatabase()->fetch_obj();
                 }
                 $kpk_tanle = $dbObj->KPKKennz;

                 while (true) {
                     $sql = "EXEC dbo.inet_get_next_pk @ATablename = :kpk_tanle,@newvalue = 0";
                     $this->getDatabase()->prepare($sql);
                     $this->getDatabase()->bindValue(':kpk_tanle', $kpk_tanle);
                     $result = $this->getDatabase()->execute();
                     if ($result !== false) {
                         $dbObj = $this->getDatabase()->fetch_obj();
                     }

                     $sql = 'SELECT NUMMER FROM KUNDEN WHERE NUMMER = ' . (int) $dbObj->PK;
                     $this->getDatabase()->query($sql);
                     $row = $this->getDatabase()->fetch_assoc();
                     if (empty($row)) {
                         break;
                     }
                 }
                 $kunden_id = (int) $dbObj->PK;
             } else {
                 while (true) {
                     $this->getDatabase()->query("EXEC dbo.inet_get_next_pk @ATablename = 'TMP_KUNDE',@newvalue = 0");
                     $dbObj = $this->getDatabase()->fetch_obj();

                     $sql = 'SELECT NUMMER FROM KUNDEN WHERE NUMMER = ' . (int) $dbObj->PK;
                     $this->getDatabase()->query($sql);
                     $row = $this->getDatabase()->fetch_assoc();
                     if (empty($row)) {
                         break;
                     }
                 }
                 $kunden_id = (int) $dbObj->PK;
             }
         }

         return $kunden_id > 0 ? $kunden_id : 0;
     }
     public function is_canceled($contract_id)
     {
         $sql = "SELECT INET_STATUS FROM MIETVERTRAEGE WHERE VERTRAGSNUMMER = :contract_id";
         $this->getDatabase()->prepare($sql);
         $this->getDatabase()->bindValue(':contract_id', $contract_id);
         $this->getDatabase()->execute();
         $row = $this->getDatabase()->fetch_assoc();
         return !empty($row['INET_STATUS']) ? $row['INET_STATUS'] : null;
     }
 } //Class DBReservation
