<?php

class DBTranslate extends DBBase
{
    public function loadTranslations($name, $language = '')
    {
        if (empty($language)) {
            $language = Session::getLang();
        }
        $language = strtoupper($language);
        $translation = array();
        if (!isset($_SESSION['TRANSLATIONS'][$language][$name])) {
            $this->getDatabase()->proc_exec('LANG_GET_COMPONENTS', array(
                'form_prefix' => $name,
                'lang' => $language,
            ));
            $rows = $this->getDatabase()->fetch_all('assoc');
            foreach ($rows as $value) {
                if (strpos(trim($value['COMPONENT']), $name . '.') === 0) {
                    $key = substr_replace(trim($value['COMPONENT']), '', 0, strlen($name) + 1);
                } else {
                    $key = trim($value['COMPONENT']);
                }

                $translation[$key] = trim($value['TEXT']);
            }

            if ($name == 'GRUPPE') {
                $crent_name = 'crent.grouptitle';
                $this->getDatabase()->proc_exec('LANG_GET_COMPONENTS', array(
                    'form_prefix' => $crent_name,
                    'lang' => $language,
                ));
                $rows = $this->getDatabase()->fetch_all('assoc');
                foreach ($rows as $value) {
                    $component = explode('.', $value['COMPONENT']);
                    $translation['TITLE'][md5($component[count($component) - 1])] = trim($value['TEXT']);
                }

                $crent_name = 'crent.groupdescription';
                $this->getDatabase()->proc_exec('LANG_GET_COMPONENTS', array(
                    'form_prefix' => $crent_name,
                    'lang' => $language,
                ));
                $rows = $this->getDatabase()->fetch_all('assoc');
                foreach ($rows as $value) {
                    $component = explode('.', $value['COMPONENT']);
                    $translation['DESCRIPTION'][md5($component[count($component) - 1])] = trim($value['TEXT']);
                }

                $crent_name = 'crent.groupdescription2';
                $this->getDatabase()->proc_exec('LANG_GET_COMPONENTS', array(
                    'form_prefix' => $crent_name,
                    'lang' => $language,
                ));
                $rows = $this->getDatabase()->fetch_all('assoc');
                foreach ($rows as $value) {
                    $component = explode('.', $value['COMPONENT']);
                    $translation['DESCRIPTION2'][md5($component[count($component) - 1])] = trim($value['TEXT']);
                }

                $crent_name = 'crent.groupcategorie';
                $this->getDatabase()->proc_exec('LANG_GET_COMPONENTS', array(
                    'form_prefix' => $crent_name,
                    'lang' => $language,
                ));
                $rows = $this->getDatabase()->fetch_all('assoc');
                foreach ($rows as $value) {
                    $component = explode('.', $value['COMPONENT']);
                    $translation['KATEGORIE'][md5($component[count($component) - 1])] = trim($value['TEXT']);
                }
            }

            if ($name == 'RATE') {
                $crent_name = 'crent.ratedata';
                $this->getDatabase()->proc_exec('LANG_GET_COMPONENTS', array(
                    'form_prefix' => $crent_name,
                    'lang' => $language,
                ));
                $rows = $this->getDatabase()->fetch_all('assoc');
                foreach ($rows as $value) {
                    $component = explode('.', $value['COMPONENT']);
                    if (count($component) > 3) {
                        $translation['DESCRIPTION'][md5($component[2])][md5($component[3])] = trim($value['TEXT']);
                    }
                }

                $crent_name = 'crent.ratedata2';
                $this->getDatabase()->proc_exec('LANG_GET_COMPONENTS', array(
                    'form_prefix' => $crent_name,
                    'lang' => $language,
                ));
                $rows = $this->getDatabase()->fetch_all('assoc');
                foreach ($rows as $value) {
                    $component = explode('.', $value['COMPONENT']);
                    if (count($component) > 3) {
                        $translation['DESCRIPTION2'][md5($component[2])][md5($component[3])] = trim($value['TEXT']);
                    }
                }
                $crent_name = 'crent.ratecategorie';
                $this->getDatabase()->proc_exec('LANG_GET_COMPONENTS', array(
                    'form_prefix' => $crent_name,
                    'lang' => $language,
                ));
                $rows = $this->getDatabase()->fetch_all('assoc'); 
                foreach ($rows as $value) {
                    $component = explode('.', $value['COMPONENT']);
                    $translation['CATEGORY'][$component[count($component) - 1]] = trim($value['TEXT']);
                }                
            }

            if ($name == 'PAYMENT') {
                $crent_name = 'crent.paymentdataRE';
                $this->getDatabase()->proc_exec('LANG_GET_COMPONENTS', array(
                    'form_prefix' => $crent_name,
                    'lang' => $language,
                ));
                $rows = $this->getDatabase()->fetch_all('assoc');
                foreach ($rows as $value) {
                    $component = explode('.', $value['COMPONENT']);
                    $translation[md5($component[count($component) - 1])] = trim($value['TEXT']);
                }
            }

            if ($name == 'CURRENCY') {
                $crent_name = 'crent.currencydata';
                $this->getDatabase()->proc_exec('LANG_GET_COMPONENTS', array(
                    'form_prefix' => $crent_name,
                    'lang' => $language,
                ));
                $rows = $this->getDatabase()->fetch_all('assoc');
                foreach ($rows as $value) {
                    $component = explode('.', $value['COMPONENT']);
                    $translation[$component[count($component) - 1]] = trim($value['TEXT']);
                }
            }

            if ($name == 'FEIERTAGE') {
                $crent_name = 'crent.holidaydata';
                $this->getDatabase()->proc_exec('LANG_GET_COMPONENTS', array(
                    'form_prefix' => $crent_name,
                    'lang' => $language,
                ));
                $rows = $this->getDatabase()->fetch_all('assoc');
                foreach ($rows as $value) {
                    // $component = explode('.', $value['COMPONENT']);
                    // $translation[$component[count($component) - 1]] = trim($value['TEXT']);
                    $component = str_replace($crent_name . '.', '', $value['COMPONENT']);
                    $translation[$component] = trim($value['TEXT']);
                }
            }

            if ($name == 'LOGIN') {
                $tmp = [];
                foreach ($translation as $k => $v) {
                    $tmp[str_replace('Login.', '', $k)] = $v;
                }
                $translation = $tmp;
            }
            $_SESSION['TRANSLATIONS'][$language][$name] = $translation;
        }
        return $_SESSION['TRANSLATIONS'][$language][$name];
    }

    public function initTranslations($name, $pattern, $language, $updateFlag = false)
    {
        $language = strtoupper($language);
        $translation = array();

        $this->getDatabase()->proc_exec('LANG_GET_COMPONENTS', array(
            'form_prefix' => $name,
            'lang' => $language,
        ));
        $rows = $this->getDatabase()->fetch_all('assoc');
        foreach ($rows as $value) {
            if (strpos(trim($value['COMPONENT']), $name . '.') === 0) {
                $key = substr_replace(trim($value['COMPONENT']), '', 0, strlen($name) + 1);
            } else {
                $key = trim($value['COMPONENT']);
            }

            $translation[$key] = trim($value['TEXT']);
        }

        foreach ($pattern as $key => $value) {
            if (!$updateFlag) {
                if (!key_exists($key, $translation)) {
                    $this->getDatabase()->proc_exec('LANG_ADD_COMPONENT', array(
                        'comp' => $name . "." . $key,
                        'text' => $value,
                        'lang' => $language,
                    ));
                }
            } else {
                $this->getDatabase()->proc_exec('LANG_ADD_COMPONENT', array(
                    'comp' => $name . "." . $key,
                    'text' => $value,
                    'lang' => $language,
                    'update' => 1,
                ));
            }
        }
    }

    public function initTexte($name, $pattern, $language, $updateFlag = false)
    {
        $language = strtoupper($language);
        $translation = array();

        /*
        TODO

        wenn nötig texte speichern

         */

        $sql = 'SELECT count(*) as count FROM texte WHERE code = :code AND Sprache = :lang';
        $this->getDatabase()->prepare($sql);
        $this->getDatabase()->bindValue(':code', $name);
        $this->getDatabase()->bindValue(':lang', $language);
        $result = $this->getDatabase()->execute();

        if ($result !== false) {
            $text = $this->getDatabase()->fetch_obj();

            if ($text->count == 0) {
                $sql = "
                    INSERT INTO dbo.texte
                        ( mem ,
                          Beschreibung ,
                          nummer ,
                          Code ,
                          Gruppe ,
                          Sprache ,
                          BILD ,
                          memPlainText
                        )
                    VALUES
                        ( '' , -- mem - text
                          :beschreibung , -- Beschreibung - varchar(255)
                          0 , -- nummer - int
                          :code , -- Code - varchar(50)
                          :gruppe , -- Gruppe - varchar(100)
                          :lang , -- Sprache - varchar(3)
                          NULL , -- BILD - image
                          :text  -- memPlainText - text
                    )
                ";

                $this->getDatabase()->prepare($sql);
                $this->getDatabase()->bindValue(':code', $name);
                $this->getDatabase()->bindValue(':text', $pattern['text']);
                $this->getDatabase()->bindValue(':gruppe', $pattern['gruppe']);
                $this->getDatabase()->bindValue(':beschreibung', $pattern['beschreibung']);
                $this->getDatabase()->bindValue(':lang', $language);
                $result = $this->getDatabase()->execute();
            }
        }
    }
} // Class DBTranslate
