<?php

class ControllerCars extends ControllerBase
{
    public function index()
    {
        $translate = null;
        $this->checkLogin();

        Cache::clearConfirmContent();
        $dateTimeFormat = new DateTimeFormat();

        $translate = $this->loadTranslations(array('FZG', 'Einheiten', 'KATEGORIE', 'GRUPPE', 'RENTAL',
            'NAVI', 'Wochentage', 'Wochentage_kurz', 'Monate_kurz', 'Feiertage', 'CURRENCY', 'GLOBAL',
            'LOGIN_BAR', 'LOGIN', 'STEP_MENU', 'BUCHUNGSFILTER', 'TOP_LINK', 'SIDEBAR', 'FILTER', 'STEP2',
            'ANMIETDATEN_BUTTON', 'STATION_SELECT', 'STATION', 'STATION_DETAILS', 'CAR_GROUP', 'TARIF', 'EXTRAS', 'RABATT', 'MESSAGE', 'NEW_PASSWORD', 'BELEGUNGSPLAN', 'EinheitEinzahl', 'USERDATA', 'ERRORS'));

        $_SESSION['NAVI_MAX_STEP'] = 2;
        $_SESSION['STEP'] = 2;

        if (!empty($_GET['ANGEBOTPK']) && intval($_GET['ANGEBOTPK']) > 0) {
            $_SESSION['ANGEBOTPK'] = intval($_GET['ANGEBOTPK']);
        }
        $opensidebar = false;
        if (!empty($_GET['open_sidebar']) && intval($_GET['open_sidebar']) == 1) {
            $opensidebar = true;
        }
        // AK 24.11.2016 - $_SESSION['DATA']['DEFAULT_CATEGORY'] entfernt und durch $_SESSION['DATA']['CATEGORY'] ersetzt
        $default_category = '';

        if (!empty($_GET['category'])) {
            $_SESSION['DATA']['CATEGORY'] = $this->catNameHash($_GET['category']);
        } elseif (!empty($_GET['category_default'])) {
            $_SESSION['DATA']['CATEGORY'] = $this->catNameHash($_GET['category_default']);
        } elseif (!empty($_GET['kategorie-select'])) {
            $_SESSION['DATA']['CATEGORY'] = trim(htmlspecialchars($_GET['kategorie-select']));
        }

        if (!empty($_GET['group'])) {
            $_SESSION['DATA']['SELECTED_GROUP'] = $_GET['group'];
        }

        //JM  Aufgabe 89929 IND_ ACL 11.08.2017
        $_SESSION['DATA']['DB']['FUNCTION']['ORM_GET_MV_PREISLISTE']['params'] = array();
        if (!empty($_GET['AWDNo']) && $_GET['AWDNo'] != '') {
            $_SESSION['DATA']['DB']['FUNCTION']['ORM_GET_MV_PREISLISTE']['params'] = array(':AWDNo' => $_GET['AWDNo']);
        }
        $default_category = !empty($_SESSION['DATA']['CATEGORY']) ? $_SESSION['DATA']['CATEGORY'] : '';

        // Löschen des Gutscheincodes
        Session::delDiscount();
        Session::delCarGroup();

        $CarGroups = [];
        $CarCategories = [];
        $ajax = false;
        $station_dep = new Station();
        $station_arr = new Station();
        $date_dep = '';
        $date_arr = '';
        $time_dep = '';
        $time_arr = '';

        $customer = new Customer();
        $is_login = false;
        $customer = Session::getCustomer();
        if (!empty($customer) and isset($_SESSION['DATA']['login']['isLoggedIn'])) {
            $is_login = true;
        } else {
            $customer = new Customer;
        }

        $Currency = new Currency();
        $DBCurrency = new DBCurrency();
        if (!isset($_SESSION['CONFIG']['CURRENCY'])) {
            $dbCurrency = $DBCurrency->getBaseCurrency();
            $_SESSION['CONFIG']['CURRENCY'] = $dbCurrency->ISOCode;
            $_SESSION['CONFIG']['CURRENCY_SYMBOL'] = $dbCurrency->Symbol;
        } else {
            $dbCurrency = $DBCurrency->getCurrency();
        }

        $Currency->description = $dbCurrency->Beschreibung;
        $Currency->symbol = $dbCurrency->Symbol;
        $Currency->conversion = $dbCurrency->Umrechnungsfaktor;
        $Currency->ISOcode = $dbCurrency->ISOCode;
        $Currency->description_lang = !empty($translate['CURRENCY'][$Currency->ISOcode]) ? $translate['CURRENCY'][$Currency->ISOcode] : $Currency->description;

        if (!empty($_GET['startstation']) or !empty($_GET['station'])) {
            $stationParam = (!empty($_GET['station'])) ? $_GET['station'] : $_GET['startstation'];

            $station_dep = new Station($stationParam);
            if (empty($station_dep->code)) {
                goError(ErrorList::getError('ERROR_STARTSTATION'));
            }

            if (!empty($_GET['endstation']) or !empty($_GET['station'])) {
                if (!empty($_GET['station'])) {
                    $endStationParam = $_GET['station'];
                } elseif (!empty($_GET['endstation'])) {
                    $endStationParam = $_GET['endstation'];
                } else {
                    $endStationParam = $stationParam;
                }

                if (Params::getValue('BINET_ALLOW_ONEWAY') == 0 && $endStationParam != $station_dep->code) {
                    goError(ErrorList::getError('ERROR_ENDSTATION'));
                }
                $station_arr = new Station($endStationParam);
            } else {
                $endStationParam = $stationParam;
                $station_arr = new Station($endStationParam);
            }

            if (empty($station_arr->code)) {
                goError(ErrorList::getError('ERROR_ENDSTATION'));
            }

            $ControllerLibs = new ControllerLibs();
            $oeffnungsZeitenResult = false;

            if (!empty($_GET['startdatetime'])) {
                $start_date_time = new DateTime();
                $start_date_time->setTimestamp((float) $_GET['startdatetime'] / 1000);
            } else {
                $oeffnungsZeitenResult = $ControllerLibs->getOpeningTimesForPHP($stationParam, $endStationParam, time(), time());
                $start_date_time = new DateTime();
                $start_date_time->setTimestamp((float) strtotime($oeffnungsZeitenResult[0]['min_start_date']));
            }

            $testVar = $start_date_time->getTimestamp();
            // if(empty($start_date_time->getTimestamp())) {    #funktioniert nicht in PHP 5.4
            if (empty($testVar)) {
                goError(ErrorList::getError('ERROR_STARTDATETIME'));
            }

            $now = new DateTime();
            $time_diff = $start_date_time->getTimestamp() - $now->getTimestamp() - $station_dep->min_vorlauf * 60;
            if ($time_diff < 0) {
                $hours = $station_dep->min_vorlauf / 60;
                $minutes = $station_dep->min_vorlauf % 60;

                if ($hours < 10) {
                    $hours = '0' . $hours;
                }
                if ($minutes < 10) {
                    $minutes = '0' . $minutes;
                }

                goError(ErrorList::getError('ERROR_MIN_VORLAUF') . ' ' . (int) $hours . 'h ' . (int) $minutes . 'min');
            }

            if (Params::getValue('CONFIG_EVERYTIME_DEPARTURE') == 0 && !$station_dep->isOpen($start_date_time->getTimestamp())) {
                goError(ErrorList::getError('ERROR_START_END_OPENTIME'));
            }

            if (!empty($_GET['enddatetime'])) {
                $end_date_time = new DateTime();
                $end_date_time->setTimestamp((float) $_GET['enddatetime'] / 1000);
            } else {
                if (!empty($_GET['startdatetime'])) {
                    $startTime = (float) $_GET['startdatetime'] / 1000;
                    $oeffnungsZeitenResult = $ControllerLibs->getOpeningTimesForPHP($stationParam, $endStationParam, $startTime, $startTime);
                }
                $end_date_time = new DateTime();
                $end_date_time->setTimestamp((float) strtotime($oeffnungsZeitenResult[0]['min_end_date']));
            }

            $testVar = $end_date_time->getTimestamp();
            // if(empty($end_date_time->getTimestamp())) {    #funktioniert nicht in PHP 5.4
            if (empty($testVar)) {
                goError(ErrorList::getError('ERROR_ENDDATETIME'));
            }

            if (Params::getValue('CONFIG_EVERYTIME_RETURN') == 0 && !$station_arr->isOpen($end_date_time->getTimestamp())) {
                goError(ErrorList::getError('ERROR_START_END_OPENTIME'));
            }
        } else {
            $station_dep = Session::getStartStation();
            $start_date_time_timestamp = Session::getStartDateTime();
            if (!empty($start_date_time_timestamp)) {
                $start_date_time = new DateTime;
                $start_date_time->setTimestamp($start_date_time_timestamp);
            }
            $station_arr = Session::getEndStation();
            $end_date_time_timestamp = Session::getEndDateTime();
            if (!empty($end_date_time_timestamp)) {
                $end_date_time = new DateTime;
                $end_date_time->setTimestamp($end_date_time_timestamp);
            }

            if (empty($station_dep) || empty($station_arr) || empty($start_date_time) || empty($end_date_time)) {
                goError(ErrorList::getError('ERROR_STARTSTATION'));
            }
        }

        Session::setStartStation($station_dep);
        Session::setEndStation($station_arr);
        Session::setStartDateTime($start_date_time->getTimestamp());
        Session::setEndDateTime($end_date_time->getTimestamp());

        $ajax = (isset($this->registry->args[0]) && $this->registry->args[0] == 'update' && (@$_SERVER['HTTP_X_REQUESTED_WITH'] == 'XMLHttpRequest' || AJAX_DEBUG));

        if (Params::getValue('BINET_ALLOW_ONEWAY')) {
            $station_arr = $station_arr;
            Session::setEndStation($station_arr);
        }

        $dbError = new DBError();
        $errors = $dbError->checkErrors(2, $start_date_time, $end_date_time, $station_dep, $station_arr);
        if (!empty($errors)) {
            goError($errors);
        }

        $date_dep = $start_date_time->format('d.m.Y');
        $time_dep = $start_date_time->format('H:i');
        $date_arr = $end_date_time->format('d.m.Y');
        $time_arr = $end_date_time->format('H:i');

        $dbRate = new DBRate();
        $dbCarGroups = new DBCarGroup();

        $car_groups_source = array();
        if (!empty($_SESSION['ANGEBOTPK'])) {
            $car_groups_source = $dbCarGroups->getGroupsFromRate(intval($_SESSION['ANGEBOTPK']));
        }
        if (empty($car_groups_source)) {
            $customerNr = ((int) $customer->id > 0) ? (int) $customer->id : 0;
            $car_groups_source = $dbCarGroups->getAllGroups(
                $station_dep,
                $station_arr,
                $date_dep . ' ' . $time_dep,
                $date_arr . ' ' . $time_arr,
                $customerNr
            );
        }
        foreach ($car_groups_source as $dbCarGroup) {
            if ($dbCarGroup->gruppe === $_SESSION['DATA']['SELECTED_GROUP']) {
                $dbCarGroup->firstGroup = true;
            } else {
                $dbCarGroup->firstGroup = false;
            }

            $car_group = new CarsGroup($dbCarGroup->gruppe, $dbCarGroup->firstGroup);

            if (!empty($translate['GRUPPE']['TITLE'][md5($car_group->code)])) {
                $car_group->title_lang = $translate['GRUPPE']['TITLE'][md5($car_group->code)];
            } else {
                $car_group->title_lang = ($car_group->title) ? $car_group->title : '';
            }

            if (!empty($translate['GRUPPE']['DESCRIPTION'][md5($car_group->code)])) {
                $car_group->description_lang = $translate['GRUPPE']['DESCRIPTION'][md5($car_group->code)];
            } else {
                $car_group->description_lang = $car_group->description;
            }

            if (!empty($translate['GRUPPE']['DESCRIPTION2'][md5($car_group->code)])) {
                $car_group->description2_lang = $translate['GRUPPE']['DESCRIPTION2'][md5($car_group->code)];
            } else {
                $car_group->description2_lang = $car_group->description2;
            }

            $car_group->rate = new Rate();

            # KR: warum wird hier $tmp_rate verwendet? Diese Variable ist nicht definiert!
            $car_group->rate->basic = !empty($tmp_rate->MietRate) ? $tmp_rate->MietRate == "J" : '';
            $car_group->rate->tarif = !empty($tmp_rate->Rate) ? $tmp_rate->Rate : '';
            $car_group->rate->description = !empty($tmp_rate->Beschreibung) ? $tmp_rate->Beschreibung : '';
            $car_group->rate->sub_description = !empty($tmp_rate->Beschreibung2) ? $tmp_rate->Beschreibung2 : '';
            $car_group->rate->count = !empty($tmp_rate->Anzahl) ? intval($tmp_rate->Anzahl) : 0;
            $car_group->rate->km_free = !empty($tmp_rate->Kmfrei) ? $tmp_rate->Kmfrei : 0;
            $car_group->rate->basic_price = !empty($tmp_rate->Brutto) ? $tmp_rate->Brutto : 0;
            $car_group->rate->total_price = !empty($tmp_rate->gesamtpreisbrutto) ? $tmp_rate->gesamtpreisbrutto : 0;
            $car_group->rate->invoice_num = !empty($tmp_rate->PKRECHNUNG) ? $tmp_rate->PKRECHNUNG : '0';
            $car_group->rate->unit = !empty($tmp_rate->Einheit) ? (array_key_exists($tmp_rate->Einheit, $translate['Einheiten']) and !empty($translate['Einheiten'][$tmp_rate->Einheit]) ? $translate['Einheiten'][$tmp_rate->Einheit] : $tmp_rate->Einheit) : '';
            $car_group->rate->sub_km_price = !empty($tmp_rate->kmbrutto) ? floatval($tmp_rate->kmbrutto * $Currency->conversion) : 0;
            $car_group->rate->is_angebot = !empty($tmp_rate->is_angebot);
            $car_group->rate->memo = !empty($tmp_rate->memo) ? $tmp_rate->memo : '';
            $car_group->group_image = SITEURL . 'images/groups/' . $car_group->cargroupid . '/group/440';

            // In SESSION muss man reine Raten speichern
            $_SESSION['CARS']['GROUPS'][$car_group->cargroupid] = serialize($car_group);
            // In template muss man Raten * Umrechnungsfactor ubergeben
            $car_group->rate->basic_price = floatval($car_group->rate->basic_price * $Currency->conversion);
            $car_group->rate->total_price = floatval($car_group->rate->total_price * $Currency->conversion);

            $availability = $this->getAvailabilityPlan($date_dep, $time_dep, $date_arr, $time_arr, $car_group->cargroupid);

            $car_group->availability_plan = isset($availability['belegungsplan']) ? $availability['belegungsplan'] : '';
            $car_group->available = $availability['available'];

            $CarGroups[] = $car_group;
        }

        $dbText = new DBText();
        $module = new Module();
        $station = Station::hasStationCode(Session::getStartStation());
        $text_footer = $dbText->getTextByStation($station->code, 'INET_ZUS_TEXT_STEP2');
        $text_footer->mem = isset($text_footer->mem) ? $text_footer->mem : 'INET_ZUS_TEXT_STEP2';

        $text_divider = $dbText->getTextByStation($station->code, 'INET_DIVIDER_TEXT_STEP2');
        $text_divider->mem = (isset($text_divider->mem) && $text_divider->mem !== '') ? $text_divider->mem : 'INET_DIVIDER_TEXT_STEP2';

        $is_round = Params::getValue('ORM_STEP2_PREISE_RUNDEN') == 1;

        $template = $this->template;

        $template->assign('ERROR', $this->error);
        $template->assign('TRANSLATE', $translate);

        $template->assign('CURRENCY', $Currency);
        $template->assign('IS_ROUND', $is_round);

        $template->assign('selected', isset($_SESSION['DATA']['car_group']) ? $_SESSION['DATA']['car_group'] : "");

        $cat_name_alle = !empty($translate['FZG']['ALLE']) ? $translate['FZG']['ALLE'] : 'FZG.ALLE';
        $CarCategories[$this->catNameHash($cat_name_alle)] = ['sort' => -1, 'name' => $cat_name_alle];
        foreach ($CarGroups as &$group) {
            $group->category_idx = '';
            foreach ($group->category as $category) {
                if (!empty($translate['GRUPPE']['KATEGORIE'][md5($category)])) {
                    $name = $translate['GRUPPE']['KATEGORIE'][md5($category)];
                } else {
                    $name = $category;
                }
                if (!in_array($this->catNameHash($name), $CarCategories) && $name != '') {
                    $CarCategories[$this->catNameHash($name)] = ['sort' => 0, 'name' => $name];
                }
                $group->category_idx .= '&' . $this->catNameHash($name);
            }
            $group->category_idx .= '&' . $this->catNameHash($cat_name_alle);
        }
        $dbCategories = new DBCategories;
        foreach ($dbCategories->getAll() as $key => $val) {
            $db_cat_name = !empty($translate['GRUPPE']['KATEGORIE'][md5($category)]) ? $translate['GRUPPE']['KATEGORIE'][md5($category)] : $val;
            if (key_exists($this->catNameHash($db_cat_name), $CarCategories)) {
                $CarCategories[$this->catNameHash($db_cat_name)]['sort'] = $key;
            }
        }

        if (!defined('CATEGORY_FILTER_DONT_AFFECT_SORTING') or !CATEGORY_FILTER_DONT_AFFECT_SORTING) {
            uasort($CarCategories, function ($a, $b) {
                return $a['sort'] - $b['sort'];
            });
        }

        $default_category_name = !empty($CarCategories[$default_category]) ? $CarCategories[$default_category]['name'] : '';

        $week_days = array($translate['Wochentage_kurz']['Montag'],
            $translate['Wochentage_kurz']['Dienstag'],
            $translate['Wochentage_kurz']['Mittwoch'],
            $translate['Wochentage_kurz']['Donnerstag'],
            $translate['Wochentage_kurz']['Freitag'],
            $translate['Wochentage_kurz']['Samstag'],
            $translate['Wochentage_kurz']['Sonntag']);

        $week_days = array($translate['Wochentage_kurz']['Montag'],
            $translate['Wochentage_kurz']['Dienstag'],
            $translate['Wochentage_kurz']['Mittwoch'],
            $translate['Wochentage_kurz']['Donnerstag'],
            $translate['Wochentage_kurz']['Freitag'],
            $translate['Wochentage_kurz']['Samstag'],
            $translate['Wochentage_kurz']['Sonntag']);

        $months = $arrayName = array('Jan' => $translate['Monate_kurz']['Januar'],
            'Feb' => $translate['Monate_kurz']['Februar'],
            'Mar' => $translate['Monate_kurz']['Maerz'],
            'Apr' => $translate['Monate_kurz']['April'],
            'May' => $translate['Monate_kurz']['Mai'],
            'Jun' => $translate['Monate_kurz']['Juni'],
            'Jul' => $translate['Monate_kurz']['Juli'],
            'Aug' => $translate['Monate_kurz']['August'],
            'Sep' => $translate['Monate_kurz']['September'],
            'Oct' => $translate['Monate_kurz']['Oktober'],
            'Nov' => $translate['Monate_kurz']['November'],
            'Dec' => $translate['Monate_kurz']['Dezember'],
        );

        $this->template->assign('WEEK_DAYS', $week_days);
        $this->template->assign('MONTHS', $months);
        $station = new Station();
        $station->getStationsBlock();
        $stations_dep = Station::getStationListFromCache('departure');
        $stations_arr = Station::getStationListFromCache('arrival');
        $template->assign('CARSGROUPS', $CarGroups); #debug($CarGroups);
        $template->assign('CARSCATEGORIES', sizeof($CarCategories) > 1 ? $CarCategories : array());
        if ($ajax) {
            $this->afterTemplate();
            echo $template->fetch('cargroup_categories.html');
        } else {
            $template->assign('NAVI_STEP', $_SESSION['STEP']);
            $template->assign('NAVI_MAX_STEP', $_SESSION['NAVI_MAX_STEP']);
            $template->assign('CARSCATEGORY_DEFAULT_NAME', $default_category_name);
            $template->assign('STATION_DEP', $station_dep);
            $template->assign('STATION_ARR', $station_arr);
            $template->assign('STARTDATETIME', Session::getStartDateTime() * 1000);
            $template->assign('ENDDATETIME', Session::getEndDateTime() * 1000);

            $template->assign('CUSTOMER', $customer);
            $template->assign('LOGIN', $is_login);
            $template->assign('TITLE', isset($translate['STEP2']['SITETITLE']) ? $translate['STEP2']['SITETITLE'] : 'STEP2.SITETITLE');
            $template->assign('ZIP_CODE_SEARCH', defined('ZIP_CODE_SEARCH') ? ZIP_CODE_SEARCH : 0);
            $template->assign('CONFIG_SHOW_AVAILABILITY_PLAN', (defined('CONFIG_SHOW_AVAILABILITY_PLAN') && CONFIG_SHOW_AVAILABILITY_PLAN == 1) || (Module::isEnabled('ORM_AVAILABILITY_PLAN')));
            $js_array = array('Cars.js', 'iframeResizer.contentWindow.js');
            foreach ($js_array as &$js_file) {
                if (file_exists(MODUL_PATH . 'js/' . $js_file)) {
                    $js_file = SITEURL . 'js/' . $js_file;
                }
            }

            $template->assign('JS_FILES', $js_array);

            $time_array_start = array();
            $start = 0;
            $end = 24;
            if (Params::getValue('CONFIG_EVERYTIME_DEPARTURE') == 0) {
                $start = 8;
                $end = 18;
            }

            for ($i = 0; $i < 24; $i++) {
                $time = ($i < 10 ? '0' . $i : $i) . ':00';
                $time = date($dateTimeFormat->getTimeFormat(), strtotime(date('Y-m-d') . ' ' . $time));
                if ($i >= $start and $i <= $end) {
                    $time_array_start[] = $time;
                }
                $time_array_end[] = $time;

                $time = ($i < 10 ? '0' . $i : $i) . ':30';
                $time = date($dateTimeFormat->getTimeFormat(), strtotime(date('Y-m-d') . ' ' . $time));
                if ($i >= $start and $i < $end) {
                    $time_array_start[] = $time;
                }
                $time_array_end[] = $time;
            }

            $station = Station::hasStationCode(Session::getStartStation());
            $password_reset_text = $dbText->getTextByStation($station->code, 'PASSWORD_RESET_TEXT');
            $password_reset_text->mem = isset($password_reset_text->mem) ? $password_reset_text->mem : 'PASSWORD_RESET_TEXT';
            $module = new Module();
            $this->template->assign('CARSCATEGORY_DEFAULT', $default_category);

            $template->assign('OFFERS', isset($_GET['ANGEBOTPK']));

            $template->assign('STATIONS_DEP', $stations_dep);
            $template->assign('STATIONS_ARR', $stations_arr);

            $template->assign('START_TIME_LIST', $time_array_start);
            $template->assign('END_TIME_LIST', $time_array_end);

            $template->assign('INET_ZUS_TEXT', $text_footer->mem);
            $template->assign('INET_DIVIDER_TEXT', $text_divider->mem);
            $template->assign('PASSWORD_RESET_TEXT', $password_reset_text->mem);

            $every_time_departure_shedule = Station::getOpenTimeEveryTime('departure');
            $every_time_return_shedule = Station::getOpenTimeEveryTime('return');
            $template->assign('EVERY_TIME_DEPARTURE_SHEDULE', json_encode($every_time_departure_shedule));
            $template->assign('EVERY_TIME_RETURN_SHEDULE', json_encode($every_time_return_shedule));
            $template->assign('OPEN_SIDEBAR', $opensidebar);

            $template->assign('LANG', $this->registry->lang);
            $dbText = new DBText();
            $station = Station::hasStationCode(Session::getStartStation());
            $group_availability = $dbText->getTextByStation($station->code, 'TEXT INET_GROUP_AVAILABILITY');
            $text_no_price = $dbText->getTextByStation($station->code, 'INET_NO_GROUP_PRICE');
            $group_availability = isset($group_availability->mem) ? $group_availability->mem : 'TEXT INET_GROUP_AVAILABILITY';
            $text_no_price = isset($text_no_price->mem) ? $text_no_price->mem : 'TEXT INET_NO_GROUP_PRICE';
            $template->assign('TEXT_GROUP_AVAILABILITY', $group_availability);
            $template->assign('TEXT_NO_GROUP_PRICE', $text_no_price);

            // AK 28.04.2017 - Aufgabe 83966: Login nur anzeigen wenn Modul aktiviert
            $show_login = Module::isEnabled('ORM_LOGIN');
            if (Module::isEnabled('ORM_HISTORIE') || Module::isEnabled('ORM_STORNO')) {
                $show_login = true;
            }

            $template->assign('SHOW_LOGIN', $show_login);

            $dbAnrede = new DBAnrede();
            $dbAnredenObj = $dbAnrede->getAll(Session::getLang());

            $anreden = array();
            foreach ($dbAnredenObj as $dbObj) {
                $anrede = new Anrede();
                $anrede->decodeFromDb($dbObj);
                $anreden[$anrede->id] = $anrede;
            }

            $this->template->assign('ANREDE', $anreden);
            $this->afterTemplate();

            // $template->display('carsgroup_index.html');
            $template->display('global_template.html');
        }
    } // Index()

    public function belegungsStatus()
    {
        $station = '%';
        $station_dep = Session::getStartStation();
        if (!empty($station_dep->code)) {
            $station = $station_dep->code;
        } elseif (!empty($_GET['station'])) {
            $station = $_GET['station'];
        } elseif (!empty($_GET['startstation'])) {
            $station = $_GET['startstation'];
        }
        $group_code = trim($_POST['data']);
        $selected_start_date = trim($_POST['selected_start_date']);
        $selected_end_date = trim($_POST['selected_end_date']);
        $dbCarGroups = new DBCarGroup();
        $frei = $dbCarGroups->getBelegungsPlan(
            $group_code,
            $selected_start_date, //->format('d.m.Y'),
            $selected_end_date, //->format('d.m.Y'));//,
            $station,
            1
        );
        if ($frei[0]['mvanummer'] > 0) {
            echo json_encode(array(
                'result' => true,
            ));
        } else {
            echo json_encode(array(
                'result' => false,
            ));
        }
    }
    public function prices()
    {
        if (isset($_GET['cur']) && trim($_GET['cur']) != '' && (@$_SERVER['HTTP_X_REQUESTED_WITH'] == 'XMLHttpRequest' || AJAX_DEBUG)) {
            $prices = array();

            $Currency = new Currency();
            $DBCurrency = new DBCurrency();
            $dbCurrency = $DBCurrency->getCurrency($_GET['cur']);

            $Currency->description = $dbCurrency->Beschreibung;
            $Currency->symbol = $dbCurrency->Symbol;
            $Currency->conversion = $dbCurrency->Umrechnungsfaktor;
            $Currency->ISOcode = $dbCurrency->ISOCode;

            $cars_groups = array();

            if (isset($_SESSION['CARS']['GROUPS']) && is_array($_SESSION['CARS']['GROUPS']) && count($_SESSION['CARS']['GROUPS']) > 0) {
                $cars_groups = $_SESSION['CARS']['GROUPS'];
            }

            foreach ($cars_groups as $group_key => $group_obj) {
                $group = unserialize($group_obj);
                $prices[] = array('group' => $group_key,
                    'single_price' => round($group->rate->basic_price * $Currency->conversion),
                    'total_price' => round($group->rate->total_price * $Currency->conversion),
                );
            }

            $output = array('prices' => $prices, 'symbol' => $Currency->symbol);

            echo json_encode($output);
        } else {
            error404();
        }
    }

    public function getGroupPrice()
    {
        $tmp_rate = null;
        $sdt = !empty($_GET['startdatetime']) ? $_GET['startdatetime'] : null;
        $edt = !empty($_GET['enddatetime']) ? $_GET['enddatetime'] : null;
        $startstation = !empty($_GET['startstation']) ? $_GET['startstation'] : null;
        $endstation = !empty($_GET['endstation']) ? $_GET['endstation'] : null;
        $car_group_id = !empty($_GET['car_group_id']) ? $_GET['car_group_id'] : null;

        $error = empty($sdt) || empty($edt) || empty($startstation) || empty($endstation);

        if (!$error) {
            $startdatetime = new DateTime;
            $startdatetime->setTimestamp((float) $sdt / 1000);
            $enddatetime = new DateTime;
            $enddatetime->setTimestamp((float) $edt / 1000);
            $cur = $_SESSION['CONFIG']['CURRENCY'];
        }

        $dbRate = new DBRate();
        $DbText = new DBText();
        //check if well-formed variables from user are correct to query in DB
        $queryACarGroupFlag = (isset($car_group_id) && $car_group_id != '' &&
            !empty($enddatetime) && !empty($enddatetime) &&
            $enddatetime->getTimestamp() > $startdatetime->getTimestamp() &&
            isset($startstation) && $startstation != '' &&
            isset($endstation) && $endstation != '' &&
            isset($cur) && $cur != ''
        ) ? true : false;
        if ($queryACarGroupFlag) {
            $startdate = $startdatetime->format('d.m.Y');
            $starttime = $startdatetime->format('H:i');
            $enddate = $enddatetime->format('d.m.Y');
            $endtime = $enddatetime->format('H:i');

            if (!empty($_SESSION['ANGEBOTPK'])) {
                $tmp_rates = $dbRate->RateCalcAufruf(
                    $_SESSION['ANGEBOTPK'],
                    $car_group_id,
                    $startdate . ' ' . $starttime,
                    $enddate . ' ' . $endtime,
                    $startstation,
                    $endstation,
                    0
                );

                $tmp_rate = $tmp_rates[0];
                // Angebot nicht gültig -> Berechung der Bestprice-Funktion
                if (($tmp_rate == null) || (intval($tmp_rate->Anzahl) == 0)) {
                    $tmp_rate = $dbRate->getStdRate(
                        $startdate . ' ' . $starttime,
                        $enddate . ' ' . $endtime,
                        $startstation,
                        $endstation,
                        $car_group_id,
                        0
                    );
                    $textObj = $DbText->getTextByStation($startstation, 'INET_GROUP_AVAILABILITY');
                    $textObj->mem = isset($textObj->mem) ? $textObj->mem : 'INET_GROUP_AVAILABILITY';

                    $tmp_rate->memo = $textObj->mem;
                }
            } // Berechung der Bestprice-Funktion
            else {
                $tmp_rate = $dbRate->getStdRate(
                    $startdate . ' ' . $starttime,
                    $enddate . ' ' . $endtime,
                    $startstation,
                    $endstation,
                    $car_group_id,
                    0
                );
            }
        }
        if (empty($tmp_rate) || !$queryACarGroupFlag) {
            $error = true;
        } else {
            $round = (Params::getValue('ORM_STEP2_PREISE_RUNDEN') == 1) ? 0 : 2;
            $Currency = new Currency();
            $DBCurrency = new DBCurrency();
            $dbCurrency = $DBCurrency->getCurrency($cur);
            $Currency->conversion = $dbCurrency->Umrechnungsfaktor;
            $Currency->symbol = $dbCurrency->Symbol;
            $dbTranslate = new DBTranslate();
            $translate = array('FZG' => $dbTranslate->loadTranslations('FZG', $this->registry->lang),
                'Einheiten' => $dbTranslate->loadTranslations('Einheiten', $this->registry->lang));
            $tmp_rate->Anzahl = round($tmp_rate->Anzahl);
            $tmp_rate->SB = sprintf("%01." . $round . "f", round($tmp_rate->SB, $round));
            $tmp_rate->Brutto = sprintf("%01." . $round . "f", round($tmp_rate->Brutto + ($tmp_rate->Brutto * $tmp_rate->rabatt / 100), $round));
            $tmp_rate->total_price_single = sprintf("%01." . $round . "f", round($tmp_rate->Brutto * $Currency->conversion, $round));
            $tmp_rate->gesamtpreisbrutto = sprintf("%01." . $round . "f", round($tmp_rate->gesamtpreisbrutto * $Currency->conversion, $round));

            if ((int) $tmp_rate->Anzahl == 1 or (float) $tmp_rate->Einzelpreis != (float) $tmp_rate->GesamtPreis) {
                $unitTranslation = isset($translate['EinheitEinzahl'][$tmp_rate->Einheit]) ? $translate['EinheitEinzahl'][$tmp_rate->Einheit] : (isset($translate['Einheiten'][$tmp_rate->Einheit]) ? $translate['Einheiten'][$tmp_rate->Einheit] : $tmp_rate->Einheit);
            } else {
                $unitTranslation = (array_key_exists($tmp_rate->Einheit, $translate['Einheiten']) and !empty($translate['Einheiten'][$tmp_rate->Einheit])) ? $translate['Einheiten'][$tmp_rate->Einheit] : $tmp_rate->Einheit;
            }

            $tmp_rate->Einheit_text = str_replace('$EINHEIT', $unitTranslation, $translate['CAR_GROUP']['PREIS']) . ' ' . $Currency->symbol;

            $tmp_rate->ANGEBOTPK = (isset($_SESSION['ANGEBOTPK']) ? $_SESSION['ANGEBOTPK'] : '');
            // Gesamtpreis auf Tag runterrechnen und Anzahl der Tage anzeigen wenn Parameter aktiv
            if (Params::getValue('ORM_STEP2_SHOW_DAYS_ONLY') == 1) {
                $tmp_rate->unit_days = isset($translate['Einheiten']['Tage']) ? $translate['Einheiten']['Tage'] : 'Tage';
                $tmp_rate->unit_day = isset($translate['Einheiten']['EINHEITEN.TAG']) ? $translate['Einheiten']['EINHEITEN.TAG'] : 'Tag';
                $tmp_rate->days = $dbRate->getDays($tmp_rate->PKRECHNUNG);
                if ($tmp_rate->days == 1) {
                    $tmp_rate->unit_days = $tmp_rate->unit_day;
                }

                $tmp_rate->total_price_single = sprintf("%01." . $round . "f", round(($tmp_rate->gesamtpreisbrutto / $tmp_rate->days) * $Currency->conversion, $round));
                $tmp_rate->Anzahl = $tmp_rate->days;
                $tmp_rate->Einheit = $tmp_rate->unit_days;
                $tmp_rate->Einheit_text = str_replace('$EINHEIT', $tmp_rate->unit_day, $translate['CAR_GROUP']['PREIS']) . ' ' . $Currency->symbol;
            }
        }

        $result = array('no_rate' => $error, 'rate' => $tmp_rate);
        if (@$_SERVER['HTTP_X_REQUESTED_WITH'] == 'XMLHttpRequest') {
            $this->json_headers();
            echo json_encode($result);
        } elseif (AJAX_DEBUG) {
            debug($result);
        }
    }

    /**
     *   Update einer einzelnen Fahrzeuggruppe
     **/
    public function updateCarGroups()
    {
        $dbTranslate = new DBTranslate();
        $translate = array('FZG' => $dbTranslate->loadTranslations('FZG', $this->registry->lang),
            'Einheiten' => $dbTranslate->loadTranslations('Einheiten', $this->registry->lang),
            'EinheitEinzahl' => $dbTranslate->loadTranslations('EinheitEinzahl', $this->registry->lang),
            'Wochentage_kurz' => $dbTranslate->loadTranslations('Wochentage_kurz', $this->registry->lang),
            'Monate_kurz' => $dbTranslate->loadTranslations('Monate_kurz', $this->registry->lang),
            'CAR_GROUP' => $dbTranslate->loadTranslations('CAR_GROUP', $this->registry->lang),
            'BELEGUNGSPLAN' => $dbTranslate->loadTranslations('BELEGUNGSPLAN', $this->registry->lang),
        );

        $tmp_rate = null;
        $sdt = !empty($_GET['startdatetime']) ? $_GET['startdatetime'] : null;
        $edt = !empty($_GET['enddatetime']) ? $_GET['enddatetime'] : null;
        $startstation = !empty($_GET['startstation']) ? $_GET['startstation'] : null;
        $endstation = !empty($_GET['endstation']) ? $_GET['endstation'] : null;
        $car_group_id = !empty($_GET['car_group_id']) ? $_GET['car_group_id'] : null;

        $error = empty($sdt) || empty($edt) || empty($startstation) || empty($endstation);

        if (!$error) {
            $startdatetime = new DateTime;
            $startdatetime->setTimestamp((float) $sdt / 1000);
            $enddatetime = new DateTime;
            $enddatetime->setTimestamp((float) $edt / 1000);
            $cur = $_SESSION['CONFIG']['CURRENCY'];
        }

        $dbRate = new DBRate();
        $Format = new Format();
        $DbText = new DBText();

        //check if well-formed variables from user are correct to query in DB
        $queryACarGroupFlag = (isset($car_group_id) && $car_group_id != '' &&
            !empty($startdatetime) && !empty($enddatetime) &&
            $enddatetime->getTimestamp() > $startdatetime->getTimestamp() &&
            isset($startstation) && $startstation != '' &&
            isset($endstation) && $endstation != '' &&
            isset($cur) && $cur != ''
        ) ? true : false;
        if ($queryACarGroupFlag) {
            $startdate = $startdatetime->format('d.m.Y');
            $starttime = $startdatetime->format('H:i');
            $enddate = $enddatetime->format('d.m.Y');
            $endtime = $enddatetime->format('H:i');

            if (!empty($_SESSION['ANGEBOTPK'])) {
                $tmp_rates = $dbRate->RateCalcAufruf(
                    $_SESSION['ANGEBOTPK'],
                    $car_group_id,
                    $startdate . ' ' . $starttime,
                    $enddate . ' ' . $endtime,
                    $startstation,
                    $endstation
                );
                $tmp_rate = $tmp_rates[0];
                // Angebot nicht gültig -> Berechung der Bestprice-Funktion
                if (($tmp_rate == null) || (intval($tmp_rate->Anzahl) == 0)) {
                    $tmp_rate = $dbRate->getStdRate(
                        $startdate . ' ' . $starttime,
                        $enddate . ' ' . $endtime,
                        $startstation,
                        $endstation,
                        $car_group_id,
                        0
                    );
                    $textObj = $DbText->getTextByStation($startstation, 'INET_GROUP_AVAILABILITY');
                    $textObj->mem = isset($textObj->mem) ? $textObj->mem : 'INET_GROUP_AVAILABILITY';

                    $tmp_rate->memo = $textObj->mem;
                }
            } // Berechung der Bestprice-Funktion
            else {
                $tmp_rate = $dbRate->getStdRate(
                    $startdate . ' ' . $starttime,
                    $enddate . ' ' . $endtime,
                    $startstation,
                    $endstation,
                    $car_group_id,
                    0
                );
            }
        }
        if (empty($tmp_rate) || !$queryACarGroupFlag) {
            $error = true;
        } else {
            $round = (Params::getValue('ORM_STEP2_PREISE_RUNDEN') == 1) ? 0 : 2;
            $Currency = new Currency();
            $DBCurrency = new DBCurrency();
            $dbCurrency = $DBCurrency->getCurrency($cur);
            $Currency->conversion = $dbCurrency->Umrechnungsfaktor;
            $Currency->symbol = $dbCurrency->Symbol;
            $tmp_rate->Anzahl = round($tmp_rate->Anzahl);
            $tmp_rate->SB = sprintf("%01." . $round . "f", round($tmp_rate->SB, $round));
            $tmp_rate->Brutto = sprintf("%01." . $round . "f", round($tmp_rate->Brutto + ($tmp_rate->Brutto * $tmp_rate->rabatt / 100), $round));

            $tmp_rate->total_price_single = sprintf("%01." . $round . "f", $this->cx9round($tmp_rate->Brutto * $Currency->conversion, $round));
            $tmp_rate->gesamtpreisbrutto = sprintf("%01." . $round . "f", $this->cx9round($tmp_rate->gesamtpreisbrutto * $Currency->conversion, $round));

            if ((int) $tmp_rate->Anzahl == 1 or (float) $tmp_rate->Einzelpreis != (float) $tmp_rate->GesamtPreis) {
                $unitTranslation = isset($translate['EinheitEinzahl'][$tmp_rate->Einheit]) ? $translate['EinheitEinzahl'][$tmp_rate->Einheit] : (isset($translate['Einheiten'][$tmp_rate->Einheit]) ? $translate['Einheiten'][$tmp_rate->Einheit] : $tmp_rate->Einheit);
            } else {
                $unitTranslation = (array_key_exists($tmp_rate->Einheit, $translate['Einheiten']) and !empty($translate['Einheiten'][$tmp_rate->Einheit])) ? $translate['Einheiten'][$tmp_rate->Einheit] : $tmp_rate->Einheit;
            }

            $tmp_rate->Einheit_text = str_replace('$EINHEIT', $unitTranslation, $translate['CAR_GROUP']['PREIS']) . ' ' . $Currency->symbol;

            $abPreisOhneKommastellen = (defined('STEP2_PREIS_AB_OHNECENT') and STEP2_PREIS_AB_OHNECENT) ? true : false;
            $abPreisOhneWaehrungssymbol = (defined('STEP2_PREIS_AB_OHNEWAEHRUNG') and STEP2_PREIS_AB_OHNEWAEHRUNG) ? true : false;

            $tmp_rate->total_price_single_formatted = $Format->currencyFormat($tmp_rate->total_price_single, !$abPreisOhneKommastellen, !$abPreisOhneWaehrungssymbol);
            $tmp_rate->gesamtpreisbrutto_formatted = $Format->currencyFormat($tmp_rate->gesamtpreisbrutto, (bool) $round);

            $tmp_rate->ANGEBOTPK = (isset($_SESSION['ANGEBOTPK']) ? $_SESSION['ANGEBOTPK'] : '');
            // Gesamtpreis auf Tag runterrechnen und Anzahl der Tage anzeigen wenn Parameter aktiv
            if (Params::getValue('ORM_STEP2_SHOW_DAYS_ONLY') == 1) {
                $tmp_rate->unit_days = isset($translate['Einheiten']['Tage']) ? $translate['Einheiten']['Tage'] : 'Tage';
                $tmp_rate->unit_day = isset($translate['Einheiten']['EINHEITEN.TAG']) ? $translate['Einheiten']['EINHEITEN.TAG'] : 'Tag';
                $tmp_rate->days = $dbRate->getDays($tmp_rate->PKRECHNUNG);
                if ($tmp_rate->days == 1) {
                    $tmp_rate->unit_days = $tmp_rate->unit_day;
                }

                $tmp_rate->total_price_single = sprintf("%01." . $round . "f", $this->cx9round(($tmp_rate->gesamtpreisbrutto / $tmp_rate->days) * $Currency->conversion, $round));
                $tmp_rate->Anzahl = $tmp_rate->days;
                $tmp_rate->Einheit = $tmp_rate->unit_days;
                $tmp_rate->Einheit_text = str_replace('$EINHEIT', $tmp_rate->unit_day, $translate['CAR_GROUP']['PREIS']) . ' ' . $Currency->symbol;
            }
        }

        $car_group = unserialize($_SESSION['CARS']['GROUPS'][$car_group_id]);

        $availability = $this->getAvailabilityPlan($startdate, $starttime, $enddate, $endtime, $car_group_id);

        $car_group->availability_plan = isset($availability['belegungsplan']) ? $availability['belegungsplan'] : '';
        $car_group->available = $availability['available'];

        $week_days = array($translate['Wochentage_kurz']['Montag'],
            $translate['Wochentage_kurz']['Dienstag'],
            $translate['Wochentage_kurz']['Mittwoch'],
            $translate['Wochentage_kurz']['Donnerstag'],
            $translate['Wochentage_kurz']['Freitag'],
            $translate['Wochentage_kurz']['Samstag'],
            $translate['Wochentage_kurz']['Sonntag']);

        $months = $arrayName = array('Jan' => $translate['Monate_kurz']['Januar'],
            'Feb' => $translate['Monate_kurz']['Februar'],
            'Mar' => $translate['Monate_kurz']['Maerz'],
            'Apr' => $translate['Monate_kurz']['April'],
            'May' => $translate['Monate_kurz']['Mai'],
            'Jun' => $translate['Monate_kurz']['Juni'],
            'Jul' => $translate['Monate_kurz']['Juli'],
            'Aug' => $translate['Monate_kurz']['August'],
            'Sep' => $translate['Monate_kurz']['September'],
            'Oct' => $translate['Monate_kurz']['Oktober'],
            'Nov' => $translate['Monate_kurz']['November'],
            'Dec' => $translate['Monate_kurz']['Dezember'],
        );

        $this->template->assign('WEEK_DAYS', $week_days);
        $this->template->assign('MONTHS', $months);
        $this->template->assign('TRANSLATE', $translate);

        $this->template->assign('car_group', $car_group);

        $html_out = $this->template->fetch('availability_plan.html');

        $result = array('no_rate' => $error, 'rate' => $tmp_rate, 'html' => $html_out, 'available' => $car_group->available);
        if (@$_SERVER['HTTP_X_REQUESTED_WITH'] == 'XMLHttpRequest') {
            $this->json_headers();
            echo json_encode($result);
        } elseif (AJAX_DEBUG) {
            debug($result);
        }
    }

    /**
     *   Update aller übergebenen Fahrzeuggruppen
     **/
    public function updateAllCarGroups()
    {
        $result = array();

        $tmp_rate = null;
        $sdt = !empty($_GET['startDatetime']) ? $_GET['startDatetime'] : null;
        $edt = !empty($_GET['endDatetime']) ? $_GET['endDatetime'] : null;
        $startstation = !empty($_GET['startStation']) ? $_GET['startStation'] : null;
        $endstation = !empty($_GET['endStation']) ? $_GET['endStation'] : null;
        $carGroupIDs = (trim($_GET['carGroups']) != false) ? trim($_GET['carGroups']) : false;

        $customer = new Customer();
        $customer = Session::getCustomer();
        $customerID = (!empty($customer) and (int) $customer->id > 0) ? (int) $customer->id > 0 : 0;
        $angebotPK = (isset($_SESSION['ANGEBOTPK'])) ? $_SESSION['ANGEBOTPK'] : 0;

        $hashParams = array($startstation, $endstation, $sdt, $edt, $customerID, $angebotPK);
        if (Session::createPricesHash($hashParams) !== Session::getCarGrpCalcHash() or !isset($_SESSION['CACHE']['CARGRP_PRICES'])) {
            $dbTranslate = new DBTranslate();
            $translate = array('FZG' => $dbTranslate->loadTranslations('FZG', $this->registry->lang),
                'Einheiten' => $dbTranslate->loadTranslations('Einheiten', $this->registry->lang),
                'EinheitEinzahl' => $dbTranslate->loadTranslations('EinheitEinzahl', $this->registry->lang),
                'Wochentage_kurz' => $dbTranslate->loadTranslations('Wochentage_kurz', $this->registry->lang),
                'Monate_kurz' => $dbTranslate->loadTranslations('Monate_kurz', $this->registry->lang),
                'CAR_GROUP' => $dbTranslate->loadTranslations('CAR_GROUP', $this->registry->lang),
                'BELEGUNGSPLAN' => $dbTranslate->loadTranslations('BELEGUNGSPLAN', $this->registry->lang),
            );

            $carGroupIDs_arr = ($carGroupIDs) ? explode(',', $carGroupIDs) : array();
            $error = empty($sdt) or empty($edt) or empty($startstation) or empty($endstation) or count($carGroupIDs_arr) == 0;
            if (!$error) {
                $startdatetime = new DateTime;
                $startdatetime->setTimestamp((float) $sdt / 1000);
                $enddatetime = new DateTime;
                $enddatetime->setTimestamp((float) $edt / 1000);
                $cur = $_SESSION['CONFIG']['CURRENCY'];
            }

            $week_days = array($translate['Wochentage_kurz']['Montag'],
                $translate['Wochentage_kurz']['Dienstag'],
                $translate['Wochentage_kurz']['Mittwoch'],
                $translate['Wochentage_kurz']['Donnerstag'],
                $translate['Wochentage_kurz']['Freitag'],
                $translate['Wochentage_kurz']['Samstag'],
                $translate['Wochentage_kurz']['Sonntag']);

            $months = $arrayName = array('Jan' => $translate['Monate_kurz']['Januar'],
                'Feb' => $translate['Monate_kurz']['Februar'],
                'Mar' => $translate['Monate_kurz']['Maerz'],
                'Apr' => $translate['Monate_kurz']['April'],
                'May' => $translate['Monate_kurz']['Mai'],
                'Jun' => $translate['Monate_kurz']['Juni'],
                'Jul' => $translate['Monate_kurz']['Juli'],
                'Aug' => $translate['Monate_kurz']['August'],
                'Sep' => $translate['Monate_kurz']['September'],
                'Oct' => $translate['Monate_kurz']['Oktober'],
                'Nov' => $translate['Monate_kurz']['November'],
                'Dec' => $translate['Monate_kurz']['Dezember'],
            );

            $dbRate = new DBRate();
            $Format = new Format();
            $DbText = new DBText();

            foreach ($carGroupIDs_arr as $curCarGrp) {
                $error = false;
                //check if well-formed variables from user are correct to query in DB
                $queryACarGroupFlag = (isset($curCarGrp) and $curCarGrp != '' and
                    !empty($startdatetime) and !empty($enddatetime) and
                    $enddatetime->getTimestamp() > $startdatetime->getTimestamp() and
                    isset($startstation) and $startstation != '' and
                    isset($endstation) and $endstation != '' and
                    isset($cur) and $cur != ''
                ) ? true : false;

                if ($queryACarGroupFlag) {
                    $startdate = $startdatetime->format('d.m.Y');
                    $starttime = $startdatetime->format('H:i');
                    $enddate = $enddatetime->format('d.m.Y');
                    $endtime = $enddatetime->format('H:i');

                    if (!empty($_SESSION['ANGEBOTPK'])) {
                        $tmp_rates = $dbRate->RateCalcAufruf(
                            $_SESSION['ANGEBOTPK'],
                            $curCarGrp,
                            $startdate . ' ' . $starttime,
                            $enddate . ' ' . $endtime,
                            $startstation,
                            $endstation
                        );
                        $tmp_rate = $tmp_rates[0];
                        // Angebot nicht gültig -> Berechung der Bestprice-Funktion
                        if (($tmp_rate == null) or (intval($tmp_rate->Anzahl) == 0)) {
                            $tmp_rate = $dbRate->getStdRate(
                                $startdate . ' ' . $starttime,
                                $enddate . ' ' . $endtime,
                                $startstation,
                                $endstation,
                                $curCarGrp,
                                0
                            );
                            $textObj = $DbText->getTextByStation($startstation, 'INET_GROUP_AVAILABILITY');
                            $textObj->mem = isset($textObj->mem) ? $textObj->mem : 'INET_GROUP_AVAILABILITY';

                            $tmp_rate->memo = $textObj->mem;
                        }
                    } // Berechung der Bestprice-Funktion
                    else {
                        $tmp_rate = $dbRate->getStdRate(
                            $startdate . ' ' . $starttime,
                            $enddate . ' ' . $endtime,
                            $startstation,
                            $endstation,
                            $curCarGrp,
                            0
                        );
                    }
                }

                if (empty($tmp_rate) or !$queryACarGroupFlag) {
                    $error = true;
                } else {
                    $round = (Params::getValue('ORM_STEP2_PREISE_RUNDEN') == 1) ? 0 : 2;
                    $Currency = new Currency();
                    $DBCurrency = new DBCurrency();
                    $dbCurrency = $DBCurrency->getCurrency($cur);
                    $Currency->conversion = $dbCurrency->Umrechnungsfaktor;
                    $Currency->symbol = $dbCurrency->Symbol;
                    $tmp_rate->Anzahl = round($tmp_rate->Anzahl);
                    $tmp_rate->SB = sprintf("%01." . $round . "f", round($tmp_rate->SB, $round));
                    $tmp_rate->Brutto = sprintf("%01." . $round . "f", round($tmp_rate->Brutto + ($tmp_rate->Brutto * $tmp_rate->rabatt / 100), $round));

                    $tmp_rate->total_price_single = sprintf("%01." . $round . "f", $this->cx9round($tmp_rate->Brutto * $Currency->conversion, $round));
                    $tmp_rate->gesamtpreisbrutto = sprintf("%01." . $round . "f", $this->cx9round($tmp_rate->gesamtpreisbrutto * $Currency->conversion, $round));

                    if ((int) $tmp_rate->Anzahl == 1 or (float) $tmp_rate->Einzelpreis != (float) $tmp_rate->GesamtPreis) {
                        $unitTranslation = isset($translate['EinheitEinzahl'][$tmp_rate->Einheit]) ? $translate['EinheitEinzahl'][$tmp_rate->Einheit] : (isset($translate['Einheiten'][$tmp_rate->Einheit]) ? $translate['Einheiten'][$tmp_rate->Einheit] : $tmp_rate->Einheit);
                    } else {
                        $unitTranslation = (array_key_exists($tmp_rate->Einheit, $translate['Einheiten']) and !empty($translate['Einheiten'][$tmp_rate->Einheit])) ? $translate['Einheiten'][$tmp_rate->Einheit] : $tmp_rate->Einheit;
                    }

                    $tmp_rate->Einheit_text = str_replace('$EINHEIT', $unitTranslation, $translate['CAR_GROUP']['PREIS']) . ' ' . $Currency->symbol;

                    $abPreisOhneKommastellen = (defined('STEP2_PREIS_AB_OHNECENT') and STEP2_PREIS_AB_OHNECENT) ? true : false;
                    $abPreisOhneWaehrungssymbol = (defined('STEP2_PREIS_AB_OHNEWAEHRUNG') and STEP2_PREIS_AB_OHNEWAEHRUNG) ? true : false;
                    if (defined('STEP2_PREIS_AB_WRAP_PREFIX') and STEP2_PREIS_AB_WRAP_PREFIX and defined('STEP2_PREIS_AB_WRAP_SUFFIX') and STEP2_PREIS_AB_WRAP_SUFFIX) {
                        $wrapArray = array(trim(STEP2_PREIS_AB_WRAP_PREFIX), trim(STEP2_PREIS_AB_WRAP_SUFFIX));
                    } else {
                        $wrapArray = false;
                    }

                    $tmp_rate->total_price_single_formatted = $Format->currencyFormat($tmp_rate->total_price_single, !$abPreisOhneKommastellen, !$abPreisOhneWaehrungssymbol, $wrapArray);
                    $tmp_rate->gesamtpreisbrutto_formatted = $Format->currencyFormat($tmp_rate->gesamtpreisbrutto, (bool) $round);

                    $tmp_rate->ANGEBOTPK = (isset($_SESSION['ANGEBOTPK']) ? $_SESSION['ANGEBOTPK'] : '');
                    // Gesamtpreis auf Tag runterrechnen und Anzahl der Tage anzeigen wenn Parameter aktiv
                    if (Params::getValue('ORM_STEP2_SHOW_DAYS_ONLY') == 1) {
                        $tmp_rate->unit_days = isset($translate['Einheiten']['Tage']) ? $translate['Einheiten']['Tage'] : 'Tage';
                        $tmp_rate->unit_day = isset($translate['Einheiten']['EINHEITEN.TAG']) ? $translate['Einheiten']['EINHEITEN.TAG'] : 'Tag';
                        $tmp_rate->days = $dbRate->getDays($tmp_rate->PKRECHNUNG);
                        if ($tmp_rate->days == 1) {
                            $tmp_rate->unit_days = $tmp_rate->unit_day;
                        }

                        $tmp_rate->total_price_single = sprintf("%01." . $round . "f", $this->cx9round(($tmp_rate->gesamtpreisbrutto / $tmp_rate->days) * $Currency->conversion, $round));
                        $tmp_rate->Anzahl = $tmp_rate->days;
                        $tmp_rate->Einheit = $tmp_rate->unit_days;
                        $tmp_rate->Einheit_text = str_replace('$EINHEIT', $tmp_rate->unit_day, $translate['CAR_GROUP']['PREIS']) . ' ' . $Currency->symbol;
                    }
                }

                $car_group = unserialize($_SESSION['CARS']['GROUPS'][$curCarGrp]);

                $availability = $this->getAvailabilityPlan($startdate, $starttime, $enddate, $endtime, $curCarGrp);

                $car_group->availability_plan = isset($availability['belegungsplan']) ? $availability['belegungsplan'] : '';
                $car_group->available = $availability['available'];

                $this->template->assign('WEEK_DAYS', $week_days);
                $this->template->assign('MONTHS', $months);
                $this->template->assign('TRANSLATE', $translate);
                $this->template->assign('car_group', $car_group);

                $html_out = $this->template->fetch('availability_plan.html');
                $result[$curCarGrp] = array('no_rate' => $error, 'rate' => $tmp_rate, 'html' => $html_out, 'available' => $car_group->available);
            } // foreach
            $_SESSION['CACHE']['CARGRP_PRICES'] = $result;

            if ($startstation) {
                $station = new Station($startstation);
                Session::setStartStation($station);
            }
            if ($endstation) {
                $station = new Station($endstation);
                Session::setEndStation($station);
            }
            Session::setStartDateTime($sdt / 1000);
            Session::setEndDateTime($edt / 1000);
            Session::setCarGrpCalcHash();
        } else {
            $result = $_SESSION['CACHE']['CARGRP_PRICES'];
        }

        if (@$_SERVER['HTTP_X_REQUESTED_WITH'] == 'XMLHttpRequest') {
            $this->json_headers();
            echo json_encode($result);
        } elseif (AJAX_DEBUG) {
            debug($result);
        }
    }

    public function categoryChange()
    {
        if (@$_SERVER['HTTP_X_REQUESTED_WITH'] == 'XMLHttpRequest' || AJAX_DEBUG) {
            if (isset($_GET['category']) && $_GET['category'] != '') {
                $_SESSION['DATA']['CATEGORY'] = $_GET['category'];
            }
        } else {
            error404();
        }
    } // categoryChange()

    protected function json_headers()
    {
        header('Cache-Control: no-cache, must-revalidate');
        header('Expires: Mon, 26 Jul 1997 05:00:00 GMT');
        header('Content-type: text/json; charset=utf-8');
        header('Content-type: application/json');
    }

    protected function isDateValid($str)
    {
        //this function must be improved, since it can fail
        $substring = ':000AM';
        if (strpos($str, $substring) !== false) {
            $str = substr($str, 0, strpos($str, $substring));
            //return true;
        }
        if (!is_string($str)) {
            return false;
        }
        $stamp = strtotime($str);
        if (!is_numeric($stamp)) {
            return false;
        }
        if (checkdate(date('m', $stamp), date('d', $stamp), date('Y', $stamp))) {
            return true;
        }
        return false;
    }

    public function translate()
    {
        $dbTranslate = new DBTranslate();
        $translate = array('FZG' => $dbTranslate->loadTranslations('FZG', $this->registry->lang),
            'Einheiten' => $dbTranslate->loadTranslations('Einheiten', $this->registry->lang),
            'KATEGORIE' => $dbTranslate->loadTranslations('KATEGORIE', $this->registry->lang),
            'GRUPPE' => $dbTranslate->loadTranslations('GRUPPE', $this->registry->lang),
            'RENTAL' => $dbTranslate->loadTranslations('RENTAL', $this->registry->lang),
            'NAVI' => $dbTranslate->loadTranslations('NAVI', $this->registry->lang));
        debug($translate);
    }

    public function setRentData()
    {
        if (@$_SERVER['HTTP_X_REQUESTED_WITH'] == 'XMLHttpRequest' || AJAX_DEBUG) {
            $require = ['startdatetime', 'enddatetime', 'startstation', 'endstation'];
            $data = $_GET;

            $error = '';
            try {
                foreach ($require as $r) {
                    if (empty($data[$r])) {
                        throw new Exception('empty "' . $r . '". ');
                    }
                }

                $startdatetime = new DateTime;
                $startdatetime->setTimestamp((float) $data['startdatetime'] / 1000);
                $enddatetime = new DateTime;
                $enddatetime->setTimestamp((float) $data['enddatetime'] / 1000);

                $startstation = new Station($data['startstation']);
                if (empty($startstation->code)) {
                    throw new Exception('Unbekante Startstation "' . $data['startstation'] . '"');
                }

                $endstation = new Station($data['endstation']);
                if (empty($endstation->code)) {
                    throw new Exception('Unbekante Endstation "' . $data['endstation'] . '"');
                }

                if (!$startstation->isOpen($startdatetime->getTimestamp())) {
                    throw new Exception('startstation "' . $data['startstation'] . '" is close am ' . $startdatetime->format('Y.m.d H:i'));
                }

                Session::setStartStation($startstation);
                Session::setEndStation($endstation);
                Session::setStartDateTime($startdatetime->getTimestamp());
                Session::setEndDateTime($enddatetime->getTimestamp());
            } catch (Exception $e) {
                $error = $e->getMessage();
            }

            $result = ['err_msg' => $error];
            if (!@$_SERVER['HTTP_X_REQUESTED_WITH'] == 'XMLHttpRequest') {
                debug($result);
            } else {
                $this->json_headers();
                echo json_encode($result);
            }
        }
    }

    //FW 17.01.18
    public function sendContactFormMail()
    {
        if (!empty($_POST["kontakt-vorname"]) && !empty($_POST["kontakt-nachname"]) && !empty($_POST["kontakt-strasse"])
            && !empty($_POST["kontakt-plz"]) && !empty($_POST["kontakt-ort"]) && !empty($_POST["kontakt-email"])
            && !empty($_POST["kontakt-phone"]) && !empty($_POST["kontakt-anfrage"])) {
            $header = "MIME-Version: 1.0\r\n";
            $header .= "Content-type: text/html; charset=utf-8\r\n";

            $header .= "From:  " . $_POST['kontakt-email'] . "\r\n";
            $header .= "Reply-To: " . $_POST['kontakt-email'] . "\r\n";
            $header .= "X-Mailer: PHP " . phpversion();

            //Stationsadresse
            $to = $_POST["email_receiver"];
            $subject = 'Kontaktformular';
            $this->template->assign('type', "email");
            $this->template->assign('CONTACT_ANREDE', $_POST["kontakt-anrede"]);
            $this->template->assign('CONTACT_VORNAME', $_POST["kontakt-vorname"]);
            $this->template->assign('CONTACT_NACHNAME', $_POST["kontakt-nachname"]);
            $this->template->assign('CONTACT_STRASSE', $_POST["kontakt-strasse"]);
            $this->template->assign('CONTACT_PLZ', $_POST["kontakt-plz"]);
            $this->template->assign('CONTACT_ORT', $_POST["kontakt-ort"]);
            $this->template->assign('CONTACT_EMAIL', $_POST["kontakt-email"]);
            $this->template->assign('CONTACT_PHONE', $_POST["kontakt-phone"]);
            $this->template->assign('CONTACT_ANFRAGE', $_POST["kontakt-anfrage"]);
            $message = $this->template->fetch('email_contactform.html');

            $sent = mail($to, $subject, $message, $header);

            echo json_encode(array("mail" => $sent));
        } else {
            echo json_encode(array("mail" => false));
        }
    }

//------------------  PRIVATE METHODS --------------------------------
    private function getAvailabilityPlan($date_dep, $time_dep, $date_arr, $time_arr, $car_group_id)
    {
        $dbCarGroups = new DBCarGroup();
        if ((defined('CONFIG_SHOW_AVAILABILITY_PLAN') && CONFIG_SHOW_AVAILABILITY_PLAN == 1) || (Module::isEnabled('ORM_AVAILABILITY_PLAN'))) {
            $selected_start_or = new DateTime($date_dep . ' ' . $time_dep);
            $minutes = $selected_start_or->format('i');
            //Irgendwo werden irgendwann 5min. auf die ausgewählte Uhrzeit addiert, dies ist nicht immer der Fall, um eine korrekte Uhrzeit wieder zu haben wurde diese 5 min. hier wieder subtrahiert.
            if ($minutes != 0 && $minutes != 15 && $minutes != 30 && $minutes != 45) {
                $selected_start_or = $selected_start_or->sub(new DateInterval('PT5M'));
            }
            $selected_start_db = $selected_start_or->format('d.m.Y H:i');

            $selected_end_or = new DateTime($date_arr . ' ' . $time_arr);
            $minutes = $selected_end_or->format('i');
            if ($minutes != 0 && $minutes != 15 && $minutes != 30 && $minutes && $minutes != 45) {
                $selected_end_or = $selected_end_or->sub(new DateInterval('PT5M'));
            }
            $selected_end_db = $selected_end_or->format('d.m.Y H:i');
            $station = '%';
            $station_dep = Session::getStartStation();

            if (!empty($station_dep->code)) {
                $station = $station_dep->code;
            } elseif (!empty($_GET['station'])) {
                $station = $_GET['station'];
            } elseif (!empty($_GET['startstation'])) {
                $station = $_GET['startstation'];
            }
        }

        if ((defined('CONFIG_SHOW_AVAILABILITY_PLAN') && CONFIG_SHOW_AVAILABILITY_PLAN == 1) || (Module::isEnabled('ORM_AVAILABILITY_PLAN'))) {
            $available = true;

            $week_befor = Params::getValue('IINET_AVAILABILITY_PLAN_WEEKS_BEFOR');
            $week_befor = is_null($week_befor) ? 2 : $week_befor;
            $week_after = Params::getValue('IINET_AVAILABILITY_PLAN_WEEKS_AFTER');
            $week_after = is_null($week_after) ? 2 : $week_after;

            $date_belegung_start = new DateTime($date_dep . ' ' . $time_dep);
            $date_belegung_end = new DateTime($date_arr . ' ' . $time_arr);

            $selected_start = $selected_start_or->format('Y-m-d\TH:i');
            $selected_end = $selected_end_or->format('Y-m-d\TH:i');

            $date_belegung_start->sub(new DateInterval('P' . $week_befor . 'W'));
            $date_belegung_end->add(new DateInterval('P' . $week_after . 'W'));

            $date_belegung_start->sub(new DateInterval('P' . (date('N', strtotime($date_belegung_start->format('Y-m-d'))) - 1) . 'D'));
            $date_belegung_end->add(new DateInterval('P' . (7 - date('N', strtotime($date_belegung_end->format('Y-m-d')))) . 'D'));

            $belegungsplan = $dbCarGroups->getBelegungsPlan(
                $car_group_id,
                $date_belegung_start->format('d.m.Y 00:00'),
                $date_belegung_end->format('d.m.Y 23:59'),
                $station
            );

            $belegte_zeiten = count($belegungsplan);

            $date = new DateTime($date_belegung_start->format('Y-m-d H:i'));
            $belegungs = new Belegungs();
            $dep = date('Y-m-d', strtotime($date_dep));
            $arr = date('Y-m-d', strtotime($date_arr));
            $belegungs_selected = $dbCarGroups->getBelegungsPlan(
                $car_group_id,
                $selected_start_db,
                $selected_end_db,
                $station,
                1
            );
            while ($date->format('Y-m-d') <= $date_belegung_end->format('Y-m-d')) {
                if (!isset($belegungs->year[$date->format("Y")])) {
                    $belegungs->year[$date->format("Y")] = new Year($date);
                }

                if (!isset($belegungs->year[$date->format("Y")]->month[$date->format("m")])) {
                    $belegungs->year[$date->format("Y")]->month[$date->format("m")] = new Month($date);
                }

                if (!isset($belegungs->year[$date->format("Y")]->month[$date->format("m")]->week[$date->format("W")])) {
                    $belegungs->year[$date->format("Y")]->month[$date->format("m")]->week[$date->format("W")] = new Week($date);
                }

                $day = new Day($date);
                $date_date = $date->format('Y-m-d');

                $date_date_start = $date->setTime(0, 0)->format('Y-m-d\TH:i');
                $date_date_end = $date->setTime(23, 59)->format('Y-m-d\TH:i');

                $day->isSelected = false;
                if ($date_date >= $dep &&
                    $date_date <= $arr) {
                    $day->isSelected = true;
                }
                $day->isFree = 2;
                if ($day->isSelected) {
                    if ($belegungs_selected[0]['mvanummer'] == null) {
                        $day->isFree = 0;
                    }
                } else {
                    for ($i = 0; $i < $belegte_zeiten; $i++) {
                        if ($date_date_start >= $belegungsplan[$i]['start'] &&
                            $date_date_end <= $belegungsplan[$i]['end']) {
                            $day->isFree = 0;
                            break;
                        } elseif (($date_date_start <= $belegungsplan[$i]['start'] &&
                            $date_date_end >= $belegungsplan[$i]['start']) ||
                            ($date_date_start <= $belegungsplan[$i]['end'] &&
                                $date_date_end >= $belegungsplan[$i]['end'])) {
                            $day->isFree = 1;
                            break;
                        }
                    }
                }
                $belegungs->year[$date->format("Y")]->month[$date->format("m")]->week[$date->format("W")]->day[] = $day;
                $date->add(new DateInterval('P1D'));
            }
            return array("belegungsplan" => $belegungs, "available" => $belegungs_selected[0]['mvanummer'] != null ? true : false);
        }

        if (defined('CONFIG_CHECK_AVAILABILITY') && CONFIG_CHECK_AVAILABILITY == 1) {
            $belegungs_selected = $dbCarGroups->getBelegungsPlan(
                $car_group_id,
                $selected_start_db,
                $selected_end_db,
                $station,
                1
            );
            return array("available" => $belegungs_selected[0]['mvanummer'] != null ? true : false);
        } else {
            return array("available" => true);
        }
    }
    protected function afterTemplate()
    {
    }
} // Class ControllerCars
