<?php
class ControllerImages extends ControllerBase
{
    public function index()
    {
    }

    /**
     * Anruf http://localhost/reservierung/images/groups/GROUP_CODE/group/IMAGE_WIDTH
     */
    public function groups()
    {
        if (isset($this->registry->args[0]) && trim($this->registry->args[0]) != '') {
            if (isset($this->registry->args[1]) && ($this->registry->args[1] == 'group' || $this->registry->args[1] == 'group_image' || $this->registry->args[1] == 'ext')) {
                $image_type = $this->registry->args[1];
                $image_pk = isset($this->registry->args[3]) ? trim($this->registry->args[3]) : 0;
                $group_code = trim($this->registry->args[0]);
                $images_path = 'images/groups/' . $group_code . '/';
                $groupFolder = MODUL_PATH . $images_path;
                $img_width = (int) $this->registry->args[2] > 0 ? (int) $this->registry->args[2] : 0;
                $image_data = false;
// debug($_SESSION);
                $dbCarGroup = new DBCarGroup();
                if ($this->registry->args[1] !== 'group_image') {
                    $image_data = $dbCarGroup->getImage($group_code, $image_type);
                } elseif ($this->registry->args[1] === 'group_image') {
                    $image_ident = $dbCarGroup->getImageGroup($group_code, $image_pk, $image_type, true);
                }

                $imageFileName = $groupFolder . $image_ident . '_' . $img_width . '_' . '.jpg';
                if (!file_exists($imageFileName)) {
                    //make directory if it does not exist
                    if (!is_dir($groupFolder)) {
                        $path_arr = explode('/', trim($images_path, '/'));
                        $new_path = MODUL_PATH;
                        foreach ($path_arr as $path) {
                            $old_path = $new_path;
                            $new_path .= trim($path, '/') . '/';
                            if (!is_dir($new_path)) {
                                if (is_writable($old_path)) {
                                    mkdir($new_path, 0777);
                                } else {
                                    break;
                                }
                            }
                        }
                    }
                    $image_data = $dbCarGroup->getImageGroup($group_code, $image_pk, $image_type);
                    file_put_contents($imageFileName, $image_data);
                } else {
                    $image_data = file_get_contents($imageFileName);
                }

                $hardFileName = SITEURL . $images_path . $image_ident . '_' . $img_width . '_' . '.jpg';
                $this->expandCarGroupWithImageFileName($group_code, $hardFileName);

                if (isset($image_data) && $image_data !== false) {
                    //if data from DB or Hard Disk then present it
                    $this->getImage($image_data, $img_width);
                    exit;
                }
            }
        }

        $this->getTransparentImg();
        exit;
    }

    public function logo()
    {
        $dbMandant = new DBMandant();
        $image_data = $dbMandant->getLogo();
        if (isset($image_data) && $image_data !== false) {
            $this->getImage($image_data, 240);
        } else {
            $this->getTransparentImg();
        }
        exit;
    }
    // anruf http://dev_ym/APP_ORM_CLIENT/images/getBackground/40/0/20/1/10/2
    public function getBackground()
    {

        $img = imagecreatetruecolor(72, 20);

        $x_pointer = 0;
        $red = imagecolorallocate($img, 255, 0, 0);
        $green = imagecolorallocate($img, 0, 255, 0);

        for ($farbe = 0; $farbe < count($this->registry->args); $farbe += 2) {
            switch ($this->registry->args[$farbe + 1]) {
                case 0:
                    $color = $red;
                    break;
                case 1:
                    $color = $green;
                    break;
                case 2:
                    $color = $lightgreen;
                    break;
            }
            imagefilledrectangle($img, $x_pointer, 0, $x_pointer + $this->registry->args[$farbe], 20, $color);
            $x_pointer += $this->registry->args[$farbe];
        }
        $this->show($img);
    }

    public function angebot()
    {
        if (isset($this->registry->args[0]) && intval($this->registry->args[0]) > 0) {
            $angebotpk = intval($this->registry->args[0]);
            $dbAngebot = new DBAngebote();
            $image_data = $dbAngebot->getBild($angebotpk);

            if (!empty($image_data)) {
                $this->getImage($image_data, 1240);
            } else {
                $this->getTransparentImg();
            }
            exit;
        }
    } //angebot()

    protected function show($img)
    {
        header('Content-Type: image/png');
        imagepng($img);
        exit;
    }

    protected function getImage($image_data, $width)
    {
        if (!function_exists('getimagesizefromstring')) {
            $uri = 'data://application/octet-stream;base64,' . base64_encode($image_data);
            $img_size = getimagesize($uri);
        } else {
            $img_size = getimagesizefromstring($image_data);
        }

        $img_res = imagecreatefromstring($image_data);

        $x = $width;
        $k = $img_size[0] / $x;
        $y = $img_size[1] / $k;

        $new_image = imagecreatetruecolor($x, $y);

        imageAlphaBlending($new_image, false);
        imageSaveAlpha($new_image, true);

        imagecopyresampled($new_image, $img_res, 0, 0, 0, 0, $x, $y, $img_size[0], $img_size[1]);

        header('Content-Type: ' . $img_size['mime']);

        imagepng($new_image);
        imagedestroy($new_image);
    }

    protected function getTransparentImg()
    {
        $transparent_image_1x1_px = imagecreatetruecolor(1, 1);
        $white = imagecolorallocate($transparent_image_1x1_px, 255, 255, 255);
        imagecolortransparent($transparent_image_1x1_px, $white);
        imagefill($transparent_image_1x1_px, 0, 0, $white);

        header('Content-Type: image/png');

        imagepng($transparent_image_1x1_px);
        imagedestroy($transparent_image_1x1_px);
        exit;
    }

    /**
     *   Fügt den Dateinamen des Bildes ins CarGroup-Objekt in der Session hinzu,
     *   damit dieses dann in den eMails als Hardlink verwendet werden kann.
     **/
    private function expandCarGroupWithImageFileName($groupID, $imageFileName)
    {
        $carGroup = Session::getCarGroup();
        if (!is_null($carGroup) and $carGroup->cargroupid == $groupID and !isset($carGroup->groupImageHardlink)) {
            $carGroup->groupImageHardlink = $imageFileName;
            Session::setCarGroup($carGroup);
        }
    }
} // Class ControllerImages
