<?php
class ControllerLibs extends ControllerBase
{
    public function index()
    {
    }

    public function getHolidays()
    {
        //print_r($this->registry->args[0]);
        $holidays = array();
        if (!empty($this->registry->args[0])) {
            if (empty($_SESSION['CACHE']['holidays'][strtolower($this->registry->args[0])])) {
                $dbHolidays = new DBHolidays();
                $holidays = $dbHolidays->getAll($this->registry->args[0]);
                $_SESSION['CACHE']['holidays'][strtolower($this->registry->args[0])] = $holidays;
            }
        }

        $holidays = $_SESSION['CACHE']['holidays'][strtolower($this->registry->args[0])];
        echo json_encode($holidays);
    } // getHolidays()
    public function systemControlOpenningTimes()
    {
        unset($_POST['time']);
//get language
        // $this->process_request($_POST,'CRW_OPENTIMES_GET_INET_OPENING_HOURS','CX9_', array('username','field_prefix'));
        // $procedure_name = 'dbo.CRW_OPENTIMES_GET_INET_OPENING_HOURS';
        $procedure_name = 'dbo.CRW_OPENTIMES_GET_INET_OPENING_HOURS_BILATERAL';

        if (isset($_POST['clientDateStartingPoint']) && $_POST['clientDateStartingPoint'] === 'NULL') {
            if (defined('ORM_DEBUG_ALL_PROC_ACTIONS')) {
                $procedure_name_suffix = ($procedure_name . '[@ACTION=>') . (array_key_exists('aktion', $_POST) ? $_POST['aktion'] . ']' : (array_key_exists('action', $_POST) ? $_POST['action'] . ']' : 'DEFAULT]'));
            } else {
                $procedure_name_suffix = $procedure_name;
            }

            $_SESSION['ControllerLibs'][$procedure_name_suffix]['DB_RESULTS']['result']['0']['error_msg'] = '';

            $data_result = $_SESSION['ControllerLibs'][$procedure_name_suffix]['DB_RESULTS'];

            if (!isset($_SESSION['ControllerLibs'][$procedure_name_suffix]['DB_RESULTS']['result']['0']['max_start_date'])) {
                if ($_POST['clientDateStartingPoint'] == 'NULL') {
                    unset($_POST['clientDateStartingPoint']);
                }
                $this->process_request($_POST, $procedure_name, 'CX9_', array('username', 'field_prefix'));
            }
            $json = new JSONData($data_result);
            $json->print_json_headers();
            $json->print_json();
        } else {
            $this->process_request($_POST, $procedure_name, 'CX9_', array('username', 'field_prefix'));
        }
    } // systemControlOpenningTimes()

    public function getOpeningTimesForPHP($startStation, $endStation, $startTimestamp, $endTimestamp)
    {
        $procedureName = 'dbo.CRW_OPENTIMES_GET_INET_OPENING_HOURS_BILATERAL';

        // username=ORM&hash=NONE&aktion=getInitialValues&clientDateStartingPoint=2016-06-15T11:33:53&lang=DE

        // username=ORM&hash=NONE&aktion=getStationData&clientDateStartingPoint=2016-06-15T11:33:56&selectedStartDateTime
        // =2016-06-15T12:00:00&selectedEndDateTime=2016-06-16T12:00:00&station_code=001&station_end_code=001&lang
        // =DE

        $dataArray = array(
            'username' => 'ORM',
            'hash' => 'NONE',
            'aktion' => 'getStationData',
            'lang' => 'DE',
            'station_code' => $startStation,
            'station_end_code' => $endStation,
            'selectedStartDateTime' => date('Y-m-d\TH:i:s', $startTimestamp),
            'selectedEndDateTime' => date('Y-m-d\TH:i:s', $endTimestamp),
        );
        $this->process_request($dataArray, $procedureName, 'CX9_', array('username', 'field_prefix'), array(), function ($result) {
            return $result;
        }, true);

        $result = $_SESSION['ControllerLibs'][$procedureName]['DB_RESULTS']['result'];
        unset($_SESSION['ControllerLibs'][$procedureName]);

        return $result;
    }

    public function IND_ACL_RENTAL_TESTS()
    {
        $procedureName = 'dbo.IND_ACL_ORM_RENTAL_TEST';
        $dataArray = array_merge(array(
            'username' => 'ORM',
            'hash' => 'NONE',
            'lang' => 'DE',
        ), $_POST);
        //print_r( $dataArray);
        $this->process_request($dataArray, $procedureName, 'CX9_', array('username', 'field_prefix'), array(), function ($result) {
            return $result;
        });

        $result = $_SESSION['ControllerLibs'][$procedureName]; //['DB_RESULTS']['result'];
        //unset($_SESSION['ControllerLibs'][$procedureName]);
        return $result;
    }

    public function getJS()
    {
        $DBStation = new DBStation();
        $dateTimeFormat = new DateTimeFormat();

        $stations = Station::getAll();
        $holidays = [];
        $returnStationCodes = [];
        foreach ($stations as $station) {
            $state = strtolower($station->stat);
            if (empty($holidays[$state])) {
                if (empty($_SESSION['CACHE']['holidays'][$state])) {
                    $dbHolidays = new DBHolidays();
                    $holidays = $dbHolidays->getAll($state);
                    $_SESSION['CACHE']['holidays'][$state] = $holidays;
                }
                $holidays[$state] = $_SESSION['CACHE']['holidays'][$state];
            };
            $codes = $DBStation->getReturnStations($station->code);
            $returnStationCodes[$station->code] = $codes;
        }

        $shedules = ['start' => Station::getOpenTimeEveryTime('start'),
            'end' => Station::getOpenTimeEveryTime('end')];

        $time_array_start = array();
        $time_array_end = array();
        $defaultStartTimeStart = '00:00';
        $defaultStartTimeEnd = '23:30';
        if (Params::getValue('CONFIG_EVERYTIME_DEPARTURE') == 0) {
            $defaultStartTimeStart = '08:00';
            $defaultStartTimeEnd = '18:00';
        }

        // ML 16.12.2016 - Stationsdaten müssen neu geladen werden ,da bei Sprachwechsel die Einheiten im "station_details" Teil nicht aktualisiert werden
        $stations = null; //Session::getStationsList();
        if (empty($stations)) {
            $stations = [];
            foreach (Station::getAll() as $station) {
                $stations[$station->code] = $station;
            }
            Session::setStationsList($stations);
        }

        $user = Session::getCustomer();

        $vars['stations'] = json_encode($stations);
        $vars['CurrentTimestamp'] = time() * 1000;
        $vars['isLogin'] = !empty($user->id) ? 1 : 0;
        $vars['NaviMaxStep'] = !empty($_SESSION['NAVI_MAX_STEP']) ? $_SESSION['NAVI_MAX_STEP'] : 0;
        $vars['NaviStep'] = !empty($_SESSION['STEP']) ? $_SESSION['STEP'] : 0;

        $vars['TimeInterval'] = 30;
        $vars['DefaultTime'] = json_encode(['start_first' => $defaultStartTimeStart, 'start_last' => $defaultStartTimeEnd, 'end_first' => '00:00', 'end_last' => '23:30']);
        $vars['ReturnStationCodes'] = json_encode($returnStationCodes);
//        $vars['OpenTimeEveryTime'] = json_encode($shedules);
        $vars['holidays'] = json_encode($holidays);
        $this->template->assign('VARS', $vars);
        $this->template->display('js/dynamic.js');
    } // getJS

    public function getConfig()
    {
        $config = array(
            'VERSION' => defined('VERSION') ? VERSION : 0,
            'DEFAULT_LANG' => defined('DEFAULT_LANG') ? DEFAULT_LANG : 'DE',
            'BINET_ALLOW_ONEWAY' => defined('BINET_ALLOW_ONEWAY') ? BINET_ALLOW_ONEWAY : 1,
            'CONFIG_JS_SUBMIT' => defined('CONFIG_JS_SUBMIT') ? CONFIG_JS_SUBMIT : 0,
            'CONFIG_STEP2_NEW_WINDOW' => defined('CONFIG_STEP2_NEW_WINDOW') ? CONFIG_STEP2_NEW_WINDOW : 0,
            'CACHE' => defined('CACHE') ? CACHE : 0,
            'FIRST_PAGE' => defined('FIRST_PAGE') ? FIRST_PAGE : '',
            'INET_STATUS' => defined('INET_STATUS') ? INET_STATUS : 0,
            'CONFIG_SHOW_AVAILABILITY_PLAN' => (defined('CONFIG_SHOW_AVAILABILITY_PLAN') && CONFIG_SHOW_AVAILABILITY_PLAN == 1) || (Module::isEnabled('ORM_AVAILABILITY_PLAN')),
            'TRANSLATE_INIT' => defined('TRANSLATE_INIT') ? TRANSLATE_INIT : 0,
            'AJAX_DEBUG' => defined('AJAX_DEBUG') ? AJAX_DEBUG : 0,
            'CONFIG_CHECK_AVAILABILITY' => (defined('CONFIG_CHECK_AVAILABILITY') && CONFIG_CHECK_AVAILABILITY == 1) || (defined('CONFIG_SHOW_AVAILABILITY_PLAN') && CONFIG_SHOW_AVAILABILITY_PLAN == 1) || (Module::isEnabled('ORM_AVAILABILITY_PLAN')),
            'CONFIG_SHOW_DRIVER_DATA' => defined('CONFIG_SHOW_DRIVER_DATA') ? CONFIG_SHOW_DRIVER_DATA : 0,
            'EXTERN_STEP2' => defined('EXTERN_STEP2') ? EXTERN_STEP2 : '',
        );

        $config = array_merge($config, Params::getAll());
        $_SESSION['CACHE']['PARAMS'] = $config;

        $data = array('error' => 0, 'error_msg' => '', 'config' => $config);

        header('Access-Control-Allow-Origin: *');
        header('Content-Type: application/javascript');
        echo(isset($_GET['callback']) ? $_GET['callback'] : '') . '(' . json_encode($data) . ')';
        exit;
    }

    public function getEveryTimeShedule()
    {
        $every_time_departure_shedule = Station::getOpenTimeEveryTime('departure');
        $every_time_return_shedule = Station::getOpenTimeEveryTime('return');
//        $template->assign('EVERY_TIME_DEPARTURE_SHEDULE', json_encode($every_time_departure_shedule));
        //        $template->assign('EVERY_TIME_RETURN_SHEDULE', json_encode($every_time_return_shedule));

        $data = array('error' => 0, 'error_msg' => '', 'departure' => $every_time_departure_shedule, 'return' => $every_time_return_shedule);

        header('Access-Control-Allow-Origin: *');
        header('Content-Type: application/javascript');
        echo(isset($_GET['callback']) ? $_GET['callback'] : '') . '(' . json_encode($data) . ')';
        exit;
    }
} //Class ControllerLibs
