<?php
class ControllerPrecheck extends ControllerBase
{
    public function index()
    {

        $_SESSION['NAVI_MAX_STEP'] = 4.5;
        $data = !empty($_SESSION['DATA']) ? $_SESSION['DATA'] : null;

        $startstation = !empty($data['startstation_obj']) ? unserialize($data['startstation_obj']) : null;
        $endstation = !empty($data['endstation_obj']) ? unserialize($data['endstation_obj']) : null;
        if (is_null($startstation)) {
            $this->error[] = 'SESSION ERROR. Miss Start Station';
        }
        if (is_null($endstation)) {
            $this->error[] = 'SESSION ERROR. Miss End Station';
        }

        $carGroup = !empty($data['car_group_obj']) ? unserialize($data['car_group_obj']) : null;
        if (is_null($carGroup)) {
            $this->error[] = 'SESSION ERROR. Miss Cargroup';
        }

        $post_data = !empty($_SESSION['POST']) ? $_SESSION['POST'] : null;

        $template = $this->template;

        $dbTranslate = new DBTranslate();
        $translate = array('STEP4' => $dbTranslate->loadTranslations('PORSCHE.STEP4', $this->registry->lang),
            'GLOBAL' => $dbTranslate->loadTranslations('PORSCHE.GLOBAL', $this->registry->lang),
            'RATES' => $dbTranslate->loadTranslations('CRENT.RATEDATA', $this->registry->lang),
            'NAVBAR' => $dbTranslate->loadTranslations('PORSCHE.NAVBAR', $this->registry->lang),
            'NAVI' => $dbTranslate->loadTranslations('PORSCHE.NAVI', $this->registry->lang),
            'MONATE' => $dbTranslate->loadTranslations('Monate', $this->registry->lang),
            'COLOR' => $dbTranslate->loadTranslations('crent.CARCOLOR', $this->registry->lang),
            'COUNTRIES' => $dbTranslate->loadTranslations('crent.countries', $this->registry->lang),
            'WEEKDAYS' => $dbTranslate->loadTranslations('Wochentage', $this->registry->lang),
            'EINHEITEN' => $dbTranslate->loadTranslations('Einheiten', $this->registry->lang),
            'RATE' => $dbTranslate->loadTranslations('RATE', $this->registry->lang),
            'Wochentage' => $dbTranslate->loadTranslations('Wochentage', $this->registry->lang),
        );

        $dbText = new DBText();
        $station = Station::hasStationCode(Session::getStartStation());
        $text_footer = $dbText->getTextByStation($station->code, 'INET_ZUS_TEXT_STEP4_1');
        $text_footer_zus = $dbText->getTextByStation($station->code, 'INET_FOOTER_ZUS_TEXT');

        $text_footer->mem = isset($text_footer->mem) ? $text_footer->mem : 'INET_ZUS_TEXT_STEP4_1';
        $text_footer_zus->mem = isset($text_footer_zus->mem) ? $text_footer_zus->mem : 'INET_FOOTER_ZUS_TEXT';

        $js_array = array( //'https://code.jquery.com/jquery-1.11.1.min.js',
            //'https://code.jquery.com/ui/1.10.3/jquery-ui.min.js',
            'System.js',
            'Precheck.js');
        foreach ($js_array as &$js_file) {
            if (file_exists(MODUL_PATH . 'js/' . $js_file)) {
                $js_file = SITEURL . 'js/' . $js_file;
            }
        }

        if (empty($data['startdate'])) {
            $this->error[] = 'SESSION ERROR. Start Date';
        }

        if (empty($data['starttime'])) {
            $this->error[] = 'SESSION ERROR. Start Time';
        }

        if (empty($data['enddate'])) {
            $this->error[] = 'SESSION ERROR. End Date';
        }

        if (empty($data['endtime'])) {
            $this->error[] = 'SESSION ERROR. End Time';
        }

        $data['startdate_time_unix'] = strtotime($data['startdate'] . ' ' . $data['starttime']);
        $data['enddate_time_unix'] = strtotime($data['enddate'] . ' ' . $data['endtime']);

        $customer = null;
        $anreden = unserialize($_SESSION['CACHE']['anreden']);

        if (!is_a($customer, 'Customer')) {
            $customer = new Customer();
            $customer->anrede = $anreden[$post_data['selSal']]->anrede;
            $customer->firstname = $post_data['input-firstname'];
            $customer->lastname = $post_data['input-lastname'];
            $customer->street = $post_data['input-street'];
            $customer->zipcode = $post_data['input-postcode'];
            $customer->city = $post_data['input-city'];
            $customer->email = $post_data['input-email'];
            $customer->phone = $post_data['input-telefon'];
            $customer->payment = $post_data['input-selPay'];
        }

        if (empty($post_data['selSal'])) {
            $post_data['selSal'] = 1;
        }

        if (empty($post_data['input-firstname'])) {
            $post_data['input-firstname'] = $customer->firstname;
        }

        if (empty($post_data['input-lastname'])) {
            $post_data['input-lastname'] = $customer->lastname;
        }

        if (empty($post_data['input-email'])) {
            $post_data['input-email'] = $customer->email;
        }

        if (empty($post_data['input-street'])) {
            $post_data['input-street'] = $customer->street;
        }

        if (empty($post_data['input-postcode'])) {
            $post_data['input-postcode'] = $customer->postcode;
        }

        if (empty($post_data['input-city'])) {
            $post_data['input-city'] = $customer->city;
        }

        if (empty($post_data['input-telefon'])) {
            $post_data['input-telefon'] = $customer->telefon;
        }

        $_SESSION['DATA']['CUSTOMER'] = serialize($customer);

        $dbUser = new DBCustomer();

        $ds = $data['startdate_time_unix'];
        $de = $data['enddate_time_unix'];
        $startday = date('d', $ds);
        $startday_short = $this->getShortWeekday(date('N', $ds));
        $startmonth_short = $this->getShortMonth(date('m', $ds));
        $starttime = date('H:i', $ds);

        $endday = date('d', $de);
        $endday_short = $this->getShortWeekday(date('N', $de));
        $endmonth_short = $this->getShortMonth(date('m', $de));
        $endtime = date('H:i', $de);

        $dateFormat = ($this->registry->lang == 'US') ? 'm/d/Y H:i' : 'd.m.Y H:i';

        $start_date_template = $this->getLangWeekday(date('N', $ds)) . '  ' . date($dateFormat, $ds);
        $end_date_template = $this->getLangWeekday(date('N', $de)) . '  ' . date($dateFormat, $de);
        $rate_dauer = str_replace('.', ',', (($de - $ds) / 3600));

        $dbText = new DBText();
        $station = Station::hasStationCode(Session::getStartStation());
        $zus_text = $dbText->getTextByStation($station->code, 'INET_ZUS_TEXT_STEP4');
        $zus_text2 = $dbText->getTextByStation($station->code, 'INET_ZUS_TEXT_STEP4_1');

        $zus_text->mem = isset($zus_text->mem) ? $zus_text->mem : 'INET_ZUS_TEXT_STEP4';
        $zus_text2->mem = isset($zus_text2->mem) ? $zus_text2->mem : 'INET_ZUS_TEXT_STEP4_1';

        $template->assign('JS_FILES', $js_array);

        $template->assign('NAVI_STEP', 4);
        $template->assign('NAVI_MAX_STEP', $_SESSION['NAVI_MAX_STEP']);
        $template->assign('STARTDAY', $startday);
        $template->assign('STARTDAY_SHORT', $startday_short);
        $template->assign('STARTMONTH_SHORT', $startmonth_short);
        $template->assign('STARTTIME', $starttime);
        $template->assign('ENDDAY', $endday);
        $template->assign('ENDDAY_SHORT', $endday_short);
        $template->assign('ENDMONTH_SHORT', $endmonth_short);
        $template->assign('ENDTIME', $endtime);
        $template->assign('START_DATE_TEMPLATE', $start_date_template);
        $template->assign('END_DATE_TEMPLATE', $end_date_template);
        $template->assign('RATE_DAUER', $rate_dauer);
        $template->assign('ZUS_TEXT', $zus_text->mem);
        $template->assign('ZUS_TEXT_2', $zus_text2->mem);
        $template->assign('TRANSLATE', $translate);
        $template->assign('DATA', $data);
        $template->assign('POST_DATA', $post_data);

        $template->assign('RATES', unserialize($data['rates']['primary']));

        $template->assign('CUSTOMER', $customer);
        $template->assign('CARGROUP', $carGroup);
        //debug($station);
        $template->assign('STARTSTATION', $startstation);
        $template->assign('ENDSTATION', $endstation);
        $template->assign('CURRENCY_SYMBOL', $_SESSION['CONFIG']['CURRENCY_SYMBOL']);
        $template->assign('DISCOUNT', !empty($data['discount']['summe']) ? number_format($data['discount']['summe'], $decimals, $translate['GLOBAL']['DECIMAL'], $translate['GLOBAL']['THOUSAND']) : false);
        $template->assign('DISCOUNT_CODE', !empty($data['discount']['code']) ? $data['discount']['code'] : '');
        $template->assign('SUMM_WITHOUT_DISCOUNT', $summ_without_discount);
        $template->assign('KM_FREE', $km_free);
        $template->assign('TOTAL_PRICE', $data['total_price']);
        $template->assign('INET_ZUS_TEXT', $text_footer->mem);
        $template->assign('INET_FOOTER_ZUS_TEXT', $text_footer_zus->mem);
        $template->assign('LANG', $this->registry->lang);

        if (!empty($this->error)) {
            goError($this->error);
        }

        $template->display('precheck_index.html');

        $_SESSION['POST'] = array();
        unset($_SESSION['POST']);
    } // index();

    private function getShortMonth($num = 0)
    {
        if (empty($_SESSION['TRANSLATIONS'][$this->registry->lang]['Monate_kurz'])) {
            $dbTranslate = new DBTranslate();
            $_SESSION['TRANSLATIONS'][$this->registry->lang]['Monate_kurz'] = $dbTranslate->loadTranslations('Monate_kurz', $this->registry->lang);
        }

        $translate = $_SESSION['TRANSLATIONS'][$this->registry->lang]['Monate_kurz'];

        // print_r($translate);
        // exit;
        if ($num == 0) {
            $num = (int) date('m');
        }

        switch ($num) {
            case 1:
                $month = $translate['Januar'];
                break;
            case 2:
                $month = $translate['Februar'];
                break;
            case 3:
                $month = $translate['Maerz'];
                break;
            case 4:
                $month = $translate['April'];
                break;
            case 5:
                $month = $translate['Mai'];
                break;
            case 6:
                $month = $translate['Juni'];
                break;
            case 7:
                $month = $translate['Juli'];
                break;
            case 8:
                $month = $translate['August'];
                break;
            case 9:
                $month = $translate['September'];
                break;
            case 10:
                $month = $translate['Oktober'];
                break;
            case 11:
                $month = $translate['November'];
                break;
            case 12:
                $month = $translate['Dezember'];
                break;
            default:
                $month = '';
        }

        return $month;
    } // getLangMonth()

    private function getShortWeekday($num = 0)
    {
        if (empty($_SESSION['TRANSLATIONS'][$this->registry->lang]['Wochentage_kurz'])) {
            $dbTranslate = new DBTranslate();
            $dbTranslate->loadTranslations('Wochentage_kurz', $this->registry->lang);
        }

        $translate = $_SESSION['TRANSLATIONS'][$this->registry->lang]['Wochentage_kurz'];

        if ($num == 0) {
            $num = (int) date('N');
        }

        switch ($num) {
            case 1:
                $weekday = $translate['Montag'];
                break;
            case 2:
                $weekday = $translate['Dienstag'];
                break;
            case 3:
                $weekday = $translate['Mittwoch'];
                break;
            case 4:
                $weekday = $translate['Donnerstag'];
                break;
            case 5:
                $weekday = $translate['Freitag'];
                break;
            case 6:
                $weekday = $translate['Samstag'];
                break;
            case 7:
                $weekday = $translate['Sonntag'];
                break;
            default:
                $weekday = '';
        }

        return $weekday;
    } // getLangWeekday()
} // Class ControllerLogin
