<?php
class ControllerRental extends ControllerBase
{
    public function index()
    {

        $this->checkLogin();

        Cache::clearConfirmContent();
        if (!empty($_COOKIE['login_hash'])) {
            $dbCustomer = new DBCustomer;
            $tmp = $dbCustomer->getInfoBypassHash($_COOKIE['login_hash']);
            if (!empty($tmp->NUMMER)) {
                $user = new Customer($tmp->NUMMER);
                if (!empty($user->id) && empty($user->is_tmp) && $user->is_inet_active == 1) {
                    Session::setCustomer($user);
                }
            }
        }
        $orm = false;
        foreach ($this->registry->module as $modul) {
            if ($modul['Modul'] == 'ORM' && $modul['enabled'] == 'J') {
                $orm = true;
                break;
            }
        }

        if (!$orm) {
            header('location: ' . SITEURL . 'checkinstall?redirect');
            exit();
        }
        // AK 28.04.2017 - Aufgabe 83966: Login nur anzeigen wenn Modul aktiviert
        $show_login = Module::isEnabled('ORM_LOGIN');
        // Wenn das Historie oder Storno erlaubt sind, muss Login auch sichtbar sein
        if (Module::isEnabled('ORM_HISTORIE') || Module::isEnabled('ORM_STORNO')) {
            $show_login = true;
        }

        Station::updatePosition();
        $DBCategories = new DBCategories();
        $tmp_session = array();

        if (isset($_SESSION['CONFIG'])) {
            $tmp_session['CONFIG'] = $_SESSION['CONFIG'];
        }

        if (isset($_SESSION['DATA']['login'])) {
            $tmp_session['DATA']['login'] = $_SESSION['DATA']['login'];
        }

        if (isset($_SESSION['DATA']['discount'])) {
            $tmp_session['DATA']['discount'] = $_SESSION['DATA']['discount'];
        }

        if (isset($_SESSION['TRANSLATIONS'])) {
            $tmp_session['TRANSLATIONS'] = $_SESSION['TRANSLATIONS'];
        }

        if (isset($_SESSION['CACHE']['STATIONS_DEP']) && isset($_SESSION['CACHE']['STATIONS_ARR'])) {
            $tmp_session['CACHE']['STATIONS_DEP'] = $_SESSION['CACHE']['STATIONS_DEP'];
            $tmp_session['CACHE']['STATIONS_ARR'] = $_SESSION['CACHE']['STATIONS_ARR'];
        }

        $user = Session::getCustomer();
        $_SESSION = array();

        foreach ($tmp_session as $key => $value) {
            $_SESSION[$key] = $value;
        }

        Session::setCustomer($user);

        $_SESSION['NAVI_MAX_STEP'] = 1;
        $_SESSION['STEP'] = 1;

        $region_ins = new Region();
        $region = $region_ins->getRegion();

        $angpk = 0; // Reserv

        $translate = $this->loadTranslations(array('MESSAGE', 'FZG', 'RENTAL', 'Wochentage', 'Wochentage_kurz', 'Monate_kurz', 'Feiertage', 'ERROR', 'GLOBAL', 'STEP1', 'STATION_SELECT', 'STATION_DETAILS', 'LOGIN', 'Einheiten', 'EinheitEinzahl', 'CURRENCY', 'OFFERS', 'crent.ratedata', 'LOGIN_BAR', 'FILTER'));

        $station = new Station();
        $station->getStationsBlock();

        $stations_dep = Station::getStationListFromCache('departure');
        $stations_arr = Station::getStationListFromCache('arrival');

        $user = Session::getCustomer();
        $login = (isset($_SESSION['DATA']['login']['isLoggedIn'])) ? true : false;

        $is_angebote = Module::isEnabled('ORM_ANGEBOTE');
        $angebote = array();
        $hide_angebote = (isset($_GET['noangebote']) && $_GET['noangebote'] == 1) ? true : false;
        $angebote_kfzart = '%';
        if (isset($_GET['ang_kfzart']) && $_GET['ang_kfzart'] != '') {
            $angebote_kfzart = $_GET['ang_kfzart'];
        }
        $js_array = [];
        if ($is_angebote && !$hide_angebote) {
            $dbAngebote = new DBAngebote();
            $angebote = $dbAngebote->getAngebote($angebote_kfzart);

            foreach ($angebote as &$angebot) {
                $angebot['HEADER'] = isset($translate['crent.ratedata']['' . $angebot['RATE'] . '.' . $angebot['GRUPPE'] . '.offer_caption']) ? $translate['crent.ratedata']['' . $angebot['RATE'] . '.' . $angebot['GRUPPE'] . '.offer_caption'] : $angebot['HEADER'];
                $angebot['BESCH2'] = isset($translate['crent.ratedata']['' . $angebot['RATE'] . '.' . $angebot['GRUPPE'] . '.offer_description']) ? $translate['crent.ratedata']['' . $angebot['RATE'] . '.' . $angebot['GRUPPE'] . '.offer_description'] : $angebot['BESCH2'];
            }
        }

        foreach ($js_array as &$js_file) {
            if (file_exists(MODUL_PATH . 'js/' . $js_file)) {
                $js_file = SITEURL . 'js/' . $js_file;
            }
        }

        //check if stations filter is set
        if (CONFIG_FILTER_STATIONLIST == 1) {
            array_push($js_array, 'geonames.js');
        }

        $categories = array();
        if (Params::getValue('BINET_KATEGORIEVORAUSWAHL') == 1) {
            foreach ($DBCategories->getAll() as $key => $val) {
                $db_cat_name = !empty($translate['GRUPPE']['KATEGORIE'][md5($val)]) ? $translate['GRUPPE']['KATEGORIE'][md5($val)] : $val;
                if (!key_exists($this->catNameHash($db_cat_name), $categories)) {
                    $categories[$this->catNameHash($db_cat_name)]['name'] = $db_cat_name;
                    $categories[$this->catNameHash($db_cat_name)]['sort'] = $key;
                }
            }

            if (!defined('CATEGORY_FILTER_DONT_AFFECT_SORTING') or !CATEGORY_FILTER_DONT_AFFECT_SORTING) {
                uasort($categories, function ($a, $b) {
                    return $a['sort'] - $b['sort'];
                });
            }
        }

        // AK 02.06.2016 - Angebot PK per Parameter vorbelegen können
        if (!empty($_GET['ANGEBOTPK']) && intval($_GET['ANGEBOTPK']) > 0) {
            $_SESSION['ANGEBOTPK'] = intval($_GET['ANGEBOTPK']);
        }

        // AK 02.06.2016 - Fahrzeugkategorie per Parameter vorbelegen können
        // AK 24.11.2016 - $_SESSION['DATA']['DEFAULT_CATEGORY'] entfernt und durch $_SESSION['DATA']['CATEGORY'] ersetzt
        $default_category = '';
        if (!empty($_GET['category'])) {
            $_SESSION['DATA']['CATEGORY'] = $this->catNameHash($_GET['category']);
        } elseif (!empty($_GET['category_default'])) {
            $_SESSION['DATA']['CATEGORY'] = $this->catNameHash($_GET['category_default']);
        } elseif (!empty($_GET['kategorie-select'])) {
            $_SESSION['DATA']['CATEGORY'] = trim(htmlspecialchars($_GET['kategorie-select']));
        }

        $default_category = !empty($_SESSION['DATA']['CATEGORY']) ? $_SESSION['DATA']['CATEGORY'] : '';
        $default_category_name = !empty($categories[$default_category]) ? $categories[$default_category]['name'] : '';

        $default_station = null;

        // check url parameters
        if (!empty($_GET['station']) || !empty($_GET['startstation'])) {
            $station_code = !empty($_GET['station']) ? $_GET['station'] : $_GET['startstation'];
            foreach ($stations_dep as $st) {
                if ($st->code == $station_code) {
                    $default_station = $st;
                    break;
                }
            }
        }

        $default_end_station = $default_station;

        if (!empty($_GET['station']) || !empty($_GET['endstation'])) {
            $station_code = !empty($_GET['station']) ? $_GET['station'] : $_GET['endstation'];
            foreach ($stations_arr as $st) {
                if ($st->code == $station_code) {
                    $default_end_station = $st;
                    break;
                }
            }
        }

        $stations_all = Station::getAll();

        // if there is only one station use it
        if (count($stations_all) == 1) {
            $default_station = $stations_all[0];
            $default_end_station = $stations_all[0];
        }

        $startdatetime = 0;
        $minstartdatetime = 0;
        if (!empty($default_station)) {
            if (!empty($_GET['startdatetime'])) {
                $startdatetime = $_GET['startdatetime'];
                $minstartdatetime = $startdatetime;
            } else {
                $startdatetime = $default_station->getFirstOpenTime() * 1000;
                $minstartdatetime = $startdatetime;
            }
            if (!empty($_GET['enddatetime'])) {
                $enddatetime = $_GET['enddatetime'];
                $minenddatetime = $enddatetime;
            } else {
                $enddatetime = $startdatetime + 24 * 60 * 60 * 1000;
            }
        } else {
            if (!empty($_GET['startdatetime'])) {
                $startdatetime = $_GET['startdatetime'];
                $minstartdatetime = $startdatetime;
            } else {
                $datetime = new DateTime();
                $hour = $datetime->format('H');
                $minuten = $datetime->format('i');
                if ($datetime->format('i') <= 30) {
                    $datetime->setTime($hour, 30, 0);
                } else {
                    $datetime->setTime($hour + 1, 0, 0);
                }
                $minstartdatetime = $datetime->getTimestamp() * 1000;

                if ($datetime->format('H:i') > '08:00') {
                    $datetime->add(new DateInterval('P1D'));
                }
                $datetime->setTime(8, 0, 0);
                $startdatetime = $datetime->getTimestamp() * 1000;
            }
            if (!empty($_GET['enddatetime'])) {
                $enddatetime = $_GET['enddatetime'];
                $minenddatetime = $enddatetime;
            } else {
                $enddatetime = $startdatetime + 24 * 60 * 60 * 1000;
                $minenddatetime = $startdatetime;
            }
        }

        $dbText = new DBText();
        $station = Station::hasStationCode(Session::getStartStation());
        $password_reset_text = $dbText->getTextByStation($station->code, 'PASSWORD_RESET_TEXT');
        $password_reset_text->mem = isset($password_reset_text->mem) ? $password_reset_text->mem : 'PASSWORD_RESET_TEXT';

        $module = new Module();
        $Currency = new Currency();
        $DBCurrency = new DBCurrency();
        if (!isset($_SESSION['CONFIG']['CURRENCY'])) {
            $dbCurrency = $DBCurrency->getBaseCurrency();
            $_SESSION['CONFIG']['CURRENCY'] = $dbCurrency->ISOCode;
            $_SESSION['CONFIG']['CURRENCY_SYMBOL'] = $dbCurrency->Symbol;
        } else {
            $dbCurrency = $DBCurrency->getCurrency();
        }
        $Currency->description = $dbCurrency->Beschreibung;
        $Currency->symbol = $dbCurrency->Symbol;
        $Currency->conversion = $dbCurrency->Umrechnungsfaktor;
        $Currency->ISOcode = $dbCurrency->ISOCode;
        $Currency->description_lang = !empty($translate['CURRENCY'][$Currency->ISOcode]) ? $translate['CURRENCY'][$Currency->ISOcode] : $Currency->description;
        $template = $this->template;
        $template->assign('JS_FILES', $js_array);
        $template->assign('IS_ANGEBOTE', $is_angebote);
        $template->assign('ANGEBOTE', $angebote);
        $template->assign('HIDE_ANGEBOTE', $hide_angebote);
        $template->assign('LOGIN', $login);
        $template->assign('SHOW_LOGIN', $show_login);
        $template->assign('USER', Session::getCustomer());
        $template->assign('TITLE', isset($translate['STEP1']['SITETITLE']) ? $translate['STEP1']['SITETITLE'] : 'STEP1.SITETITLE');
        $template->assign('TRANSLATE', $translate);
        $template->assign('CURRENCY', $Currency);
        $template->assign('STATIONS_DEP', $stations_dep);
        $template->assign('STATIONS_ARR', $stations_arr);
        $template->assign('STATION_DEP', $default_station);
        $template->assign('STATION_ARR', $default_end_station);
        $template->assign('STARTDATETIME', $startdatetime);
        $template->assign('ENDDATETIME', $enddatetime);
        $template->assign('MINSTARTDATETIME', $minstartdatetime);
        $template->assign('MINENDDATETIME', $minenddatetime);
        $template->assign('BINET_KATEGORIEVORAUSWAHL', Params::getValue('BINET_KATEGORIEVORAUSWAHL'));
        $template->assign('ZIP_CODE_SEARCH', defined('ZIP_CODE_SEARCH') ? ZIP_CODE_SEARCH : 0);
        $template->assign('CATEGORIES', $categories);
        $template->assign('CARSCATEGORIES', $categories);
        $template->assign('REGION', $region);
        $template->assign('PASSWORD_RESET_TEXT', $password_reset_text->mem);
        $template->assign('FORCE_CUSTOMER_LOGIN', defined('FORCE_CUSTOMER_LOGIN') && FORCE_CUSTOMER_LOGIN == 1 ? true : false);
        $template->assign('CARSCATEGORY_DEFAULT', $default_category);
        $template->assign('CARSCATEGORY_DEFAULT_NAME', $default_category_name);

        $every_time_departure_shedule = Station::getOpenTimeEveryTime('departure');
        $every_time_return_shedule = Station::getOpenTimeEveryTime('return');
        $template->assign('EVERY_TIME_DEPARTURE_SHEDULE', json_encode($every_time_departure_shedule));
        $template->assign('EVERY_TIME_RETURN_SHEDULE', json_encode($every_time_return_shedule));

        $template->assign('LANG', $this->registry->lang);
        $template->assign('NAVI_STEP', 1);
        $template->assign('NAVI_MAX_STEP', 1);

        $this->afterTemplate();
        $template->display('rental_index.html');
    } // Index

    public function getStationInfo()
    {
        if (isset($_GET['code']) && trim($_GET['code']) != '' && (@$_SERVER['HTTP_X_REQUESTED_WITH'] == 'XMLHttpRequest' || AJAX_DEBUG)) {
            $code = trim($_GET['code']);

            $dbTranslate = new DBTranslate();
            $translate = array();
            $translate = $dbTranslate->loadTranslations('Wochentage', $this->registry->lang);
            $dateTimeFormat = new DateTimeFormat();

            $dbStations = new DBStation();

            $dbStation = $dbStations->getStationByCode($code);

            if ($dbStation !== false) {
                $station = new Station();

                $station->code = $code;
                $station->name = $dbStation->name;
                $station->country = $dbStation->land;
                $station->stat = $dbStation->Bundeslandkuerzel;
                $station->street = $dbStation->strasse;
                $station->city = $dbStation->ort;
                $station->zipcode = $dbStation->plz;
                $station->phone = $dbStation->Telefon;
                $station->fax = $dbStation->Fax;
                $station->email = $dbStation->EMail;
                $station->url = $dbStation->url;
                $station->min_vorlauf = $dbStation->min_vorlauf;
                $schedule = new StationSchedule();
                $station->shedules = $schedule->getSchedule($station->code);

                $week_days = array('mo', 'di', 'mi', 'do', 'fr', 'sa', 'so');
                $week_tmp_arr = array();

                foreach ($station->shedules as &$shedule) {
                    $shedule->day = strtolower($shedule->day);
                    $week_tmp_arr[] = $shedule->day;
                }

                foreach (array_diff($week_days, $week_tmp_arr) as $week_day) {
                    $station->shedules[] = array('day' => $week_day, 'btime' => '00:00', 'etime' => '00:00', 'mbtime' => '00:00', 'metime' => '00:00');
                }

                for ($i = 0; $i < count($station->shedules); $i++) {
                    foreach ($station->shedules[$i] as $key => &$val) {
                        if ($key == 'day') {
                            switch ($val) {
                                case 'mo':
                                    $val = $translate['Montag'];
                                    break;
                                case 'di':
                                    $val = $translate['Dienstag'];
                                    break;
                                case 'mi':
                                    $val = $translate['Mittwoch'];
                                    break;
                                case 'do':
                                    $val = $translate['Donnerstag'];
                                    break;
                                case 'fr':
                                    $val = $translate['Freitag'];
                                    break;
                                case 'sa':
                                    $val = $translate['Samstag'];
                                    break;
                                case 'so':
                                    $val = $translate['Sonntag'];
                                    break;
                            }
                        }
                        if ($key == 'stationClosed' && $val) {
                        }
                    }
                }
                if (isset($this->registry->args[0]) && $this->registry->args[0] == 'mobile') {
                    $_SESSION['MOBILE']['CACHE']['mietstation_page'] = serialize($station);
                }

                foreach ($station->shedules as &$val) {
                    $val->btime = $dateTimeFormat->getTime($val->btime);
                    $val->etime = $dateTimeFormat->getTime($val->etime);
                    $val->mbtime = $dateTimeFormat->getTime($val->mbtime);
                    $val->metime = $dateTimeFormat->getTime($val->metime);
                }
                unset($val);
                echo json_encode($station);
            } else {
                echo json_encode(array("error" => "Error"));
            }
        } else {
            echo json_encode(array("error" => "Error"));
        }
    } // getStationInfo()

    public function getStationsBlock()
    {
        $dbTranslate = new DBTranslate();
        $translate = array(
            'RENTAL' => $dbTranslate->loadTranslations('RENTAL', $this->registry->lang),
            'Wochentage' => $dbTranslate->loadTranslations('Wochentage', $this->registry->lang),
            'Wochentage_kurz' => $dbTranslate->loadTranslations('Wochentage_kurz', $this->registry->lang),
        );

        $dbStations = new DBStation();
        $stations_dep = array();
        $stations_arr = array();

        $region = !empty($_GET['region']) ? $_GET['region'] : (!empty($_SESSION['DATA']['region']) ? $_SESSION['DATA']['region'] : '');

        foreach ($dbStations->getAllStations(0, $region) as $dbStation) {
            $station = new Station();

            $station->code = $dbStation->station;
            $station->name = (!empty($dbStation->INET_NAME)) ? $dbStation->INET_NAME : $dbStation->name;
            $station->country = $dbStation->land;
            $station->stat = $dbStation->bundeslandkuerzel;
            $station->street = $dbStation->strasse;
            $station->city = $dbStation->ort;
            $station->zipcode = $dbStation->plz;
            $station->phone = $dbStation->telefon;
            $station->fax = $dbStation->fax;
            $station->email = $dbStation->email;
            $station->url = $dbStation->url;
            $station->min_vorlauf = $dbStation->forerun;
            $station->onlyci = $dbStation->onlyCI;
            $station->shedules = $dbStations->getStationSchedule($station->code);

            $week_days = array('mo', 'di', 'mi', 'do', 'fr', 'sa', 'so');
            $week_tmp_arr = array();

            for ($i = 0; $i < count($station->shedules); $i++) {
                foreach ($station->shedules[$i] as $key => &$val) {
                    if ($key != 'day' && $key != 'day_lang' && isset($val) && strlen($val) == 4) {
                        $val = substr($val, 0, 2) . ":" . substr($val, 2, 4);
                    } else {
                        if ($key != 'day_lang') {
                            $val = strtolower($val);
                            $week_tmp_arr[] = $val;
                        }
                    }
                }
            }

            $stations_arr[] = $station;

            if ($station->onlyci == 0) {
                $stations_dep[] = $station;
            }
        }

        $_SESSION['CACHE']['STATIONS_DEP'] = serialize($stations_dep);
        $_SESSION['CACHE']['STATIONS_ARR'] = serialize($stations_arr);

        if ((AJAX_DEBUG || @$_SERVER['HTTP_X_REQUESTED_WITH'] == 'XMLHttpRequest') && !empty($_GET['stations_typ'])) {
            $template = $this->template;
            $template->assign('STATIONS_DEP', $stations_dep);
            $template->assign('STATIONS_ARR', $stations_arr);
            $template->assign('TRANSLATE', $translate);

            $out = $template->fetch('station_list.html');

            echo $out;
        } else {
            //return array('stations_dep' => $stations_dep, 'stations_arr' => $stations_arr);
        }
    } // getstationsBlock()

    public function getReturnStationsCode($json = true)
    {
        if (isset($_GET['startstation']) && trim($_GET['startstation']) != '' && (@$_SERVER['HTTP_X_REQUESTED_WITH'] == 'XMLHttpRequest' || AJAX_DEBUG)) {
            $DBStation = new DBStation();
            $stations = $DBStation->getReturnStations(trim($_GET['startstation']));
            if ($json) {
                echo json_encode($stations);
            } else {
                return $stations;
            }
        }

        exit;
    } // getReturnStationsCode()

    // Private Functions
    protected function afterTemplate()
    {
    }
} // Class ControllerRental
