<?php
class ControllerSummary extends ControllerBase
{
    public function index()
    {
        $this->checkLogin();

        $_SESSION['DATA']['new_customer'] = 0;
        $_SESSION['error_flag'] = 0;
        $dateTimeFormat = new DateTimeFormat();
        $_SESSION['POST'] = array();
        unset($_SESSION['POST']);

        $_SESSION['NAVI_MAX_STEP'] = 4;
        $_SESSION['STEP'] = 4;

        DataCheck::checkStep3();
        $translate = $this->loadTranslations(array('MESSAGE', 'RESERVATE', 'RENTAL', 'RATE', 'FZG', 'WEBEMAIL', 'STEP4',
            'NAVI', 'GLOBAL', 'LOGIN_BAR', 'LOGIN', 'STEP_MENU', 'BUCHUNGSFILTER', 'TOP_LINK', 'USERDATA', 'ERRORS', 'NEW_PASSWORD', 'STATION_SELECT', 'STATION', 'STATION_BLOCK', 'Wochentage', 'Wochentage_kurz', 'Monate_kurz', 'Feiertage'));

        $anreden = '';
        $payArtsArr = array();
        $years = '';
        $months = '';
        $station_dep = '';
        $station_arr = '';
        $rate = '';
        $car_group = '';
        $currency = '';
        $extras = '';
        $customer = '';
        $is_login = false;
        $mandant = '';
        $total_price = 0;

        if (count($this->error) == 0 || $this->session_error) {
            $cacheCurrency = Cache::getCurrency();
            $currency = new Currency();
            $currency->decodeFromDb($cacheCurrency);

            $dbMandant = new DBMandant();
            $dbMandantObj = $dbMandant->getInfo();

            $mandant = new Mandant();
            $mandant->decodeFromDb($dbMandantObj);
            $mandant->logo = $dbMandant->getLogo();

            $dbAnrede = new DBAnrede();
            $dbAnredenObj = $dbAnrede->getAll(Session::getLang());

            $anreden = array();
            foreach ($dbAnredenObj as $dbObj) {
                $anrede = new Anrede();
                $anrede->decodeFromDb($dbObj);
                $anreden[$anrede->id] = $anrede;
            }

            $_SESSION['CACHE']['anreden'] = serialize($anreden);

            $car_group = Session::getCarGroup();

            $dbPayArt = new DBPayart();
            $dbPayArtsObj = $dbPayArt->getAll($car_group->cargroupid);
            $payArtsArr = array();
            foreach ($dbPayArtsObj as $dbObj) {
                $payArt = new PayArts();
                $payArt->decodeFromDb($dbObj);
                if (empty($payArt->web_name_lang) || strtoupper($payArt->web_name_lang) == 'NULL') {
                    $payArt->web_name_lang = $payArt->web_name;
                }
                $payArtsArr[$payArt->id] = $payArt;
            }
            $_SESSION['CACHE']['zahlungsarten'] = serialize($payArtsArr);

            $years = array();
            for ($i = intval(date('Y')); $i < intval(date('Y')) + 10; $i++) {
                $years[] = $i;
            }

            $months = array();
            for ($i = 1; $i <= 12; $i++) {
                $months[] = $i < 10 ? '0' . $i : $i;
            }

            $station_dep = Session::getStartStation();
            $station_arr = Session::getEndStation();

            $rate = unserialize($_SESSION['DATA']['rates']['primary']);
            $rate_km = '';
            foreach ($rate as $val) {
                if ($val->rate == 'KM') {
                    $rate_km = $val;
                    break;
                }
            }

            $rate = $rate[0];

            $extras = array();
            $subrates = unserialize($_SESSION['DATA']['rates']['subrates']['options']);

            foreach ($subrates as $subrate) {
                if ($subrate->selected == 1) {
                    $extras[] = $subrate;
                }
            }

            $customer = Session::getCustomer();
            $is_login = !empty($customer->id);
            $dbText = new DBText();
            $station = Station::hasStationCode(Session::getStartStation());
            $text_footer = $dbText->getTextByStation($station->code, 'INET_AGB');
            $zus_text = $dbText->getTextByStation($station->code, 'INET_ZUS_TEXT_STEP4');
            $inet_payment = $dbText->getTextByStation($station->code, 'INET_PAYMENT');
            $mailto_text = $dbText->getTextByStation($station->code, 'INET_MAILTO_TEXT');

            $text_footer->mem = isset($text_footer->mem) ? $text_footer->mem : 'INET_AGB';
            $zus_text->mem = isset($zus_text->mem) ? $zus_text->mem : 'INET_ZUS_TEXT_STEP4';
            $inet_payment->mem = isset($inet_payment->mem) ? $inet_payment->mem : 'INET_PAYMENT';
            $mailto_text->mem = isset($mailto_text->mem) ? $mailto_text->mem : 'INET_MAILTO_TEXT';
        }

        $js_array = array( // 'libs/parsley.min.js',
            'Summary.js', 'jquery.creditCardValidator.js', 'iframeResizer.contentWindow.js');
        foreach ($js_array as &$js_file) {
            if (file_exists(MODUL_PATH . 'js/' . $js_file)) {
                $js_file = SITEURL . 'js/' . $js_file;
            }
        }

        if (!empty($_SESSION['ERROR'])) {
            $this->error = array_merge($this->error, $_SESSION['ERROR']);
            unset($_SESSION['ERROR']);
        }
//--- TEMPLATE ASSIGN

        // AK 28.04.2017 - Aufgabe 83966: Login nur anzeigen wenn Modul aktiviert
        $show_login = Module::isEnabled('ORM_LOGIN');
        // Wenn das Historie oder Storno erlaubt sind, muss Login auch sichtbar sein
        if (Module::isEnabled('ORM_HISTORIE') || Module::isEnabled('ORM_STORNO')) {
            $show_login = true;
        }

        $template = $this->template;
        $template->assign('JS_FILES', $js_array);

        $template->assign('TITLE', isset($translate['STEP4']['SITETITLE']) ? $translate['STEP4']['SITETITLE'] : 'STEP4.SITETITLE');
        $template->assign('ERROR', $this->error);
        $template->assign('TRANSLATE', $translate);
        $template->assign('NAVI_STEP', $_SESSION['STEP']);
        $template->assign('NAVI_MAX_STEP', $_SESSION['NAVI_MAX_STEP']);
        $template->assign('SHOW_LOGIN', $show_login);
        $template->assign('SID', session_id());
        $template->assign('ANREDE', $anreden);
        $template->assign('PAY', $payArtsArr); //debug($payArtsArr,0);

        $js_pay_credit_cards_arr = array();
        foreach ($payArtsArr as $pay) {
            if ($pay->credit_card) {
                $js_pay_credit_cards_arr[] = (int) $pay->id;
            }
        }

        if (count($js_pay_credit_cards_arr) > 0) {
            $jsPayCreditCardsString = '["' . implode('" , "', $js_pay_credit_cards_arr) . '"]';
        } else {
            $jsPayCreditCardsString = false;
        }

        $template->assign('CREDIT_CARDS_ARR', $jsPayCreditCardsString);
        $template->assign('pPAYMENTDISPLAY', (isset($customer->kknummer) ? '' : 'invisible'));

        $template->assign('YEARS', $years);
        $template->assign('MONTHS', $months);

        $template->assign('STATION_DEP', $station_dep);
        $template->assign('STATION_ARR', $station_arr);

        $start_date_time = new DateTime;
        $start_date_time->setTimestamp(Session::getStartDateTime());
        $end_date_time = new DateTime;
        $end_date_time->setTimestamp(Session::getEndDateTime());
        $date = array('date_dep' => $start_date_time->format($dateTimeFormat->getDateFormat()),
            'date_arr' => $end_date_time->format($dateTimeFormat->getDateFormat()),
            'time_dep' => $start_date_time->format($dateTimeFormat->getTimeFormat()),
            'time_arr' => $end_date_time->format($dateTimeFormat->getTimeFormat()),
        );

        $stations_dep = Station::getStationListFromCache('departure');
        $stations_arr = Station::getStationListFromCache('arrival');

        $password_reset_text = $dbText->getTextByStation($station->code, 'PASSWORD_RESET_TEXT');
        $password_reset_text->mem = isset($password_reset_text->mem) ? $password_reset_text->mem : 'PASSWORD_RESET_TEXT';

        $template->assign('STATIONS_DEP', $stations_dep);
        $template->assign('STATIONS_ARR', $stations_arr);

        $template->assign('DATE', $date);

        $template->assign('RATE', $rate);
        $template->assign('RATE_KM', $rate_km);
        $template->assign('CAR_GROUP', $car_group); //debug($car_group);
        $template->assign('CURRENCY', $currency);
        $template->assign('COMMENT', isset($_SESSION['DATA']['comment']) ? $_SESSION['DATA']['comment'] : '');
        $template->assign('EXTRAS', $extras);

        $template->assign('CUSTOMER', $customer);

        $template->assign('MANDANT', $mandant);

        $template->assign('PRICE', $total_price);
        // AK 23.09.2015 Aufgabe 71750: alle Preise sollen auch in Netto angezeigt werden
        $template->assign('PRICE_NETTO', $_SESSION['DATA']['total_price_netto'] * $currency->conversion);

        $template->assign('TEXT_FOOTER', $text_footer->mem);
        $template->assign('INET_ZUS_TEXT', $zus_text->mem);
        $template->assign('INET_PAYMENT', $inet_payment->mem);
        $template->assign('PASSWORD_RESET_TEXT', $password_reset_text->mem);

        $template->assign('DISCOUNT_CODE', !empty($_SESSION['DATA']['discount']['code']) ? $_SESSION['DATA']['discount']['code'] : '');
        $template->assign('ANGEBOT_SHARE', Params::getValue('BINET_SHARE_OFFER'));

        $template->assign('LANG', $this->registry->lang);

        $dbError = new DBError();
        $errors = $dbError->checkErrors(4, $start_date_time, $end_date_time, $station_dep, $station_arr, $car_group->code);

        // if(!empty($errors[0])) goError($errors);
        // debug($_SESSION );
        if (isset($_SESSION['ERROR_FLAGS'])) {
            $template->assign('ERROR_FLAGS', $_SESSION['ERROR_FLAGS']);
            $is_login = false;
            unset($_SESSION['ERROR_FLAGS']);
        }

        if (!empty($_SESSION['ERROR_LIST'])) {
            $template->assign('ERRORS_INLINE', $_SESSION['ERROR_LIST']);
            $is_login = false;
            unset($_SESSION['ERROR_LIST']);
        }

        $template->assign('LOGIN', $is_login);
        $template->assign('SHOW_KK_INPUTS', defined('CONFIG_SHOW_KK_INPUTS') ?CONFIG_SHOW_KK_INPUTS : 0);

        $template->display('global_template.html');
    } // index()

    public function addcoment()
    {
        if ((@$_SERVER['HTTP_X_REQUESTED_WITH'] == 'XMLHttpRequest' || AJAX_DEBUG) && isset($_POST['text']) && trim($_POST['text']) != '') {
            $_SESSION['DATA']['comment'] = trim($_POST['text']);
        }
    } // addcoment

    public function SaveCustomerData()
    {
        if ((@$_SERVER['HTTP_X_REQUESTED_WITH'] == 'XMLHttpRequest' || AJAX_DEBUG)) {
            $_SESSION['DATA']['customer_data']['firstname'] = !empty($_GET['firstname']) ?trim($_GET['firstname']) : '';
            $_SESSION['DATA']['customer_data']['lastname'] = !empty($_GET['lastname']) ?trim($_GET['lastname']) : '';
            $_SESSION['DATA']['customer_data']['street'] = !empty($_GET['street']) ?trim($_GET['street']) : '';
            $_SESSION['DATA']['customer_data']['postcode'] = !empty($_GET['postcode']) ?trim($_GET['postcode']) : '';
            $_SESSION['DATA']['customer_data']['city'] = !empty($_GET['city']) ?trim($_GET['city']) : '';
            $_SESSION['DATA']['customer_data']['email'] = !empty($_GET['email']) ?trim($_GET['email']) : '';
            $_SESSION['DATA']['customer_data']['telefon'] = !empty($_GET['telefon']) ?trim($_GET['telefon']) : '';
            $_SESSION['DATA']['customer_data']['anrede'] = !empty($_GET['anrede']) ?trim($_GET['anrede']) : '';
            $_SESSION['DATA']['comment'] = !empty($_GET['comment']) ?trim($_GET['comment']) : '';
        }
    } // SaveCustomerData()
} // Class ControllerSummary
