<?php
header('Access-Control-Allow-Origin: *');
header('Access-Control-Allow-Headers: x-requested-with, content-type, origin, accept');
header('Access-Control-Allow-Methods: GET, PUT, POST, DELETE, OPTIONS');

if (!defined('MODUL_PATH')) {
    die('Access denied');
}

if (!defined('DEBUG')) {
    define('DEBUG', false);
}

if (version_compare(phpversion(), '5.4.0', '<') == true) {
    die('PHP5.4 Only');
}

date_default_timezone_set(defined('DEFAULT_TIMEZONE') ?DEFAULT_TIMEZONE : "Europe/Berlin");

include_once APP_PATH . 'includes/errors.php';

if (!file_exists(APP_PATH . 'classes/Smarty/templates_c')) {
    if (!mkdir(APP_PATH . 'classes/Smarty/templates_c', 0777)) {
        die('Das Verzeichnis "' . APP_PATH . 'classes/Smarty/templates_c" kann nicht erstellt werden.');
    }
} elseif (!is_writable(APP_PATH . 'classes/Smarty/templates_c')) {
    die('Das Verzeichnis "' . APP_PATH . 'classes/Smarty/templates_c" ist nicht beschreibbar.');
}

$rewrite = 0;
if (function_exists('apache_get_modules')) {
    foreach (apache_get_modules() as $v) {
        if ($v == 'mod_rewrite') {
            $rewrite = 1;
        }
    }
}
if ($rewrite == 0) {
    $boolValue = isset($_SERVER['HTTP_MOD_REWRITE']);
    if ($boolValue) {
        $rewrite = 1;
    } else {
        die('<strong>mod_rewrite required</strong> but could not be found - please ensure that your .htaccess contents:<br />
            &lt;IfModule mod_rewrite.c&gt;<br />
            SetEnv HTTP_MOD_REWRITE On<br />
            &lt;/IfModule&gt;<br />');
    }
}

if (isset($_REQUEST['PHPSESSID']) && preg_match('/^[0-9a-zA-Z]+/', $_REQUEST['PHPSESSID']) == 1) {
    session_id($_REQUEST['PHPSESSID']);
}
session_start();

if (!defined('LOG_PATH')) {
    define('LOG_PATH', MODUL_PATH . DIRSEP . 'logs' . DIRSEP);
}

require_once APP_PATH . 'includes/postredirect.php';

require_once APP_PATH . 'includes/init.php';
require_once APP_PATH . 'controllers/controller_base.php';
require_once APP_PATH . 'classes/Smarty/libs/Smarty.class.php';
require_once APP_PATH . 'includes/translate_init.php';

$registry = Registry::getInstance();

try {
    if (!empty($instance)) {
        $hostWithoutInstance = str_replace('\\' . $instance, '', $host);
        $registry->db = new DBPDOConnect($hostWithoutInstance . (empty($port) ? '' : ':' . $port) . '\\' . $instance, $username, isset($password) ? $password : '', $dbname);
    } else {
        $registry->db = new DBPDOConnect($host . (empty($port) ? '' : ':' . $port), $username, isset($password) ? $password : '', $dbname);
    }
} catch (PDOException $ex) {
    echo $ex->getMessage();
}

$registry->checkGet();

if (empty($_SESSION['MANDANT'])) {
    $dbMandant = new DBMandant();
    $mandant = new Mandant();
    $mandant->decodeFromDb($dbMandant->getInfo());
    $mandant->logo = $dbMandant->getLogo();
    $_SESSION['MANDANT'] = serialize($mandant);
} else {
    $mandant = unserialize($_SESSION['MANDANT']);
}
$registry->mandant = $mandant;

if (CACHE == 0 && isset($_SESSION['CACHE'])) {
    unset($_SESSION['CACHE']);
}

$registry->translate_init = $TRANSLATE_INIT;
$registry->texte_init = $TEXTE_INIT;
if (defined('TRANSLATE_INIT') and TRANSLATE_INIT == 1) {
    translateInit(false);
}

$module = array();
foreach (Module::getAll() as $value) {
    $module[strtoupper($value['Modul'])] = $value;
}
$registry->module = $module;

$params = new Params();
$registry->params = $params;

$dateTimeformat = new DateTimeFormat();
$dateFormat = json_encode(array('date' => $dateTimeformat->getDateFormat(), 'time' => $dateTimeformat->getTimeFormat()));

$smarty = new Cx9Smarty();

if (is_dir(MODUL_PATH . 'templates/')) {
    $smarty->template_dir = MODUL_PATH . 'templates/';
    $template_url = SITEURL . 'templates/';
} else {
    $smarty->template_dir = APP_PATH . 'templates/';
    $template_url = str_replace(DIRECTORY_SEPARATOR, '/', APP_URL) . 'templates/';
}

define('TEMPLATE_URL', $template_url);
if (!defined('BINET_ALLOW_ONEWAY')) {
    $binet_allow_oneway = $params->getValue('BINET_ALLOW_ONEWAY');
    define('BINET_ALLOW_ONEWAY', $binet_allow_oneway);
}
$smarty->compile_id = md5(MODUL_PATH);
$smarty->compile_dir = APP_PATH . 'classes/Smarty/templates_c/';

$smarty->config_dir = APP_PATH . 'classes/Smarty/configs/';
$smarty->cache_dir = APP_PATH . 'classes/Smarty/cache/';

$smarty->assign('DATE_FORMAT', $dateFormat);
$smarty->assign('SID', session_id());
$smarty->assign('SITEURL', SITEURL);
$smarty->assign('FIRST_PAGE', FIRST_PAGE);
$smarty->assign('APP_URL', APP_URL);
$smarty->assign('TEMPLATE_URL', $template_url);

$smarty->assign('MODULE', $registry->module);

$smarty->assign('CONFIG_JS_SUBMIT', !is_null($params->getValue('CONFIG_JS_SUBMIT')) ? $params->getValue('CONFIG_JS_SUBMIT') : 0);
$smarty->assign('CONFIG_STEP2_NEW_WINDOW', defined('CONFIG_STEP2_NEW_WINDOW') ?CONFIG_STEP2_NEW_WINDOW : 0);
$smarty->assign('CONFIG_EVERYTIME_DEPARTURE', !is_null($params->getValue('CONFIG_EVERYTIME_DEPARTURE')) ? $params->getValue('CONFIG_EVERYTIME_DEPARTURE') : 0);
$smarty->assign('CONFIG_EVERYTIME_RETURN', !is_null($params->getValue('CONFIG_EVERYTIME_RETURN')) ? $params->getValue('CONFIG_EVERYTIME_RETURN') : 0);
$smarty->assign('CONFIG_SHOW_AVAILABILITY_PLAN', (defined('CONFIG_SHOW_AVAILABILITY_PLAN') && CONFIG_SHOW_AVAILABILITY_PLAN == 1) || (Module::isEnabled('ORM_AVAILABILITY_PLAN')));
$smarty->assign('BINET_ALLOW_ONEWAY', defined('BINET_ALLOW_ONEWAY') ?BINET_ALLOW_ONEWAY : 1);
$smarty->assign('CONFIG_SHOW_DRIVER_DATA', defined('CONFIG_SHOW_DRIVER_DATA') ?CONFIG_SHOW_DRIVER_DATA : 0);

$config = array(
    'VERSION' => defined('VERSION') ?VERSION : 0,
    'DEFAULT_LANG' => defined('DEFAULT_LANG') ?DEFAULT_LANG : 'DE',
    'BINET_ALLOW_ONEWAY' => defined('BINET_ALLOW_ONEWAY') ?BINET_ALLOW_ONEWAY : 1,
    'CONFIG_JS_SUBMIT' => defined('CONFIG_JS_SUBMIT') ?CONFIG_JS_SUBMIT : 0,
    'CONFIG_STEP2_NEW_WINDOW' => defined('CONFIG_STEP2_NEW_WINDOW') ?CONFIG_STEP2_NEW_WINDOW : 0,
    'CACHE' => defined('CACHE') ?CACHE : 0, 'FIRST_PAGE' => defined('FIRST_PAGE') ?FIRST_PAGE : '',
    'INET_STATUS' => defined('INET_STATUS') ?INET_STATUS : 0,
    'CONFIG_SHOW_AVAILABILITY_PLAN' => (defined('CONFIG_SHOW_AVAILABILITY_PLAN') && CONFIG_SHOW_AVAILABILITY_PLAN == 1) || (Module::isEnabled('ORM_AVAILABILITY_PLAN')),
    'TRANSLATE_INIT' => defined('TRANSLATE_INIT') ?TRANSLATE_INIT : 0,
    'AJAX_DEBUG' => defined('AJAX_DEBUG') ?AJAX_DEBUG : 0,
    'ORM_DEBUG' => defined('ORM_DEBUG') ?ORM_DEBUG : false,
    'CONFIG_CHECK_AVAILABILITY' => (defined('CONFIG_CHECK_AVAILABILITY') && CONFIG_CHECK_AVAILABILITY == 1) || (defined('CONFIG_SHOW_AVAILABILITY_PLAN') && CONFIG_SHOW_AVAILABILITY_PLAN == 1) || (Module::isEnabled('ORM_AVAILABILITY_PLAN')),
    'CONFIG_SHOW_DRIVER_DATA' => defined('CONFIG_SHOW_DRIVER_DATA') ?CONFIG_SHOW_DRIVER_DATA : 0,
    'EXTERN_STEP2' => defined('EXTERN_STEP2') ?EXTERN_STEP2 : '',
);

//$config = array_merge($config, $params->getAll());
$_SESSION['CACHE']['PARAMS'] = $config;

$smarty->assign('CONFIG', json_encode($config));

$dbText = new DBText();
$station = Station::hasStationCode(Session::getStartStation());
$group_availability = $dbText->getTextByStation($station->code, 'TEXT INET_GROUP_AVAILABILITY');
$text_no_price = $dbText->getTextByStation($station->code, 'INET_NO_GROUP_PRICE');
$group_availability = isset($group_availability->mem) ? $group_availability->mem : 'TEXT INET_GROUP_AVAILABILITY';
$text_no_price = isset($text_no_price->mem) ? $text_no_price->mem : 'TEXT INET_NO_GROUP_PRICE';

$smarty->assign('TEXT_GROUP_AVAILABILITY', $group_availability);
$smarty->assign('TEXT_NO_GROUP_PRICE', $text_no_price);

$Format = new Format();
$registry->format = $Format;
$smarty->assign('FORMAT', $Format);

$registry->template = $smarty;

$registry->lang = Session::getLang();

$router = new Router();

$registry->router = $router;

$router->setPath(MODUL_PATH . 'controllers', true);
if ($router->delegate() === false) {
    $router->setPath(APP_PATH . 'controllers');
    if ($router->delegate() === false) {
        error404();
    }
}
