var Libs =
{
		holidays: Array(),

		selYearOnChange: function()
		{
			$('#selYear').removeClass('summary_error_field');

			var firstMont 	= 1;
			var curYear 	= new Date().getYear();

			if(curYear <= 1000)
			{
				curYear += 1900;
			}

			if($("#selYear").val() == curYear)
			{
				firstMont = new Date().getMonth() + 1;
			}

			$("#selMonth").empty();
			$('#selMonth').append( $('<option value="-1"></option>'));

			for(i = firstMont; i <= 12; i++)
			{
				if(i < 10) i = '0' + i;
				$('#selMonth').append( $('<option value="' + i + '">' + i + '</option>'));
			}

		},

		getWeekDay: function(date)
		{
			//var day = (new Date(date.substr(6, 4)+'-'+date.substr(3, 2)+'-'+date.substr(0, 2))).getDay();
			var day = (new Date(date.substr(6, 4)+'/'+date.substr(3, 2)+'/'+date.substr(0, 2))).getDay();


			day--;

			if(day == -1)
			{
				day = 6;
			}

			return day;

		},

		parseURL: function () {
			var strQuery	= window.location.search;
		    var strSearch   = strQuery.substr(1),
		        strPattern  = /([^=]+)=([^&]+)&?/ig,
		        arrMatch    = strPattern.exec(strSearch),
		        objRes      = {};
		    while (arrMatch != null) {
		        objRes[arrMatch[1]] = arrMatch[2];
		        arrMatch = strPattern.exec(strSearch);
		    }
		    return objRes;
		},

		getHolidays_bak: function(region)
		{
			region = $.trim(region);
			if( region === '' )
			{
				return new Array();
			}
			if( Libs.holidays[region] === undefined )
			{
				$.ajax({
					type: "GET",
					url: CX9SITEURL + "libs/getholidays/"+region,
					data: "PHPSESSID="+SID,
					dataType: "json",
					async: false,
					error: function ()
					{
                        console.log('Libs:getHoliday Ajax Error');
					},
					success:  function(data)
					{
						Libs.holidays[region] = data;
					}
				});
			}
			return Libs.holidays[region];
		},

		getHolidays: function(region)
		{
			region = $.trim(region);
			if( region === '' )
			{
				return new Array();
			}
            if(typeof(CX9VARS.holidays[region]) == 'undefined') {
                return CX9VARS.holidays[region];
            } else {
                return new Array();
            }

		},

		validateEmail: function(email)
		{
			var RegExpr = /^(([^<>()[\]\\.,;:\s@\"]+(\.[^<>()[\]\\.,;:\s@\"]+)*)|(\".+\"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
			return RegExpr.test(email);
		},

        germanDateFromFormat: function(format, date)
        {
            var delimiter = '.';
            var delimiter_array = ['/', '.', '-'];
            for(i = 0; i < delimiter_array.length; i++)
            {
                if(date.indexOf(delimiter_array[i]) > 0 )
                {
                    delimiter = delimiter_array[i];
                    break;
                }
            }
            var array_format = this.explode(delimiter, format);
            var array_date = this.explode(delimiter, date);

            return array_date[this.array_find(array_format, 'd')] + '.' +
                    array_date[this.array_find(array_format, 'm')] + '.' +
                    array_date[this.array_find(array_format, 'Y')];

        },

        germanDateToFormat: function(format, date)
        {
            var delimiter = '.';
            var delimiter_array = ['/', '.', '-'];
            for(i = 0; i < delimiter_array.length; i++)
            {
                if(format.indexOf(delimiter_array[i]) > 0 )
                {
                    delimiter = delimiter_array[i];
                    break;
                }
            }
            var array_format = this.explode(delimiter, format);
            var array_date = this.explode('.', date);

            var return_array = new Array();
            return_array[this.array_find(array_format, 'd')] = array_date[0];
            return_array[this.array_find(array_format, 'm')] = array_date[1];
            return_array[this.array_find(array_format, 'Y')] = array_date[2];

            var return_str = '';
            for(i = 0; i < return_array.length; i++)
            {
                return_str += (i > 0 ? delimiter : '') + return_array[i];
            }
            return return_str;

        }, //germanDateToFormat()

        getTimestamp: function(date)
        {
          var tmp = this.germanDateFromFormat(DATE_FORMAT.date, date);
          tmp = this.explode('.', tmp);
          tmp = tmp[2] + '-' + tmp[1] + '-' + tmp[0];
          tmp = new Date(tmp).getTime();
          return tmp;
        },

        dateFromTimestamp: function(timestamp)
        {
            var date    = new Date(timestamp);
            var day     = date.getDate() >= 10 ? date.getDate() : '0' + date.getDate();
            var month   = date.getMonth()+1 >= 10 ? date.getMonth()+1 : '0' + (date.getMonth()+1);
            var year    = date.getFullYear();
            var tmp =   day + '.' + month + '.' + year;
            return this.germanDateToFormat(DATE_FORMAT.date, tmp);

        },

        time12to24: function (time)
        {
            var am = time.toLowerCase().indexOf('am') > 0;
            var time_array = Libs.explode(':', time.substr(0,5));
            var new_time = '';

            if(parseInt(time_array[0]) > 12 || parseInt(time_array[1]) > 59) return undefined;

            if(am) // am
            {
                if( time_array[0] == '12' )
                {
                    new_time = '00:' + time_array[1];
                }
                else
                {
                    new_time = time.substr(0,5);
                }
            }
            else // pm
            {
                if( time_array[0] == '12' )
                {
                    new_time = time.substr(0,5);
                }
                else
                {
                    var int_time = parseInt(time_array[0]) + 12;
                    new_time = int_time > 9 ? int_time : '0' + int_time;
                    new_time += ':' + time_array[1];
                }
            }

            return new_time;

        }, // time12to24()

        time24to12: function (time)
        {
            var time_array = Libs.explode(':', time);

            if(parseInt(time_array[0]) > 23 || parseInt(time_array[1]) > 59) return undefined;

            if(parseInt(time_array[0]) == 0)
                return '12' + ':' + time_array[1] + ' am';
            else if(parseInt(time_array[0]) < 12 )
                return time_array[0] + ':' + time_array[1] + ' am';
            else if(parseInt(time_array[0]) == 12 )
                return '12:' + time_array[1] + ' pm';
            else
            {
                var time_int = parseInt(time_array[0]) - 12;
                return (time_int > 9 ? time_int : '0' + time_int) + ':' + time_array[1] + ' pm';
            }




        }, // time24to12()

        explode: function ( delimiter, string ) {	// Split a string by string

            var emptyArray = { 0: '' };

            if ( arguments.length != 2
                || typeof arguments[0] == 'undefined'
                || typeof arguments[1] == 'undefined' )
            {
                return null;
            }

            if ( delimiter === ''
                || delimiter === false
                || delimiter === null )
            {
                return false;
            }

            if ( typeof delimiter == 'function'
                || typeof delimiter == 'object'
                || typeof string == 'function'
                || typeof string == 'object' )
            {
                return emptyArray;
            }

            if ( delimiter === true ) {
                delimiter = '1';
            }

            return string.toString().split ( delimiter.toString() );
        }, //explode()

        array_find: function (array, value) {

          for(var i=0; i<array.length; i++) {
            if (array[i] == value) return i;
          }

          return -1;
        },

        timeToTimestamp: function(time)
        {
            if(DATE_FORMAT.time != 'H:i') {
                time = Libs.time12to24(time);
            }
            time = Libs.explode(':', time);
            var d = new Date(1970,0,1, parseInt(time[0]), parseInt(time[1]));
            return d.getTime();
        }


};